VERSION 4 - DECEMBER 18 2019
----------------------------

A very minor release which should fix the problem of duplicate Echomail
areas being added. The version number has not changed.



VERSION 4 - NOVEMBER 15 2019
----------------------------

- Moving on to version 4... for Roger.

- Tossing performance should be a bit faster now, due to less disk-writes
  and new cache code written from scratch that stores the most frequently-
  tossed Echomail areas in memory. On modern computers you may not notice
  the change, but on any legacy/old systems you should see an improvement,
  especially when running on a "real" MS-DOS computer.

- Two new semaphores: DBNOTOSS.X and DBNOECHO.X, with X being the line
  number, ie. DBNOTOSS.1 for line 1 (or for single-line usage). Each
  will tell D'Bridge not to activate tossing or Echomail scanning; basically
  disabling the mail-tosser until the semaphore is erased; assuming in
  some sort of batch file for your system.

  On most systems, you would use DBNOTOSS.1 or DBNOECHO.1 as the filenames.

  Note that pending Echomail forwarding/scanning and any Xmail "Compress"
  operations will finish first before the mail tosser is disabled by the
  semaphore.

- A reminder, that if the above is not quite what you want, the semaphore
  DBRIDGE.PTM (Processing/Tossing Mail) is created whenever D'Bridge is
  busy tossing mail. The semaphore is erased when finished. Your own batch
  files or scripts could check for this although you will want to use
  some sort of "sleep" command or timeout between checking, ie:

                 :AreWeTossingMail
                 if exist dbridge.ptm timeout 60
                 if exist dbridge.ptm goto AreWeTossingMail

  In this example, the batch file waits 60 seconds between checks (on
  most Windows computers)

- Rewrote some of the file I/O handler routines.

- Slight rewording in the Queue/View command.

- Slightly changed the command-line parameters to allow a specific line
  to be specified while starting the Terminal.

- Slight adjustments to memory and buffer allocation for MS-DOS computers.

- A minor fix when debugging processed mail packets.

- Slightly updated help screens.

- A fix for long messages in the internal editor in VGA mode.



VERSION 3.99/SR45 - JUNE 27 2019
--------------------------------

Very minor bug fixes.

- If you wish to have messages rejected due to Circular Path Detection
  (CPD) written to the log file, create the dummy/semaphore file called
  DBRIDGE.RCP (Report Circular Path)

- Added CPD ON/OFF to DBUTIL CHANGE.



VERSION 3.99/SR44 - JUNE 16 2019
--------------------------------

A very minor release, but an important one. This release has a new option
in CONFIG-PACKET/MAIL, called "Keep copies of all mail".

If you wish to have D'Bridge keep a copy of all "raw" mail packets (*.PKT
files) received, specify for the maximum number of days here. For example,
7 means keep one week's worth of mail packets. Even as D'Bridge processes
mail, it will still keep the copies.

The INBOUND directory will have a subdirectory created, called COPIES.
Inside will be ZIP-formatted files arranged by date, each containing the
mail received, along with a text-file called yyyymmdd.LOG. This file
will list the date/time, the system received from, and the packet filename.
Copies older than the date specified will be erased.

WARNING: This is an advanced feature. Do not enable unless you have a
         need to keep all mail files for troubleshooting purposes.

By default, packets are "stored" uncompressed inside the ZIP files for
performance reasons. If you wish for the ZIP files to be compressed,
create a semaphore/dummy file called DBRIDGE.CCM (Compress Copied Mail).



VERSION 3.99/SR43 - JUNE 14 2019
--------------------------------

A very minor release:

- A slight improvement to the Echomail History Log

- Echodirs.log will not exist if no Echomail was unpacked to a *.MSG
  directory.

- A new option, LOG PACKET NAMES, in CONFIG-BASIC, will now update the
  system log with the packet filenames you specify:

           NONE - Do not log packet names.

        INBOUND - Log packet filenames received during the Unpack cycle.

       OUTBOUND - Log packet filenames created during the Echoscan cycle.

           BOTH - Log both types of packet filenames.

  WARNING: Do NOT enable this option unless absolutely necessary. On busy
           Hub systems, this may create logs of significant size.

- The SR is now displayed.

- Minor fix for some help screens.

- Minor fix in how the printed documentation is formatted.

- Very minor code cleanup.



VERSION 3.99/SR42 - APRIL 20 2019
---------------------------------

- At this time it is not possible to increase the size of the buffer in
  the internal message editor beyond 16k; without a lot of code-rewrite. I
  will address this in a future update.

- The HOME and END keys now work correctly in Config-Echomail Areas, TIC/
  Fileecho and the Actions menu in the "Scan" function.

- XMAIL/Arcmail bundles that cannot be decompressed will now have their
  filenames logged to a file called DBRIDGE.XDF (Xmail Decompression
  Failure). You can use this file with scripts or other programs to
  further troubleshoot or decompress the files in question.

- Very small cosmetic bug fix in the mailer when ran in 43/50 VGA mode.

- A fix for DBUTIL DESCFILE not matching areas.

- The F1-Help screen and manual have been slightly updated.


VERSION 3.99/SR41 - JANUARY 13 2019
-----------------------------------

Bug fixes.

- Pressing RIGHT ARROW in the VIEW QUEUE screen will "expand" the entry.

- Null messages were not being deleted in SR40 even though the setting
  was enabled in Config-PACKET/MAIL. SR39 and prior had no issues.

- Messages tagged as "Junk" during tossing/filtering, can now either be
  saved to BADECHO or deleted in CONFIG-PACKET/MAIL.

- A fix for Junk/filtered messages with the Isolated status enabled.

- If DBUTIL is running in another process or window on your operating
  system, it creates the dummy/semaphore file DBUTIL.BSY to tell D'Bridge
  not to update or scan the Queue... this was a potential for "problems".

- Two new options have been added to the Config-ZMODEM screen to reset
  default settings as well as "minimums" used for troubleshooting modem
  file-transfer problems.

  WARNING: The values in the Zmodem screen should not be changed unless
           there is a really good specific reason to do so. Technical
           support will NOT be provided if you are using custom settings.

  In that screen, you may now press F9 for minimums or F10 for defaults.

- Minor code cleanup.


VERSION 3.99/SR40 - DECEMBER 6 2018
-----------------------------------

NOTE: The structure of the Echomail database file DBRIDGE.ADF has changed.
      If you are a developer or advanced user, refer to TECHSPEC.TXT.

This minor release adds two new options; Circular Path Detection (CPD)
and bad AREA kludge checking. It also upgrades the Windows version of BinkD
to 1.1a/99.

In CONFIG-ECHO AREAS, there is now a new question if you wish to have CPD
functionality enabled for the Echomail area. This is an advanced feature
that will likely only be used by mail-Hub systems.

If you answer YES to this question, during the Unpack/Toss cycle, D'Bridge
will examine every message received in this area for duplication in the
PATH kludge-line. The PATH (and SEEN-BY) kludges are very important when it
comes to Echomail. Without them, it would be difficult to trace or
troubleshoot problems when a message "echoes" its way across the network.

The PATH kludge is simular in concept to the VIA kludge for Netmail; in
that as a message "travels" through the network, the system(s) that process
the message add themselves to the PATH. The PATH kludge is "two dimensional"
meaning that only the NET and NODE of the address is added. When a system
adds itself; the NET portion changes only if necessary. Duplication occurs
when either a Sysop or software strips the SEEN-BY's or manipulates the
PATH in a way that a system is added twice.

NOTE: It is impossible for a properly configured D'Bridge system to ever be
      the cause of a circular PATH; no matter the version or edition.

An Echomail message received with a circular path will be tossed to the
BADECHO area for your inspection. Note that only the applicable address is
checked during CPD; not all of your addresses. For example, if you have an
alias-address defined for the area, then CPD will only check based on that
address. If no alias address is defined, then the CPD applies to your
primary address. CPD cannot be used for Point-addresses.

By default, CPD is disabled. Do not enable CPD unless you are specifically
receiving duplicate messages in the area that are not being caught by
the built-in duplicate message checking.

The "Bad AREA kludge" option in CONFIG-PACKET/MAIL CONTROL forces D'Bridge
to examine every received message for the correct "placement" of the AREA
kludge. The AREA kludge defines a message as Echomail. Sometimes, for
whatever the reasons, a "grunged" message will have this in other places.
When D'Bridge encounters a grunged message, it will be moved to the
BADECHO area for your inspeection. Answer YES for this checking or NO if
not. The default setting is NO.



VERSION 3.99/SR39 - NOVEMBER 17 2018
------------------------------------

Very minor release... just bugfixes.

- The installation for newcomers has been significantly rewritten from
  scratch; I was never really happy with it... until now. Now, it is five
  simple screens that newcomers fill out and most of the default-settings
  in the mailer are preconfigured correctly.

- The F1 Help System and manual (and the web-manual) have been slightly
  updated.

- Minor fix for a weird bug in the Ansi terminal.

- The dialup modem code was slightly cleaned up.

- Usenet utilities have been moved to SOUPGATE.ZIP.

If there are no show-stopper issues at this point, I would like to focus
work on the next release that, lets just say, I keep getting "bugged" about.


VERSION 3.99/SR38 - OCTOBER 31 2018 - HALLOWEEN EDITION
-------------------------------------------------------

                         /}
                  _,---~-LJ,-~-._
               ,-^  '   '   '    ^:,
              :   .    '      '     :
             :     /| .   /\   '     :
            :   . //|    // \   '     :
            :     `~` /| `^~`    '     ;
            :  '     //|         '    :
            :   \-_  `~`    ,    '    :
            ;  . \.\_,--,_;^/   ,    :
             :    ^-_!^!__/^   ,    :
              :,  ,  .        ,    :
                ^--_____     .   ;`z
                        `^''----`

A totally frightening, scary, disturbing creation... containing plenty
of horrifying details:

- SR37 was an internal release... long, banal, uninteresting story, not
  even worthy of a beer. Not even a light beer.

- Whats really scary? Almost all of today's pop music is crap. And yes,
  there was a recent scientific study conducted to prove this as fact; so
  don't bother flaming me with "its a generation thing" nonsense.

- The internal message editor has been significantly updated for 43/50
  screen mode and will automatically enlarge reading and writing messages.

  In DOS, either type MODE 80,43 or MODE 80,50; or on Windows, change the
  properties for whatever D'Bridge shortcut you created so that the number
  of lines is either 43 or 50.

- In 43/50 screen mode, all multiple-line entry windows/questions are now
  automatically enlarged in the mailer to really take advantage of the
  bigger screen size. It really makes a difference when working with large
  configurations, routing tables, BinkD sessions, etc.

- In 43/50 screen mode, the new question "8x8 Font Usage" in CONFIG-BASIC
  allows you to override this for the DOS session; some video cards may
  need this to be enabled. (Do NOT enable unless you really need to)

- The BinkD log is now user-definable... sorry for that!

- Slight updates to both the manual and the F1-Help screens

- A new dummy/semaphore file, DBRIDGE.HVA (Hide Violated Areafix) can be
  created. If this file exists, and an Areafix request comes in for an
  Echomail/EchoFile area that is not authorized, the returned receipt
  will say the area does not exist, instead of "Not authorized".

  This was done simply for those of you who prefer to hide unauthorized-
  areas instead of revealing to remote systems that they do in fact exist.

- Fixed a very rare problem of not being able to select BADECHO from the
  internal message editor.

- Jamie Lee Curtis will always and forever be the scream-queen.

- Fixed the F1-Help "bottom" text to match all questions now

- Address Synonym definitions can no longer conflict with Flag Overrides
  in the CONFIG-NODELIST screen.

- "Destinations" in the F8/Multiple recipient command has been enlarged
  in the internal message editor.

- Flag-Dialing in Config-COMM MODEM SETUP was slightly reworked/adjusted.

- Under a very rare condition, changing the settings in CONFIG-BBS
  CONFIGURATION would cause a system crash on a carrier-signal detection.

- Pretty sure I fixed the "NTVDM encountered an error" condition for good.

Trick or treat...

Mary Shelley


VERSION 3.99/SR37 - SEPTEMBER 2 2018
------------------------------------

Note: Going forward, D'Bridge releases will carry the filenames DB3SR36S.ZIP
      for Standard Edition and DB3SR36G.ZIP for GoldBase.

This very minor release adds two new settings, "Junk-Filter" and "Isolate"
to CONFIG-ECHOMAIL AREAS. Any Echomail area that has this enabled will be
subject to checking the following text files for a keyword match:

DBRIDGE.JMF  - The message FROM field will be scanned against this file.
DBRIDGE.JMT  - The message TO field will be scanned.
DBRIDGE.JMS  - The message SUBJECT field will be scanned.
DBRIDGE.JMB  - The message body will be scanned.
DBRIDGE.JME  - New Echomail areas matching this file will have Junk enabled.

When a junk message is encountered, the setting "Isolate" determines if
D'Bridge will isolate that message and refuse to toss/forward it to any
systems defined in the FORWARD-TO field.

WARNING: Use both settings with caution. Isolating/filtering messages to
         downlinks will likely upset people...

In addition, DBUTIL CHANGE has been updated to be able to set the Junk
and Isolate status as well as Suspend, Permanent and Forced introduced in
prior releases.

- The format of DBRIDGE.ADF has changed and TECHSPEC.TXT has been updated.

- The documentation and F1 Help system have both been updated.



VERSION 3.99/SR36 - AUGUST 4 2018
---------------------------------

This release improves and fixes printing in D'Bridge along with some other
minor things. The Printer PORT and the Printer Control File (PCF) settings
have been moved out of the COMM screen and into Config-Basic. After
installing this upgrade, verify your printer settings in Config-Basic.

On Windows, printing from the D'Bridge internal Editor may only function
correctly if you use LPT1, LPT2 or LPT3 as the port name; and the printer
must have the chosen port name specified in the printer properties. You
should verify that this is set correctly in the Windows Device Manager or
using the NET SHARE command. If the printer port is not assigned or is
incorrect, printing may not function correctly or cause D'Bridge to hang.

Also:

- An option was added to Config-Basic to disable animations. The default
  setting is left enabled for both upgrades and new installations.

- An option was added back to Config-Basic to manually control timeslicing.
  Please do NOT change this option unless you really need to do so.

- The F1 Help screen and manual have been updated.


VERSION 3.99/SR34 JULY 21 2018
------------------------------

WARNING: If you are upgrading, please take a full backup of your existing
         system prior to installing this version.

This is a minor release... Bug fixes only.

- If D'Bridge is ran in a multi-line setup, a serious problem could occur
  with the system Queue leading to possible data corruption.

- A problem with the DBRIDGE.PTM semaphore should be fixed now.

- Problems with Archive/Sent-flagged NETmail should be fixed now.

- A very slight adjustment for PRESERVE in the Echomail Area editor.

- The problem with Local/Private Echomail areas corrupted during upgrades
  should be fixed now.

- The file DBRIDGE.LNR (Last NETmail Received) is created when a NETmail
  arrives addressed to you. It is just one line of text, for example
  "From John Doe to Nick Andre".

- Echomail scans using ECHOMAIL.CTL should be lightning-fast now.

- Reworded some of the help system to avoid confusing newcomers.

- It is rare that I would remove a feature, but, "Unpacked semaphore" is
  no longer an option in CONFIG-PACKET/MAIL. This is because there is no
  logical reason to have it, when DBRIDGE.NMW is created when NETmail is
  processed or DBRIDGE.EMW for Echomail.

- Various internal code cleaned up.

- At the last minute, I added ten new commands to DBUTIL. These work
  exactly the same as DBUTIL AREAFIX/FILEFIX... except now:

  DBUTIL AREAFIXLIST - Also sends an area list.
  DBUTIL AREAFIXOVERRIDE - Overrides any security defined for the system.
  DBUTIL AREAFIXLISTOVERRIDE - Same as the above two commands.
  DBUTIL AREAFIXRESCAN - Systems newly added to an area get a rescan.
  DBUTIL AREAFIXRESCANLIST - Same as above but also send an area list.
  DBUTIL AREAFIXRESCANOVERRIDE - New areas rescan and override security.
  DBUTIL AREAFIXRESCANLISTOVERRIDE - New/Rescan, list and override.
  DBUTIL FILEFIXLIST - Also sends an area list.
  DBUTIL FILEFIXOVERRIDE - Overrides any security defined for the system.
  DBUTIL FILEFIXLISTOVERRIDE - Same as the above two commands.

- Minor updates to the documentation and F1-Help system.



VERSION 3.99 SR33 JUNE 29 2018
------------------------------

There are a few show-stoppers fixed in this minor update:

- A serious problem with exported-configuration not importing is fixed.

- It was not possible to have a combination of a BinkD port other than
  24554 and the "U" option for Uncompressed Mail... until now.

- By default, D'Bridge puts your primary address in outgoing Netmail packet
  files. Now there is a new option to control this behavior, if alias-
  addresses should be used. Do NOT enable this unless there is a need to.

- Various internal code cleaned up which I suspect may have impacted
  reliability if the mailer is left unattended for long periods of time.


VERSION 3.99 FINAL (SR32) JUNE 5 2018
-------------------------------------

This should be the last round of fixes for 3.99... for a couple of reasons.
Unless there are serious "show stopper" bugs, any more D'Bridge work will
now focus on version 4.

- Certain scenarios were resulting in TIC passwords being rejected.

- On a bad TIC password, the file referenced is no longer moved to the BAD
  TICS directory; to prevent possible problems later.

- I know I said before that I would not add any new stuff to D'Bridge at
  this point, but the Echomail and Echofile/TIC area editors now have two
  new questions. These are for you to have more "fine tuning" over each
  area, as I saw these in another tosser and think it is a good idea to
  have them here:

     PERMANENT - Makes this area exempt from Passthru purging or removal
                 using DBUTIL REMOVEDEADECHOS.

        FORCED - A system cannot unsubscribe/un-Areafix themselves from
                 the area. The only way to unsubscribe is by manually
                 editing the areas database or by pressing ALT+N.

- The SUSPEND option has also been added for Echofile/TIC file processing.

- Both the DBRIDGE.ADF and DBRIDGE.TDF database files have different
  structures. Please refer to the updated TECHSPEC.TXT file for details.

- Very minor cosmetic fixes.

- Yet another few fixes for the help system.

- The manual has been revised slightly for newcomers.


VERSION 3.99 SERVICE RELEASE 31 - MAY 29 2018
---------------------------------------------

A very minor release:

- "Additional Databases" in CONFIG-DIRECTORY PATHS is now "Unsecured
  Mail". When mail and files are received in either dialup modem sessions
  or Internet BinkD with no session password, D'Bridge has the ability
  to save those in a seperate directory... most commonly known
  as the UNSECURED directory.

  Before anyone proclaims the sky-is-falling or snickers at this, it
  should be noted that D'Bridge has always had the ability to seperate
  secure inbounds from unsecure inbounds; through an environment
  variable.

  If UNSECURED MAIL is left blank, then D'Bridge will store received
  mail and files from an unsecured session into the default inbound
  directory; the behavior from all prior versions.

  WARNING: For security or "best practice" concerns, D'Bridge will NOT
           process any mail or files that are received in the Unsecured
           Mail directory.

  The setting applies for both dialup modems and BinkD Internet sessions.

- Two new files, AREAS.JFD (Just Fido *.MSG Directories) and AREAS.JTF
  (Just Tags and Fido *.MSG Directories) are created in addition to
  the other "AREAS" files in CONFIG-ECHO AREAS-XPORT.

- ECHOMAIL.CTL can now contain either Echomail conference tags or Fido
  *.MSG directories. When D'Bridge scans for outbound mail, it checks
  to see if this file exists and if so, will only process whats in there.

- Some other stuff cleaned up in the F1-Help system, the manual, and
  the technician's manual TECHSPEC.TXT.

- A memory allocation problem may prevent an upgrade to prior versions.
  A warning message will be shown, detailing the steps needed to continue
  the upgrade.



VERSION 3.99 - SERVICE RELEASE 30 - MAY 21 2018
-----------------------------------------------

Bugfix for the main menu-bar only... sorry.




VERSION 3.99 - SERVICE RELEASE 29 - MAY 20 2018
-----------------------------------------------

Bugfixes only.

WARNING: If you are upgrading, please take a FULL BACKUP of your existing
         installation before installing this update.

- The internal message editor should no longer crash on exit.

- Problems with some random number jibberish added to the description
  of Echomail areas marked as Local between EXPORT's and IMPORT's should
  be fixed, but if the descriptions in the areas have that problem, they
  will need to be corrected manually in CONFIG-ECHO AREAS.

- This release further solidifies and consolidates TIC file processing,
  and is entirely managed in the CONFIG-PACKET/MAIL control screen,
  instead of having somewhat confusing or convoluted questions.

- The description for "Packet passwords" has been changed to Packet/TIC
  Password Override in CONFIG-PACKET/MAIL. This is because by default,
  D'Bridge will first check the "Session passwords" in ADVANCED-MISC/
  SECURITY. If if it finds a session password defined there, it assumes
  this also applies as the password for packets and TIC files.

  The behavior now, is that if the system is defined in PACKET/TIC
  OVERRIDE with a password, the packet or TIC file password will be
  changed to what has been defined.

  If a system has been listed in the OVERRIDE but there is no password,
  then it implies that the TIC file has no password; yet packet security
  still applies.

- Memory usage has been slightly reduced and the code has been cleaned up
  in several places.

- Problems with low "WorkRAM" should be fixed.

- A bug with a possible file handle left open after an Areafix/Filefix
  transaction completes during a toss cycle has been fixed.

- A bug affecting long term stability/reliability with a fair amount of
  TIC files and "Actions" taken on them should be fixed now.

- A bug with TIC request forwarding has been fixed.

- A "confusing" bug in CONFIG-BASIC - ALIAS ADDRESSES should be fixed.

- A problem with In-transit Areafix routing has been fixed.

- For security reasons, D'Bridge will now only auto-add areas from systems
  you specify only. It will no longer support the option to add areas from
  just anyone.

- Once again the F1-Help system and manual have been revised and updated.



VERSION 3.99 - SERVICE RELEASE 28 - MAY 14 2018
-----------------------------------------------

A bugfix for the F1-help system and TIC "blind Hub" forwarding only.



VERSION 3.99 - SERVICE RELEASE 27 - MAY 12 2018
-----------------------------------------------

A very minor update, bugfixes.

- A problem with some of the setup screens have been resolved.

- A problem with Echofile/TIC passwords and Config-Fileecho has been fixed.

- A warning is written to the log when Passthru files arrive in Echofile/
  TIC areas with no downlinks.

- Passthru TIC area removal on a no-links-left condition now follows the
  setting for "timeout days" in CONFIG-PACKET/MAIL.

- BADTICS.LOG is no longer possibly left in a "permanently open" state.

- Slight rewording of some sections of both the F1 on-line help system and
  the manual to avoid confusion for newcomers.



VERSION 3.99 - SERVICE RELEASE 26 - MAY 6 2018
----------------------------------------------

This is a very minor release that fixes the following:

- Reduced CPU usage on Windows; you should see slightly improved results
  when creating a shortcut (PIF) and moving the "Idle sensitivity" slider
  to just under the High setting. Put the slider back to the middle if you
  are experiencing any problems with dialup modem sessions.

- The nodelist is no longer "always" compiling on startup; instead the
  mailer now follows specifically the settings in CONFIG-NODELIST.

- Some minor cosmetic fixes in all of the CONFIG screens.

- Some minor updates to TECHSPEC.TXT.

- Removed some of the obnoxiousness out of the help system and the
  documentation.

- Further reduced the size of the code overall.

- D'Bridge should now run in 512k of RAM instead of requiring 640k.

- At this time, D'Bridge appears to be incompatible with Quarterdeck's QEMM
  memory manager running in the "stealth" mode and then running D'Bridge
  on Desqview.




VERSION 3.99 - SERVICE RELEASE 25 - MAY 1 2018
----------------------------------------------

This is a very minor update, but is important for those of you who are
using D'Bridge with somewhat-elaborate batch files, scripts or running the
mailer in modes such as UNPACK or using the *X variables.

When D'Bridge is ran on an operating system that you have set to execute
tasks in the background, and lets say a task needs to shutdown D'Bridge
for some reason, you should ALWAYS create the shutdown semaphore and then
check to see that it is in fact, shutdown, by checking that no DBLINE
semaphores exist.

For example, this DOS batch file will tell D'Bridge to shutdown, and not
proceed further until it has in fact, shutdown cleanly. When D'Bridge
shuts down, it will exit with Errorlevel 200 and also delete the DBLINE
semaphore. Note the use of the SLEEP command. SLEEP is just a command-line
utility to wait X amount of seconds.

      CD \DB
      ECHO > DBEXIT.200
      :CHECKER
      IF EXIST DBLINE.* SLEEP 3
      IF EXIST DBLINE.* GOTO CHECKER

- A new dummy/semaphore file, DBRIDGE.AQD, if created, will always tell
  D'Bridge to engage in QuickDial mode; overriding the timing-specific
  settings of the current Mail event. When the Queue is either empty or
  no other entries can be "called", the mailer returns to IDLE status.

- Creating a DBEXIT semaphore now correctly deletes the DBLINE semaphore.

- Using the FUNCTION GATEWAY in EMSI/WaZOO sessions and using the "*X"
  parameter to exit is a bit more graceful now and deletes the DBLINE
  semaphore.

- The *X parameter deletes the DBLINE semaphore.

- TECHSPEC.TXT has been updated.




VERSION 3.99 - SERVICE RELEASE 24 - APRIL 16 2018
-------------------------------------------------

This very minor release fixes reported problems with D'Bridge running
specifically on MS-DOS, PC-DOS, Tandy 1000 and other "real DOS" computers.



VERSION 3.99 - SERVICE RELEASE 23 - APRIL 3 2018
------------------------------------------------

This is a very minor release which fixes a rare but noticable problem with
"Passthru" TIC files for many downlinks defined in an area.



VERSION 3.99 - SERVICE RELEASE 22 - MARCH 27 2018
-------------------------------------------------

This is a very minor release to resolve:

- A very minor change was made to the Queue code for the way NETmail
  destined for "Unpublished" BinkD systems were not immediately
  turning-around in a toss-forward cycle.

- Auto-polling in Config-Scheduler has been slightly revised/updated.



VERSION 3.99 - SERVICE RELEASE 21 - MARCH 1 2018
------------------------------------------------

This is a very minor release that should resolve "Error 203" in Areafix
processing in certain scenarios. No other changes were made at this time.



VERSION 3.99 - SERVICE RELEASE 20 - FEBRUARY 27 2018
----------------------------------------------------

NOTE: There was a security vulnerability fixed in SR19. If you are upgrading
      from SR18 or earlier, please review the HISTORY.TXT file and go
      over the notes for SR19 prior to installing this update.

This is a very minor release which cleans up some code behind-the-scenes
and removes the following problematic settings: Bounce NETmail to Unlisted,
Log voice calls (defaults to enabled), Xmail raw packet interval (same
as normal), Xmail debugging - obsolete and Gateway users (script this
in a batch file instead for BBS usage).

In addition:

- A problem with EMS memory not being used or initialized correctly when
  running on a "real" MS-DOS system should be fixed. Note that there is
  a few conditions which must be met in order for D'Bridge to use EMS
  memory on these systems; it doesn't just automatically use it because
  it exists.

- A possible "waiting for keyboard input" bug on tossing should be resolved.

- A new file, DBRIDGE.DRQ (Deny Request), can be created containing the
  area name, a space, and the system of which Areafix/Filefix messages
  can be denied to. The remote system will see an "Area unavailable"
  message if they are listed in this file and attempt to request the area
  and the area will NOT show up in any list-requests.

  For example:          SECRET_AREA     1:229/500

  Means that SECRET_AREA is not available to be requested by 229/500.

- A bug in the help system has been fixed.

- A bug in CONFIG-XMAIL should be fixed (regression)

- The TECHSPEC.TXT file has been slightly revised and updated.




VERSION 3.99 - SERVICE RELEASE 19 - FEBRUARY 8 2018
---------------------------------------------------

*** URGENT ***

Recently, a serious security vulnerability and fundimental design flaw in
D'Bridge was privately disclosed, affecting ALL versions; even going back
to the very first ones.

This update specifically fixes this design flaw and vulnerability. THIS IS
AN URGENT UPDATE - I strongly suggest backing up your system and
installing this update ASAP.

The exact detail of the problem will not be disclosed publically in order
to avoid unfair and unnecessary "sky is falling" discussions; almost always
started by non-D'Bridge people with no life outside of Fidonet.

AGAIN - THIS IS AN URGENT UPDATE FOR ALL D'BRIDGE SYSTEMS.

I WILL NOT PROVIDE TECHNICAL SUPPORT FOR UNPATCHED SYSTEMS.

PERIOD.

Thank you,

Nick Andre
www.net229.org



VERSION 3.99 SERVICE RELEASE 18 - DECEMBER 29 2017
--------------------------------------------------

A very minor release:

- The "size" TIC keyword on forwarded files should be fixed now.

- Leftover TIC files in some scenarios should be fixed now.

- Cosmetic problems scrolling through some areas.

- "Last accessed" is now correctly updated for Fileecho/TIC areas.

- Some code cleanup behind-the-scenes.



VERSION 3.99 SERVICE RELEASE 17 - DECEMBER 16 2017
--------------------------------------------------

This is a very minor release which adds three new commands to DBUTIL
and fixes bugs discovered whilest hubbing mail on my own system.

The three new commands added are DBUTIL AREAFIX, DBUTIL AREAFIXRESCAN
and DBUTIL FILEFIX.

These new commands allow you to "fake" such requests from the DOS
prompt as if that system was sending you a request normally via *.PKT files.
It was possible to do this in any version of D'Bridge but not exactly in
an easy way... or an easy way that can be scripted.

WARNING: The DBUTIL ADD, DROP and REMOVE commands are no longer supported
         as of this release. Please adjust any scripts or batch files
         accordingly if you were using those commands.

Being able to "fake" Areafix/Filefix requests is a feature found in other
mail-tossing software and I decided to include it here for convenience;
the DBUTIL functionality lets you write your own scripts or batch files
to automate this in however which way you see fit.

D'Bridge will process these requests the next time it has to toss mail;
note that due to the way D'Bridge tosses mail, only one Areafix or Filefix
request can be pending at a time, per system. That means that if you run
this command for a system and there is already an existing Areafix/Filefix
request waiting to be processed for that Sysop, this command will fail.

When no areas are specified, a notification of the currently subscribed
areas is generated.

Now AREAFIXRESCAN is exactly the same as AREAFIX, except that an Areafix
request to add an area is given the "rescan" flag. Your system must
specifically support the rescanning of messages - If you are manipulating
your messages via a BBS or 3rd-party software, it may not be possible to
process a rescan-request for systems with DBUTIL AREAFIXRESCAN.

Areafix/Filefix requests generated from DBUTIL will be given NORMAL
priority with NO "override" authority (as in, not the same as pressing
ALT+N from the mailer). This means, a request is "faked" along with
permissions. This was designed to specifically aid in troubleshooting or
testing Areafix/Filefix requests. Requests will follow the security levels
you specifically define in CONFIG - AREAS, CONFIG - PACKET/MAIL CONTROL
and CONFIG - FILEECHO SETUP.

Here are some examples (assuming my system address, 1:229/426)

C:\DB> DBUTIL AREAFIX 1:229/427

This will send a notification list from my system, 1:229/426, to a
downlink of mine, 1:229/427, containing all of the currently connected
Echomail areas.

C:\DB> DBUTIL FILEFIX 1:229/427

This will send a notification list from 1:229/426 to 1:229/427 of the
currently connected EchoFILE/TIC areas.

C:\DB> DBUTIL AREAFIX 1:229/427 DBRIDGE FN_SYSOP -STATS

Fakes an Areafix request from 1:229/427 to 1:229/426, requesting the
DBRIDGE and FN_SYSOP echoes, but dropping STATS.

C:\DB> DBUTIL AREAFIXRESCAN 1:229/427 -FIDONEWS CHAT

Fakes an Areafix request from 1:229/427 to 1:229/426, requesting the
CHAT echo with a message rescan, and dropping FIDONEWS.

FIXES
-----

- A bug in the upgrade process messing up Filefix TIC passwords was fixed.

- A bug affecting the system log purge at midnight should be fixed now.

- The tiny program SLEEP, used for delaying scripts/batch files, is no
  longer included with D'Bridge releases due to ongoing problems with
  false-positives with Clam anti-virus. The SLEEP program can be downloaded
  from http://www.net229.org/misc




VERSION 3.99 SERVICE RELEASE 16 - DECEMBER 3 2017
-------------------------------------------------

This very minor release changes the way MSGID is computed for the D'Bridge
Editor. Note that the MSGID kludge is only done for Echomail messages; the
kludge is not present in NETmail messages.

At the last minute, a serious bug with TIC file handling was caught and
resolved. Note that if a system is not defined in the Config-Fileecho/TIC
screen, and that system sends a TIC file, the TIC and related file is moved
to BADTICS for your inspection.

No other changes were made at this time.


VERSION 3.99 SERVICE RELEASE 15 - NOVEMBER 18 2017
--------------------------------------------------

This very minor release fixes a bug with "Uncompressed packets" under
certain conditions, a slight problem with Areafix RESCAN requests, improves
the F1 Help system slightly and a very minor bug in the DBUTIL PURGE code.



VERSION 3.99 - SERVICE RELEASE 14 - JULY 31 2017
------------------------------------------------

At this point, we're up to 14 patches for 3.99 and I think thats about
enough... this one was to add one feature to the CONFIG - ECHOMAIL AREAS
screen which could help big Hub systems. This allows you to temporarily
SUSPEND forwarding of Echomail to all links in the FORWARD-TO screen. A new
question, "Suspend", if answered yes, means that D'Bridge will only receive
mail on your system for that area, but NOT forward it elsewhere. The
default is NO, obviously.



VERSION 3.99 SERVICE RELEASE 13 - MAY 26 2017
---------------------------------------------

A very minor release, but one that "cleans up" a few things...

- Fixed a potential problem with Areafix Rescan not enforcing limits.

- Removed "Areafix requests per NETmail message" as I rewrote some things
  in the back-end as well as the NETmail tracker.

- Rewrote some of the Help screens of Config/Packet-Mail and XMAIL CONTROL.

- We really don't need to check for files that never get created.

- We really don't need to set X as 1 then check to see, if in fact, X is 1.

- New installations of D'Bridge do not automatically set the RATIO and COUNT
  questions in the XMAIL CONTROL screen... in fact they never have, despite
  what the help screen says. This is to avoid problems and yet another
  round of amusing assumptions from the non-D'Bridge crowd.

- Some cosmetic bug fixes.



VERSION 3.99 SERVICE RELEASE 12 - FEBRUARY 27 2017
--------------------------------------------------

This is a very minor release which updates BinkD to Mingw/1.1a-95 for
Windows and OS/2. This appears to resolve any network stack "binding"
problems and "WSA" error messages when setting D'Bridge to use a port
other than 24554.

WARNING: I will NOT provide technical support if I determine that you are
         replacing the BinkD included with D'Bridge with some other build,
         no matter what bizarre compelling reason to do so.

Note that for Windows, there was a choice between the MingW build
and the build done with Microsoft Visual C++ 2010 runtime. I chose to
include the former, as the other would involve installing MSVC2010 which
opens things up to a whole slew of possible "problems" with dependancy
conflicts. The design goal of D'Bridge has always been that it should
just work out of the box and not have to require a bunch of dependancies.

The MingW build installs PERL510.DLL in your D'Bridge directory. It may
be necessary to temporarily disable any anti-virus software or set an
"ignore" policy for this file; if you encounter any problems.

No other changes were made at this time.


VERSION 3.99 - SERVICE RELEASE 11 - JANUARY 15 2017
---------------------------------------------------

This very minor release addresses just a few things.

- DBUTIL SHOWDEADECHOES and REMOVEDEADECHOS were broken... not anymore.

- You may also optionally specify the GROUP ACCESS ID of areas to include
  when reporting/marking, ie. DBUTIL SHOWDEADECHOES 90 B means show areas
  with no traffic over 90 days belonging to group B only.

- And... if you add a letter after the GROUP ACCESS ID above, that means
  only areas that match the group access ID *and* the storage method will
  be reported/marked for deletion. ie. DBUTIL SHOWDEADECHOES 90 B F
  means show dead echoes 90 days, group B, Fido *.MSG storage only. (Use N
  for no-storage, meaning Passthru areas)

- The new DBUTIL command NUKEFROMFILE will delete the areas specified
  in the file. For example, DBUTIL NUKEFROMFILE DEADAREA.LOG will cause
  all of the areas in DEADAREA.LOG to be deleted.

- If the command %HELP is received in an AREAFIX request, basic help will
  be sent to the requesting system. If the text file DBRIDGE.AFH (Areafix
  HELP) exists; the contents of that will be sent instead. If the help
  request comes to FILEFIX, the contents of DBRIDGE.FFH is sent instead.

- A minor but somewhat important fix to Areafix and Filefix was done
  behind the scenes.

- An open file handle not closed properly in the tosser/outbound cycle
  for QuickBBS/Hudson was fixed.

- Very minor, completely trivial cosmetic fixes for the mailer.



VERSION 3.99 SERVICE RELEASE 10 - JUNE 11 2016
----------------------------------------------

WARNING: Please backup your entire D'Bridge system before installing SR10
         and be prepared to rollback to SR9 if this does not perform to
         your expectations. BinkDWIN must be completely shut down before
         installing SR10. If it is installed as a service, it must be
         completely stopped and removed from Windows before proceeding.

D'Bridge should now be 100% IPV6-capable and ready...

This very minor "hotfix" release brings the Windows version of BinkD to
the 1.1a-27 build-level with native IPV6 connectivity support... along
with some minor things I wrote over the past few months.

This version of BinkD should also resolve potential "timeout" problems on
Server 2008, Windows 7, Windows 8/8.1 and Windows 10 32-bit systems. A
very minor change was also done to the way D'Bridge controls the
configuration for BinkD.

NOTE: Refer to the revised README file to install D'Bridge on Windows 10.

NOTE: The structure of the Echomail database file DBRIDGE.ADF has been
      changed in this release. Refer to TECHSPEC.TXT.

- Random problems with "Error: Invalid parameter 'U', reverting back to
  previous configuration" and related weird nonsense from BinkD is fixed.

- An option has been added for saving the kludge-lines in archived
  messages, on a per-echo basis, in Editor - Echo areas. This question works
  in conjunction with DBUTIL PURGE. So now, you can have your choice of
  having some areas with the kludges archived, and some without... you
  get the idea.

- A minor fix for the rescan limit in Areafix requests.

- A minor fix for rescanning Areafix messages.

- A very minor fix for Areafix for Usenet gateways.

- Very minor corrections to Echofile/TIC processing.

- D'Bridge is a tiny bit more verbose when the mailer moves an extremely
  large mail bundle into BinkD staging.

- Two additional security checks are done as part of the mailer's much
  more comprehensive "baseline check" against mail-bombs, invalid packets
  and so on that was introduced from before.

- DBUTIL QNAME just reports the Queue name... Duhhhhhhhh.




VERSION 3.99 SERVICE RELEASE 9 - NOVEMBER 8 2015
------------------------------------------------

This is a minor but important upgrade, that fixes the following:

- "Passthru" TIC processing no longer erases the queued file being sent
  under certain conditions.

- Messages with the AREA kludge appearing where that kludge should not be
  appearing are sent to the BADECHO area for your inspection; and not
  forwarded elsewhere.

- A minor change was made to the CONFIG-XMAIL screen for newcomers.

- A minor change was done to the way D'Bridge archives system history.

- A very minor fix was done for when Echomail areas are auto-added.

- The MSGID kludge is only added for Echomail.

- You can now specify whatever additional kludge lines you want to in
  the Config - Editor Options screen. By default, no extra kludge lines
  are added.

- The internal message editor should no longer bork the INTL kludge under
  certain conditions.


VERSION 3.99 SERVICE RELEASE 8 - AUGUST 29 2015
-----------------------------------------------

This very minor release deals with systems that store a lot of *.MSG files.
In addition, "Enhanced echomail logging" is removed, since the tosser now
creates ECHODIRS.LOG on every toss operation for *.MSG areas.


VERSION 3.99 SERVICE RELEASE 7 - AUGUST 16 2015
-----------------------------------------------

Yet a very minor release...

- DBUTIL SORT TICS no longer crashes the system.

- Minor adjustments to DBUTIL PURGE operations.

- A problem with long domain names in the DATA directory and a poll
  request subsequently failing to reach such a system has been fixed.

- Slight correction made to the BINKD SESSIONS in the setup screen.

- Session Limits can now be overridden in the scheduler. A new question,
  "Enforce limits?" now appears for Mail events. Answer YES if the Mail
  event must follow the limits defined, or NO if "unlimited" calls,
  sessions etc. can happen.



VERSION 3.99 SERVICE RELEASE 6 - JULY 4 2015
--------------------------------------------

This is a very, very minor release to address some things...

- The mailer no longer crashes when attempting to view large Queue entries.

- A new question in CONFIG-PACKET/MAIL allows you to tell D'Bridge to keep
  NETmail messages after archiving them via the Archive/Sent flag. The
  default behavior is NO, meaning DO NOT keep NETmail messages after they
  have been archived.

- Another new question in CONFIG-PACKET/MAIL allows you to archive the
  kludge lines of messages during DBUTIL PURGE.

- The CHRS kludge is not added in an "endless loop" when editing an
  existing message in the internal editor.

- A slight adjustment was done to the QueueScan code for Fido *.MSG format.

- Minor updates to the help screens and the Readme file for newcomers.

- Minor corrections to DBUTIL PURGE and DBUTIL PURGERENUM as per Ben
  Ritchey.


VERSION 3.99 SERVICE RELEASE 5 - JUNE 21 2015
---------------------------------------------

WARNING: This release deals with the way NETmail messages are processed on
         your system. If you are a Hub system, you should first test this
         release in an isolated environment before deploying into your
         production system. Backup any NETmail messages currently on your
         system before installing this update. Be prepared to roll-back to
         SR4 just in case this release does not work for you.

This is a very minor update. Of course, what I consider to be minor may
in fact be a major fix for you...

- The long-standing problem of D'Bridge not being able to process more
  than a thousand NETmail messages in one toss cycle has been fixed. Gone
  for good are any any all problems relating to this... maybe some new ones?

  This has existed for many years. Actually its not so much a problem as it
  is in the way the mailer was designed to run on IBM XT's at 8 Mhz. Until
  now, the code that scanned the NETmail messages in *.MSG format used a
  disk-cache routine index of 1,024 messages. In this version, the cache
  has been removed entirely. If you are in fact running D'Bridge on a "real
  DOS" machine, it is recommended to use Microsoft SmartDrive or Norton's
  Speedcache product.

- "Route receipts" is now internally managed.

- Specifying a "Blind Request Hub" in Config-Packet/Mail first requires that
  the entry be first specified in AREAFIX INFO.

- There is a new question in Config-Packet/Mail for "Areafix by name".
  This was added to solve a problem with downlink systems running BBS's
  where NETmail that is not simply addressed to "SYSOP" does not get
  processed. Answer YES if you wish to have D'Bridge reply to Areafix
  requests using the Sysop's nodelisted name or NO if the replies should
  just be addressed to "SYSOP". The default setting is NO.

- Areafix Rescan requests now work the way they should.

  WARNING: Many Fidonet operators love to make an example out of someone
           who inadvertently floods the net with a bunch of Rescans
           or "dupes". Unless you crave negative attention, use due-
           diligence and common sense when administering your system.

           DO NOT, under ANY circumstances, use the Areafix Rescanning with
           ANY BBS software unless you have tested this first in a secluded
           environment. Some BBS programs may "import" the rescanned
           messages or manipulate them to send back up the network again...

- The logic in NETmail Archive/Sent handling in Config-Packet/Mail has been
  slightly adjusted and reworded.

- NETmail Archive/Sent in DBUTIL should all be fixed now.

- The internal editor should no longer mangle kludge lines when copying
  or forwarding messages under certain conditions.

- Various source code cleaned up behind-the-scenes.



VERSION 3.99 SERVICE RELEASE 4 - MAY 17 2015
--------------------------------------------

NOTE: This update should be treated as important, just like SR3, please
      review the HISTORY.TXT notes for SR3 if you have not done so already.

This is a very minor release which corrects file truncating in DBUTIL as
per Mark Hoffman. This problem affected SR2 and SR3. When a Queue operation
involved truncating a NETmail attachment, DBUTIL would crash with Error 203
thus leaving the Queue in the previous state (causing an endless loop)


VERSION 3.99 SERVICE RELEASE 3 - MAY 16 2015
--------------------------------------------

NOTE: Ignore any events that appear as Overdue when upgrading to this
      release. After ignoring them, the events will continue to function
      as scheduled.

This minor release of D'Bridge fixes a couple of things that some of
you may consider to be trivial, but along the way an important stability
and function update was done to BinkD. This should be treated as an
important upgrade for an existing D'Bridge system.

- Fixed an apparently long-standing fundimental design flaw in the way .FLO
  files are managed in the BinkD subsystem. This problem affects all
  versions of D'Bridge prior to this one when it comes to sending inter-
  zone mail (Same FTN domain but the zone changes)

  Before installing SR3, you may want to take the time to first ensure that
  the Queue is empty and all transactions have been sent out. Once complete,
  you may wish to shutdown BinkD and completely erase the subdirectories in
  DB\DATA. Restart the BinkD system so the directories are "rebuilt", then
  install SR3. This will ensure going forward that the subdirectories in
  DB\DATA are clean.

  WARNING: DO NOT erase any subdirectories if BinkD is running or there are
           pending transactions.

- Resetting the counters on a BinkD Queue entry already sent no longer sends
  the mailer into a bizarre tailspin.

- Numerous corrections to the code were done for Multi-line operation and
  several logic-handling scenarios were slightly improved.

- The Twit filter in the editor can now block based on a system address.

- The TOPT kludges in the internal editor should be no longer mangled.

- Uncompressed *.PKT files are now really uncompressed... duh.

- Quickdial is quicker now... (don't ask)

- Split-screen chat during D'Bridge-to-D'Bridge dialup mail sessions (IZE
  protocol) follows the times specified for "Audio alarms" in that you
  cannot be paged outside of the time specified.

- The F1-Help Screens have been slightly updated.

- Some of the D'Bridge setup screens have been slightly revised.

- The copyright text "banner" can be changed on incoming mail sessions
  on dialup modems under BBS configuration... just to satisfy the morbid
  strange fascinating desires of those of you who insist on having a
  "totally customized" experience for BBS callers.

  NOTE: It is not recommended to pass Ansi screen codes or anything outside
        of alphanumeric ASCII in the banner. Please use the "BBS Loading
        File" for this.

- The message archiving should be fixed (Roger)

- The EULA reflects changes to Canadian law dealing with installing
  computer software. You agree that I reserve the right to change the
  contents of outbound packets to replace the letters E and R with smiley's.


VERSION 3.99 SERVICE RELEASE 2 - JUNE 23 2014
---------------------------------------------

*** WARNING ***

A VERY SERIOUS problem with the BinkD system has been fixed. This problem
affects ALL releases of D'Bridge going back to at least 3.93, and affects
both security, stability and long-term reliability (leaving the mailer
unattended for long periods of time)

THIS IS A CRITICAL FIX for your D'Bridge system. Please BACK UP your DB
directory including DB\DATA and its contents, as well as Queue, Packets
and the NETmail directory. This release affects all of these components,
however Echomail processing, TIC, nodelists, etc. are NOT affected.

The nature of the problem fixed is not being discussed publically in order
to avoid certain individuals hijacking/trolling the support echo with their
own two-cents; without fully understanding why such a problem happens or
taking into account that I do this as a hobby.

Please PAY CAREFUL ATTENTION to your system log and DBBINKD.LOG after
this release has been installed. Be prepared to report any problems
immediately.

Only this issue has been fixed. No other changes were made.

Upon installation, your D'Bridge system will state that is version 3.99
however it will show a June release date. Newcomers installing this for the
first time will not be affected by this advisory.

Sigh...


VERSION 3.99 SERVICE RELEASE 1 - APRIL 3 2014
---------------------------------------------

This is a VERY minor release. The same release notes from February apply,
please refer to the top of HISTORY.TXT if necessary. Version 4 is still a
ways-off, but I felt this was necessary to "tide you over":

- Fixed a bug whereas your BinkD configuration would regress to only "one"
  inbound connection, among other somewhat glaring mistakes.

- Adjusted the setup screens and F1-Help system in a few places.

- Pretty sure I figured out the "12-in-the-description" problem.

- Reduced the memory allocated by the log-code; this should solve EXTREMELY
  RARE conditions where weird things happen after you receive a BBS caller
  via. a dialup-modem... yes, dialup-modem callers still exist; my system
  receives them at least a few times per week.

- Very minor adjustment in Areafix to improve response in certain scenarios.


VERSION 3.99
------------

WARNING: Take a proper backup or snapshot of your system prior to upgrading
         to 3.99. Please review these notes thoroughly and if possible, you
         should always test new releases before applying them to your
         production mail system or BBS.

As most of you know by now; I do not have much time lately to spend working
on D'Bridge, but I do continue to support and issue fixes when possible. I
like to think of myself as someone who does exactly what he says he will do.
So at one time I made a promise to improve one aspect of DB, and here it is.

In 3.99, the entire Internet EMAIL and USENET gating system has been
completely redesigned from scratch. I was never happy with the way I
initially designed it and this time it should hopefully suffice for
everyone's needs. So... if you were waiting patiently for me to fix all of
that stuff, then you are rewarded now.

The USENET/EMAIL GATING screen has been greatly simplified, and a new
screen, GATEWAY USERS, controls the user or BBS accounts for authenticating
against your SMTP or POP3 servers. In addition, the F1 help screens have
been rewritten to hopefully explain things clearly for newcomers.

It is now possible, to use pretty much any legacy DOS BBS software with
D'Bridge and give it the ability to use Internet EMAIL and Usenet groups.

The overall operation of gating Internet EMAIL and USENET with D'Bridge is
to treat it as another Fido-style system. When mail is addressed to a
specified address, called the gateway, that mail is transformed into a
format that can be processed by common Internet SMTP, POP3 and NNTP servers.
Two programs are included to do the job, VSOUP and SOUPGATE. Those two
programs use configurations that are automatically managed by D'Bridge, very
simular to the way the popular BinkD system has its configuration parameters
managed by D'Bridge. Mail arriving from the Internet likewise is addressed
to the gateway, and D'Bridge will toss the mail just like it would under
normal conditions.

The Usenet groups are requested by sending an Areafix message to the
gateway address. D'Bridge will "intercept" these requests and automatically
manage the configuration for VSOUP to download the appropriate groups. The
master NEWSRC file is updated along with USENET.BBS and a few other files
that would otherwise require manual intervention.

Internet EMAIL is managed primarily by SOUPGATE and there is a new screen
which allows you to configure the individual mail accounts for Email. These
accounts typically match up with the user accounts in your BBS software or
your favourite message editor.

To send an Internet EMAIL message, first ensure that NETmail can be
properly routed to the gateway address by adding the following line to
the "Un-event" and any other Mail events. For example, if the gateway
address is 1:229/2 then the "Route to" line must be:

ROUTE TO: 1:229/2 FOR 1:229/2

Then, you (or your BBS users) must compose a NETmail message to "UUCP" at
the gateway, then put the line "To: " in the body followed by the Internet
EMAIL address. For example:

   From: Nick Andre, 1:229/426
     To: UUCP, 1:229/2
Subject: Testing Testing 1-2-3
  Flags: Direct
--------------------------------------------------
To: nandre@net229.org

This is just a test...

--------------------------------------------------

When D'Bridge is properly configured, it will automatically call VSOUP
and SOUPGATE. It does this by automatically generating and calling a file
called GATEDB.BAT. If you are running OS/2, you should create the semaphore
(dummy) file called DBRIDGE.OS2. If this file exists, then D'Bridge will
call the line "HSTART GATEDB.BAT". HStart is a utility which allows a DOS
session in OS/2 to call OS/2 programs.

If, however, you prefer to manually call VSOUP and SOUPGATE yourself, or
you are curious to see how it all comes together, see the example file
GATE.BAT in your DB directory.

There can also be three files in your DB directory - DBRIDGE.GS1,
DBRIDGE.GS2, DBRIDGE.GS3. If any of those files exist, the contents of them
are automatically added into the GATEDB.BAT batch file D'Bridge creates.
Refer to the GATE.BAT file for specific "hook points" where the contents
of those files are inserted. So, GS1, GS2 and GS3 (short for Gateway Step
1, 2 and 3) would actually contain whatever batch-commands you want added.

Keep in mind that SMTP/POP3 and USENET gating is somewhat of an "advanced"
feature of D'Bridge. If you already use a 3rd-party solution for bridging
Soup bundles/UUCP or Internet mail and groups to Fidonet, or you are already
dealing with another Fidonet system for your Internet gating needs, then
you should NOT be using the gateway features of 3.99.

There are some limitations of gating that you should be made aware of to
avoid "surprises" or spending a lot of time to set something up that may
not work the way you want:

* 3.99's gating features only operate on Windows and OS/2 platforms. It
  will not work correctly on plain-DOS or Linux systems at this time.

* The address of the gateway must be a "4D" address and a non-point address,
  nor should the address be published in a nodelist used by other systems.

* 3.99 only supports one SMTP, one POP3 and one NNTP/Usenet server. It
  does not support multiple servers or gateways, and it may not work
  correctly with "modern" hosted mail services. I may not be able to offer
  technical support to those of you who take things further and customize
  a system to use multiple servers. The USENET gating should work with the
  vast majority of providers.

* Usenet in general is not the same as it was back in the late 1980's -
  early 1990's, most of it is spam or HTML-formatted messages. D'Bridge
  currently does not decode HTML formatting; and any mail received from
  the gateway that is destined for other systems will be passed on "as is".

  NOTE: There are several junk filters that are included in JUNKCFGS.ZIP.

* D'Bridge may not decode file attachments correctly nor is it intended to
  be used as some sort of replacement or comparison to a "modern" Email
  client program.

The components that come with D'Bridge 3.99 currently do not support SSL
or TLS encryption for SMTP or POP3. Please keep this in mind before
attempting to deploy the gating with an existing SMTP or POP3 server system.

Other changes that were done:

- The nodelist compiler has been adjusted to handle up to 1024 characters
  of "raw" textlines in a nodelist. In addition, the size of certain fields
  was increased in memory to handle pretty much any entry imaginable.

  WARNING: I was reluctant to change the compiler for a few reasons, but
           several different scenarios were tested against the nodelist
           compiler; including attempts to cause buffer overruns, high-
           Ascii, general garbage and the compiler worked fine here. However
           that being said, it is YOUR responsibility to ensure that this
           release meets your production requirements. I strongly recommend
           testing 3.99 with your existing nodelists (and differentials if
           possible), please report any problems ASAP.

- A minor adjustment to the log file code was made when buffering on "plain"
  MS-DOS systems. It is strongly recommended to use a disk-cache utility
  when running D'Bridge on plain-DOS (IBM XT, AT, PS/2, Tandy 1000, etc)

- A minor adjustment was done to the way MSGID kludging is calculated. It
  was not flawed, just a bit of a mess.

- A very, very minor adjustment was done to the dialup-modem code.

- A minor fix was done for the "Last received date" when automatically
  adding TIC areas during a toss cycle.

- Some potential problems in the TIC "actions" configuration should be
  fixed now.

- Resetting limits on a Queue entry that has already been sent should no
  longer crash the system.

- The code that controls the installation of D'Bridge for newcomers has
  been significantly redesigned and improved.

- Minor cosmetic cleanups in the Queue.

- Surprisingly, anywhere from 5 to 25k of extra "free memory" should be
  available now from the cleanups. Keep in mind that the more complex your
  configuration is; the more memory is used. Keep an eye on the usage by
  watching the initial "stats" when D'Bridge loads for the first time.

Enjoy...


VERSION 3.98 - DECEMBER 20 2013 - CHRISTMAS EDITION
---------------------------------------------------

WARNING: If you are upgrading from 3.96 or prior, please review the
         release notes for 3.97 in the HISTORY.TXT file *before* you apply
         this upgrade. 

If you are upgrading from 3.97, it is strongly recommended to upgrade to
this release to avoid potential "problems" which some users have reported.

This very minor release is to address specifically problems from 3.97 as
well as one other major bug that has been lingering since 3.9.

- Repeatedly pressing ALT+Q in the mailer, under certain conditions,
  no longer crashes the entire system.

- Redesigned the logic behind archive checking (from 3.97) and weird
  looking PKZIP/PKUNZIP screens should not happen again.

- There is no more "Bomb action". Whenever an archive is tested, if it
  fails due to the Ratio or Count settings, it is marked as failed just
  like any problems with archives received via. other methods.

- The help screen was slightly revised accordingly.

- Another very serious problem with the Queue involving "large" or unusual
  combinations of Zone, Net or Node numbers and a specific combination of
  file attachments has been fixed. This problem affects 3.9 to 3.97.

- A very, very minor adjustment was done to the outbound call logic
  when electing to use QuickDial mode. Problems with the mailer not
  cycling back to "Idle" status upon Quick-dialing Queue entries should be
  fixed now.

- Pretty sure that also relates to the weird problem of the Processing Mail
  window left "open" meanwhile D'Bridge happily cycles though the Queue.

- The ability to add missing kludges to Echomail messages from legacy BBS
  software has been disabled in this specific version (troubleshooting
  something else reported...)

- Looks like another regression problem from before if D'Bridge takes
  a long time to shut down to DOS.

- Removed semaphore DBRIDGE.RAB,



VERSION 3.97 - DECEMBER 7 2013
------------------------------

WARNING: This release addresses a potential security flaw with D'Bridge and
         should be treated as an important upgrade. Carefully review these
         release notes PRIOR to installing this upgrade.

This is a very minor release which deals with "mail bombs". Specifically,
mail bombs that take advantage of someone's system that may be low on drive
space.

A lot of hard work has been done to ensure that the security of your
D'Bridge system is resistant to these common attack methods. In addition,
the code for Zmodem, EMSI, Yahoo, Wazoo and FTS has been carefully examined
to ensure no problems going forward. No changes were made to that code as I
have determined that it will pass the "test" for common exploit attempts.

Now, a mail-bomb is an FTS mail archive typically sent to a system to
attempt to crash or otherwise disrupt that system's operation. The idea is
to either cause that system to be disrupted when it calls the external
program to decompress the bundle; and/or disrupt the system when it
attempts to process the contents of the decompressed bundle.

One method is to carefully construct a packet file comprising of carriage-
returns or contents easily compressed - So a compression program will
shrink it to a trivial amount. Then when the files within the bundle are
decompressed to their original size, the sender of the bomb hopes that they
will exceed the available drive space on the recipient system; disrupting
or crashing it.

For example, a 2 gigabyte file full of carriage-returns or other pattern of
gibberish can be compressed to less than 2 megabytes in size. Multiply this
file several times, and its not hard to see how this would cause a problem
on a recipient's system if no safeguards are in place. By keeping the
overall size of the mail-bomb somewhat trivial; only until it is "too late"
does the operator then realise what the problem was.

D'Bridge may be the only mailer now that carefully examines the contents
of all received compressed mail bundles BEFORE they are decompressed.

Six types of mail-bombs are specifically addressed in this upgrade; most
likely the common methods to disrupt a system:

- Bundles containing files other than packets or nodelist differentials.
- Bundles containing files with unusually-high compression ratio.
- Bundles containing many files; to fool any large-file detection methods.
- Bundles containing directory-within-a-directory exploit attempts.
- Bundles that have any filenames not conforming to MS-DOS 8.3 format.
- Bundles with ANSI in the comment header and other such nonsense.

There are now three new questions in the CONFIG - XMAIL screen accordingly,
"Ratio", "Count" and "Action".

"Ratio" means that if the compression ratio within the compressed archive
is beyond a reasonable amount (lets say 90), then the archive is
treated as suspicious.

Likewise for "Count". If the number of files within the archive exceed a
specified amount (lets say 50), the archive is treated as suspicious.

WARNING: At the last minute, the defaults for both Ratio and Count were
         set to zero for newcomers and upgrades. You must manually specify
         a value to enable the verification of mail bundles.

The Action question has three choices:

NONE - Do nothing. D'Bridge will process the bundle irregardless of
       settings. This is the default setting which must be changed to Trap
       or Kill to enable the action on a suspicious bundle. Leave it as-is
       if you are running some external process to check for these.

TRAP - D'Bridge will rename the bundle and NOT process it further.

KILL - D'Bridge will immediately delete the bundle.

The logic behind the simple act of uncompressing a mail bundle irregardless
of the contents has also been significantly redesigned; taking into account
that D'Bridge also handles differential-nodelists ("Diffs"). Note that if
an XMAIL archiver "suffix" has been designed, this overrides this logic.

Having said all this, its still YOUR responsibility as a diligent network
operator to ensure you are running a secure system in other areas... a
secure operating system, passwords, etc.

I understand that these scenarios are fairly rare nowadays, however, in the
interest of addressing these now for the future newcomers to our hobby I
felt it was important.

Other minor things done while we're at it:

- Cleaned up, revised and in some cases completely rewrote the F1 Help
  screens in a few places.

- Cleaned up a few setup screens for newcomers unfamiliar with how certain
  things relate to another.

- Very minor cosmetic fixes.

- The DBRIDGE.NMM semaphore file is fixed now. (see notes for 3.52)

- Removed some unecessary code from the BinkD system; although careful
  attention to detail was done to ensure I'm not rehashing old problems.

- If no initialization string was defined in the MCF file for a dialup
  modem, D'Bridge no longer attempts to send "ATZ".



VERSION 3.96 - OCTOBER 20 2013
------------------------------

This is another very minor release that fixes the following problems:

- Mutli-line operation was slightly corrected/updated in the way that the
  mailer shares the Queue across multiple copies of the mailer running. Its
  another one of those things that just "bugged" me for awhile.

- A temporary workaround has been added to the Queue to prevent any further
  problems with the DBRIDGE.MEH/UEH file; I plan to rewrite this and part
  of the BinkD subsystem.

- Very minor, trivial cosmetic fixes.



VERSION 3.95 - OCTOBER 13 2013
------------------------------

This is a very, very minor update which has some code-cleanup behind the
scenes as well as addresses a very minor and rare issue with the Queue on
certain entries addressed to "high" Zone numbers.



VERSION 3.94 - MAY 22 2013
--------------------------

WARNING: It is STRONGLY recommended to upgrade to 3.94 if you are running
         a production Hub system, even if you have just one downlink; or
         if you plan on running a Hub system with D'Bridge in the future.

Yet another very minor release, but an important one:

- The entire code that handles Passthru areas has been completely rewritten
  and redesigned from scratch. A serious problem with removing empty
  passthru areas has been fixed, one which has existed for awhile and could
  potentially cause issues on production Hub's that deal with automated
  Echomail/Echofile/TIC management via Areafix/Filefix.

  The problem has to do with how the DBRIDGE.ADF (and DBRIDGE.TDF) database
  files were handled in prior versions. Under certain conditions, empty
  Passthru areas would not be purged correctly when one link is left in
  the Forward-to definitons - the uplink of the area; and sometimes this
  would cause D'Bridge to fail the midnight AutoUpdate event.

- Reverted the Queue linkage code back to how it was in 3.92 (as per a
  recent message thread in the DBRIDGE echo on Fidonet)

- A minor problem with session passwords not being correctly written to
  the DBRIDGE.BNK file under certain conditions has been fixed.

- Sometimes, the Areafix system was not informing downlinks that a
  requested area was not available on a "Forward to uplink" condition. This
  all relates to another problem, "System date incorrect for history".

- Minor cosmetic improvements to the Utilities - History screen.

- New installations for PSTN/dialup modem users would fail because a
  default MCF control file was not correctly unpacked.


VERSION 3.93 - MAY 18 2013
--------------------------

WARNING: Certain database file structures have changed. After upgrading to
         3.93 from a prior version, any scheduled events may be marked as
         overdue and the mailer will prompt to run them. You may press CTL+A
         to abort running overdue events.

This is another very minor release that deals with the following:

- Pretty sure any MEH/UEH file problems are solved now...

- Enhanced Echomail Logging no longer causes 3rd-party tossers to handle
  areas that were deemed to contain duplicate messages only.

- D'Bridge now updates the BinkD configuration DBRIDGE.BNK less frequently
  and usually only when necessary.

- A few very minor, trivial cosmetic things here & there were fixed.



VERSION 3.92 - APRIL 20 2013
----------------------------

This is a very minor release but addresses several things relating to
long-term stability, memory management and overall improvements to the
source code. The two most important changes are:

- A serious memory allocation problem with the way D'Bridge parses dialup
  modem AT codes and "translation strings" has been fixed. This problem
  does not become apparent unless you were using a really large MCF file.
  Keep in mind that large MCF files are not recommended since each MCF
  entry takes away from the memory available to the mailer.

- D'Bridge now only supports one dialup modem defined in the setup screen,
  not three. However if you have more than one modem installed in your
  computer you should be running in multi-line operation (also redesigned
  and improved).



VERSION 3.9 - DECEMBER 24 2012
------------------------------

The goal for 3.9 was to strictly focus on fixing most if not all of the
reported problems, not just recently, but collected over a period of time.

In order for that to happen, some drastic changes were made to a few things.

I hope you enjoy 3.9 as this one was a bit of a challenge and involved
a fair amount of programming and testing.

WARNING: BINKDWIN and BINKDOS2 must now be started with the -C parameter
         if you are serving incoming connections or "hubbing" mail to other
         systems, ie. C:\DB\BINKDWIN.EXE -C DBRIDGE.BNK

         Please update any shortcuts ASAP in Windows or OS/2 to include
         the -C parameter. Failure to do so may cause certain aspects of
         this release to not work as desired.

         BinkD must also be shut down before upgrading. If you have it
         running as a service in Windows 2000 or higher, ensure the service
         has been uninstalled entirely ("BINKDWIN -t uninstall") and
         verify; via Windows Start-Run-SERVICES.MSC. After upgrading to
         this version; D'Bridge will automatically re-install the service
         with the correct -C parameter.

WARNING: The event database format has been updated, so after upgrading to
         3.9 you may find that all events become "overdue". Get ready to
         press CTL+A to cancel any overdue events when the mailer fires up.

- A very serious problem involving a fun-filled week of troubleshooting
  issues with Quickdial, the MEH/UEH files and long-term system stability
  has been fixed.
  
- A very serious fundimental design flaw with DBUTIL MOVE not moving more
  than one Netmail message at a time and/or not correctly modifying the
  "status" of moved Netmails has been fixed.

- A very serious Echomail-tossing flaw has been fixed when tossing
  excessively large amounts of messages in Fido *.MSG format.

- A serious stability problem has been resolved when scanning many
  Echomail areas with many *.MSG files; then pressing CTL+A either does
  not cancel the scan, or it hangs the system.

- A somewhat major regression-bug with DB TERM not operating correctly or
  mishandling the modem or port itself has been fixed.

- Rewrote the logic behind appending to a message archive in DBUTIL PURGE.

- The TIC processor code has been completely rewritten and redesigned
  from scratch. It should no longer crash the system with memory leaks,
  stack overflow or other nonsense.

- TIC "actions" now take place before TIC files are forwarded or processed
  to other systems.

- Internet EMAIL and USENET gating has been significantly rewritten and
  redesigned from scratch; leaving only core elements and Areafix support
  for Usenet groups intact in the mailer while the rest is setup manually.

- Every single reported "8000" problems with the Internal Editor should be
  gone for good. The internal editor should now correctly handles huge
  volumes of messages, messages with high-numbers, forwarding/copying, etc.

- There may be a slight delay when using the internal editor and "listing"
  the contents of an Echomail directory in *.MSG format with many messages.
  This is normal.

- When the mailer saves the last-EMSI session information, it no longer
  includes the system type (for possible security concerns)

- Added two new questions, "Resolve from INA/IBN flags" and "Obey ICM"
  to the BinkD system; which was also significantly redesigned. D'Bridge
  can now resolve INA and IBN flags in addition to BINKD.TXT, when
  sending a Netmail message direct to another system and that system has
  not been first defined in the BINKD SESSION INFO screen.

  NOTE: At the last minute, it was determined that BinkD might complain
  about a destination system's "mailbox" directory missing if the
  destination was resolved by INA/IBN/BINKD.TXT and has only XMAIL or
  file-transmissions (no Netmail). The warning messages may persist for
  up to several minutes. These warnings can be ignored.

- It is recommended that an INA/IBN/BINKD.TXT-resolved system be
  "properly" set up in the BINKD SESSIONS question if ongoing transactions
  are to be expected; or the system must also have a session password
  defined.

- At least one system in BINKD SESSIONS must be defined for INA/IBN
  and BINKD.TXT resolution to work correctly (this will likely be
  addressed in a followup release)

- BinkD can now process Private/Unpublished nodelist entries provided the
  destination system can have its listed BinkD information resolved
  correctly. I still do not understand why a Pvt/Unpublished system would
  have INA/IBN flags since Pvt/Unpublished to me implies you're off
  the Matrix; you can't be contacted other than host-routing messages.

- The field for the BinkD default resolution domain (FNZ) has been adjusted,
  however I am not supporting FNZ lookups at this time.

- There is no more option to "write" the BinkD configuration.

- There are no more hooks to call DOS commands before or after a BinkD
  transaction, for a few reasons.

- BinkD should now properly create all domain directories in scenarios
  where the Zone differs from the AKA matching logic D'Bridge applies.

- BinkD will not create the received-mail semaphore until all mail and files
  have been received.

- The problem of incorrect Zone portions of the BinkD domains created
  should be resolved now.

- BinkD resolution is properly displayed in the "View Queue" menu screen.

- The nodelist may be recompiled and the Queue rescanned after exiting the
  Config - Internet BinkD settings screen. This is normal behavior.

- A very rare scenario where new Echomail is created, scanned & packed and
  then the first Queue entry being a PSTN dialup system is mistaken for
  a BinkD system thus the mail is lost in the Twilight Zone has been fixed.

- Cosmetic bugs with displaying Queue entries in a few different rare
  scenarios have also been fixed.

- The display of "** No description" on valid history entries has been
  corrected. Note that the format of those database files has been slightly
  adjusted and this means you will not be able to keep the history files
  if you downgrade back to 3.82.

- If BinkD resolution fails, and/or a dialup modem is not installed for
  a Queue entry, the entry is placed on Hold/Unlisted status.

- Clocksync operations are restricted to PSTN dialup modems only.

- The timeout value for outgoing calls on PSTN dialup sessions has been
  slightly adjusted though the modem's S7 register setting still applies
  and overrides the timeout value.

- D'Bridge no longer probes COM ports in COMM/MODEM setup.

- A slightly less-complicated check for disk space is done while tossing
  mail and the available drive space falls within a certain threshold to
  cycle the tosser to pack XMAIL.

- A slight correction was made to the code that controls the mailer's
  status line updates.

- Removed all obnoxious "Beeps of Death" from the mailer and internal
  message editor; except for certain scenarios which the mailer must exit
  with an error. FUN FACT: It appears that anything that calls Beep on
  a Windows RDP session overrides the volume setting of the local host...

- D'Bridge now properly creates all required directories for newcomers.

- There are several "macros" that can be used for any "DOS window" or
  window-of-commands to execute. In theory, this can be used to run DOS
  programs which require a basic amount of "interaction" however I am
  not offering technical support beyond the abilities mentioned below.

    *K<CR> - Replace with carriage-return.
    *K<LF> - Replace with line-feed.
   *K<ESC> - Replace with ESC key.
     ~YYYY - Replace with current four-digit year.
       ~YY - Replace with current two-digit year.
       ~MM - Replace with current two-digit month.
       ~DD - Replace with current two-digit day.
       ~HH - Replace with current two-digit hour.
       ~II - Replace with current two-digit minute.
    ~ALARM - Beeps and halts the mailer until a key is pressed.

  Note for *K when I say replace, I mean stuffing the DOS keyboard buffer
  with the desired keystroke-code byte.

- Checking for updates no longer crashes the system if CTL+A or CTL+X is
  pressed.

- An extensive amount of Echomail/Echofile area changes no longer crashes
  the system.

- Aborting a Zmodem file transfer in DB TERM no longer crashes the system.

- Cancelling the Internet BinkD setting screen a bunch of times no longer
  crashes the system.

- Specifying multiple destinations for Netmail via the F8 command in
  the internal editor no longer crashes the system.

- D'Bridge now has slightly better support for GoldED and TimED message
  editors in Config - Editor Options.

- The FLAGS kludge in the internal editor is no longer added to Netmail when
  the message contents are edited (yes, I'm aware of another issue relating
  to this scenario)

- The internal editor should properly show kludges on the "first" message
  shown on the screen.

- Removed the references to base address and IRQ settings. The FOSSIL code
  never uses it.

- Should be possible now to push through a FREQ over BinkD via. the mailer,
  though I am not supporting it at this time.

- Pretty sure I freed up some badly-needed memory in the MCF parsing code.

- DB EXPORT and DB IMPORT have been slightly adjusted.

- A serious problem with DB EXPORT and an immediate DB IMPORT not correctly
  "maintaining" certain settings should be resolved now.

- D'Bridge 3.9 should run correctly on MS-DOS 3.3, "share" or no share.

- D'Bridge should no longer crash on a Tandy 1000 SL, TL, RL or RLX
  computer system using Thaddius Pritchard's utility to play VOC/WAV files
  on the digital-audio chipsets of those computers when the "Youve got mail"
  option calls PLAYMAIL.BAT on personal Netmail/Echomail.

- A very trivial problem with screen mode 43/50 has been fixed.

- The on-line help system / entire documentation has been slightly updated
  and some sections revised or rewritten.

- The "manual" is properly included going forward now...

  NOTE: At the last minute, I decided against including MS-Word and PDF
        documentation for now.

- The Net 229 website correctly resolves http://www.net229.org/dbridge

- The D'Bridge section of the Net 229 website has been updated.

Feedback on 3.9 is greatly appreciated. Happy testing!

Nick Andre
www.net229.org



VERSION 3.82 - AUGUST 19 2012
-----------------------------

This is a very, very minor release which corrects some minor cosmetic
stuff ("Blank" system name, message databases, etc, etc).

The maximum number of NETmail messages packed in one "cycle" has been
reduced from 1024 to 512 to free up memory for those of you unable to
upgrade due to a large configuration (Ward). Error 203 should be no more.

The reason there is a limit is because D'Bridge allocates a certain number
of buffers in memory when its time to route and process NETmail messages
only. The amount of buffers allocated can cause a problem with those of you
running very large setups. Unfortunately there is no way to specify the
number of buffers to allocate since a portion of the code has been built
around this predefined constant. I have to take an educated guess as to
what a safe number of buffers should be...

The reduction of this limit does NOT affect normal operation, except that
there may be one or two more packing "cycles" executed to process NETmail
messages.

Any problems with this or other things, let me know...


VERSION 3.81 - AUGUST 6 2012
----------------------------

WARNING: This version affects message storage. Be sure to back up your
         message directories prior to upgrading to 3.81.

Alright, this is another minor release which deals with:

- A reported problem with DBUTIL purge on days.

- Extra lines added to messages written in the internal editor should
  be resolved now. If not, I would need specific examples sent my way
  (hex dumps) along with how it came to be... writing one message or several
  in a row, quoting originals, changing an existing message, etc...

- The CHRS kludge is now optional. If it is blank, nothing is added.



VERSION 3.8 - JULY 10 2012
--------------------------

WARNING: This version affects message storage. Be sure to back up your
         message directories prior to upgrading to 3.8.

This very minor release addresses DBUTIL specifically. There were no other
changes made to D'Bridge in this version.

Although I cannot replicate the reported purge problem here; I did make
a minor adjustment to the file-handling code. I reviewed and studied all of
the code for DBUTIL to ensure all file operations work as they should.

Keep in mind that my time does not permit me to work on D'Bridge very often
anymore. I will still offer tech support but turnaround time may be longer.

Nick Andre
www.net229.org



VERSION 3.79 - APRIL 6 2012
---------------------------

This is a very minor release which corrects and adjusts the handling of
the MSGID kludge as well as minor code improvements to all aspects of
the software.



VERSION 3.78 - MARCH 6 2012
---------------------------

This is a very minor update which changes the logic of the DBUTIL ADD
and DROP commands to always follow the defined security policy so adding
or dropping ALL areas works as it should.



VERSION 3.77 - MARCH 3 2012
---------------------------

This is a very minor release that introduces some new functionality to
the DBUTIL program as well as improving performance in the tosser when
the system is tossing large volumes of Echomail to many downlinks at once.

- Added two new commands to DBUTIL: ADD and DROP. These two commands are
  used to globally ADD a system to specified areas or DROP the system:

  DBUTIL ADD ECHOMAIL 1:229/427 BBS_CARNIVAL DBRIDGE
  Means add 229/427 to BBS_CARNIVAL and DBRIDGE echoes.

  DBUTIL DROP ECHOMAIL 1:229/427 FIDONEWS
  Means to remove 229/427 from the FIDONEWS echo

  DBUTIL ADD ECHOFILE 1:229/427 NODEDIFF
  Means add 229/427 to the NODEDIFF Echofile/TIC area.

  DBUTIL DROP ECHOFILE 1:229/427 NODEDIFF
  Means to remove 229/427 from the NODEDIFF Echofile/TIC area.

- Note that the ADD and DROP commands essentially create "fake" Areafix
  or Filefix requests, as if the remote system sent them except that
  the local security policy is not enforced. So, the commands will NOT be
  processed until the next time that D'Bridge is running.

- Resolved a possible condition in DBUTIL that may not correctly archive
  messages during a purge cycle.

- The LEVEL/ADD and LEVEL/PASSTHRU questions have been removed. You now
  specify the default group access letter and security levels in the "Only
  add from" question. This now gives you much greater control over areas
  that are automatically added to D'Bridge. For example:

  1:229/426 A 50 means new areas from 229/426 are assigned group A level 50.

- And yes... the change also affects Echofile/TIC areas.

- A minor adjustment was made to the tosser so that it will not constantly
  "Drop to compress XMAIL" when tossing huge amounts of Echomail (many
  thousands of messages in one "cycle" to many downlinks), and should
  hopefully eliminate the constant "dropping" after one single message
  is unpacked (with many Queue entries present).

  This was a very difficult problem to address but was related to the way
  that the mailer checks for free disk space. The code was slightly
  modified and should work properly on all versions of DOS, Windows
  and OS/2 operating systems but testing on emulated environments will be
  dependant on how the emulator reports free-space.

- Cleaned up some very minor appearance-related bugs.

- Spent some more time cleaning up the source code.



VERSION 3.76 - FEBRUARY 20 2012
-------------------------------

This addresses a condition pointed out by Ward Dossche in the DBRIDGE echo.

When running as a hub system and a downlink sends an unsubscribe request
(Areafixing "-"), if the area is not available but can be requested from an
uplink (or is in a .BBS file), the mailer was incorrectly forwarding that
unsubscribe request to the uplink. The logic has been fixed in this version.

This is a very minor release but should be installed by anyone running
a "Hub" system since this condition affected ALL versions of D'Bridge.



VERSION 3.75 - FEBRUARY 2 2012
------------------------------

This is a very minor release which removes the problematic "Maximum
outgoing sessions" setting from Config - Internet, for BinkD. It also
prepares your system for IPV6 support by addressing some minor code changes
to allow IPV6 BinkD addresses to be saved in the D'Bridge configuration.

Note that at this time the BinkD system with D'Bridge is not directly IPV6
compatible, but when it is and I'm satisfied that it is reliable and stable
I will happily publish an update for this. Note that the OS/2 version may
not ever support IPV6 since there is not (to my knowledge) an IPV6 stack
released for that operating system.

Maximum outgoing sessions was removed because it affects long-term operation
and also the collection of statistics was not accurate. This does not affect
outbound transactions outright; it just means that on busy hubs with many
Queue entries, it may take a little bit longer to complete a "round" of
transactions. Unless someone can give me a good reason why this needs to be
in there, it has been "commented out" of the code for the time being.



VERSION 3.74 - JANUARY 31 2012
------------------------------

This is a very minor release which adds one function and one keyword change
to DBUTIL. This was done to address some Emails I get occasionally
regarding the operation of that program. Now, it is possible to fully
understand where systems are storing their mail.

DBUTIL QNAME - This will display the Base36 directory name for a given Fido
               address. For example: DBUTIL QNAME 1:229/426 will show
               the result 00106D.0BU meaning that any directory, Queue
               entry or control file with this part of the filename is for
               the specified address.

That being said, 3rd-party programs and InterBBS games should always be
configured to run in "Frontdoor/Intermail" mode with seperate "outbound"
directories per application. The Inbound and Message directories are okay
for access.

Never let a 3rd-party program or InterBBS game have access to the Queue
or Packets directories. Technical support will NOT be provided for any
problems I find are a result of 3rd-party programs using those directories.

The SECURITY keyword has been added to DBUTIL change and functions the
same as AREASECURITY. So, DBUTIL CHANGE SECURITY 5000 SECURITY 50 will
change all Echomail areas with security level 5000 to level 50.

Nick Andre
www.net229.org



VERSION 3.73 - JANUARY 14 2012
------------------------------

This is a very minor release to fix an issue with the Echomail setup screen.



VERSION 3.72 - JANUARY 8 2012
-----------------------------

D'Bridge is probably the only DOS program updated into 2012... Anyhow, this
is a very minor release which corrects two problems in the internal editor:

- The COPY and MOVE commands no longer crash the whole system.

- The Y command is repaired.



VERSION 3.71 - DECEMBER 30 2011
-------------------------------

This is a very minor release which corrects some reported issues in 3.7.

It is strongly recommended to install this upgrade if you have recently
installed the 3.7 release. Even if your D'Bridge system is running properly,
you should install this upgrade to address the following:

- Resolved a minor problem with the way D'Bridge handles poll and transmit-
  requests for multiple zone-addresses in a singular domain in BinkD. For
  example, you have a Zone 1 address and could not poll a Zone 2 system, or
  you have a primary address outside of Zone 1 (or in an "othernet") and you
  were trying to poll a Zone 1 address (or another zone in that othernet).

- A serious problem was resolved in the TIC processor when processing huge
  amounts of TIC files at once, as well as several internal improvements
  were made to the TIC code for stability reasons.



VERSION 3.7 - DECEMBER 22 2011
------------------------------

NOTE: This should be treated as a major release. Make an entire backup of
      your existing D'Bridge system if you are upgrading. Newcomers who
      are installing 3.7 for the first time are advised to review this
      document as some important notes were specifically written for those
      of you taking the software for a test-drive.

D'Bridge now supports TIC processing.

The TIC system is completely integrated into the mailer, tosser and
scheduler. It is not "tacked on". It was written from the ground up to be
easy, seamless yet totally configurable for your needs.

For newcomers, Fileechos are simular to Echomail areas, except files are
being "echoed" instead of messages. Files are sent among systems along with
tiny text files known as "TIC" files. Those TIC files control which fileecho
the file belongs to along with other criteria.

D'Bridge also supports internal "hatching" (posting) of new files to a
fileecho, either manually via console commands, or automated on a schedule.
It also supports automated management via FILEFIX, a system simular to
AREAFIX.

The internal FILEFIX system is 100% compatible with Harold Harm's ALLFIX
along with other 3rd-party TIC software.

I have done all the hard work in simplifying the whole process so really
all you need to worry about is the names of the fileechoes, who you get
them from, and what the passwords are. There are some new screens
which control all of the settings for how the TIC subsystem operates.

FILEECHO/TIC AREAS     Where you define the Fileecho areas.
ACTIONS/MAGIC NAMES    Where you define actions to take on the files.
FILEECHO/TIC SETTINGS  Where you configure TIC processing options.
HATCHING FILES         How to "post" a file into a fileecho.

There is no support in this version for adding files to incoming files
received, or modifying the comment-field of archives. However D'Bridge
does support virus-scanning of each incoming file, and executing commands
prior to (and after) file processing. And yes... there are a lot of "hooks"
to let you integrate your own batch files, software, etc during every
step of operations.

TIC support is not all that was done.

3.7 has a noticable and substantial amount of corrections, updates and
improvements to existing functions. Even if you do not care for TIC
processing or you use 3rd-party TIC software such as Allfix or HTick, you
should consider upgrading to 3.7 as it is been tested to be more stable
than prior versions... even more than the classic 1.58 release.

The work on 3.7 was ongoing if somewhat sporatic over the months since
the last version. To sum up the work, priority was placed on three factors:

BETTER STABILITY       Ongoing issues were resolved for long-term stability.
BETTER MANAGEMENT      Improved administrative and diagnostic functions.
BETTER PERFORMANCE     The code was revised to reduce memory and CPU usage.

TIC SETUP TUTORIAL
------------------

This is a "Quick start" guide for using the new TIC subsystem, and this is
written for those of you upgrading from 3.64 or prior. Newcomers installing
for the first time have plenty of help available via F1 at any time.

In this example, your uplink for fileechoes is my system (1:229/426) and
you want to handle the weekly Fidonet NODEDIFF updates to the nodelist. You
want D'Bridge to automatically "toss" and compile the nodediff on receipt.

Since the NodeDIFF is usually an ".ARC" file, I would go to the XMAIL
CONFIGURATION screen and make sure that the ARC program is properly set up.

ARC comes with D'Bridge so you don't need to download or install it. The
redesigned/revised installation in 3.7 takes care of the work setting those
programs up - so ARC should already be good to go.

In order to use the new TIC system, you must first configure some new paths
in the DIRECTORY PATHS screen.

 BAD TICS: If D'Bridge encounters a problem processing a TIC, it will move
           that along with the corrosponding file into this directory. If
           this path is not specified, TIC processing is disabled. (default)
           Suggested path is C:\DB\BADTICS and that is the default for
           new installations. (Replace "C" drive with whatever drive DB is
           installed on)

NEW AREAS: Specify this path where new fileecho areas will be created, if
           you choose to store received files in their own directories.

Define your uplinks/downlinks in the FILEECHO/TIC SETTINGS screen. Pay
attention to passwords and security access. When the TIC subsystem is used
and there are "problems", D'Bridge will log them and also create a log
file in the BAD TICS directory; explaining in detail which TIC and/or which
file caused the problem... such as invalid password, etc.

If your Echomail AREAFIX configuration is very simple, as in, you are
not "Hubbing" any mail so you just have one system defined, you can select
"Use FILEFIX info from AREAFIX" so it will copy the same security settings
there into this screen. Obviously you are able to change all of this later.

Create the area NODEDIFF in the FILEECHO/TIC AREAS editor. For the directory
for files, you may leave this set to None... we will use them but not keep a
directory of them. Be sure the area is setup good; paying attention to
things like alias-addressing (if Fidonet is not your primary network), and
security.

When specifying the FORWARD-TO lines, you may optionally specify READ,
WRITE or BOTH read/write access, for example:

                    Forward-to: 1:229/426,NW 619,NR 723,NR

Means 1:229/426 has Normal priority and Write/Hatch access only (any other
links should have READ access only to prevent accepting NODEDIFF's from
anyone but 426)

Next, we will go to the ACTIONS/MAGIC NAMES. We will use an "Action" to
automatically copy received Nodediff files to our DB directory. Select
"CopyFile". Then type in the fileecho we're copying from ("NODEDIFF") and
then the DOS path where we are copying to ("C:\DB" for example)

Finally, the D'Bridge scheduler controls which events are allowed to
process TIC's, just like it controls if XMAIL/Echomail is allowed. Go in
to the SCHEDULER screen, and change the settings for the UN-EVENT along
with any other mail-events you want TIC processing enabled for. Save your
changes and you're done!

Hopefully this will make sense for everyone and remember that you may press
F1 at any question or screen for help on configuring the settings.

Moving on, lets look at the screens in detail:


FILEECHO/TIC AREAS:
-------------------

This screen is where you specify the individual TIC "areas", very simular
to the screen that controls the Echomail areas:

Codeword: NODEDIFF

The CODEWORD is a word from 1 to 16 characters which you designate as a
mnemonic reference to an area. It could be a word like NODEDIFF for node
"diff" files or GRAPHICS for image files. CODEWORDs must be unique - the
words "NETMAIL" and "BADECHO" are predefined by the system and may not be
used here.

Alert flag: D

If you wish to be notified (on the status line) about new files in this
area, specify a one character "flag" here. When files are received, the
mailer will show it by listing the defined "flag" character on the right
side of the bottom status line.

Security level: 500

The SECURITY LEVEL is used by the FILEFIX subsystem to allow other
systems to automatically add or delete themselves from Fileecho links.
Security levels range from 0 to 9999; if a system has a security
level of 50, it has access to all areas with a SECURITY LEVEL of 50
or less. If you don't want anyone to have access to an area, define
its level to be 9999.

Group/Sort: A1

GROUP/SORT is a two-byte field; the first character is the FILEFIX access
group; the second is the sort code for use with DBUTIL SORT TICS.
In FILEFIX, each area is assigned a GROUP code. Each system with a FILEFIX
password also has one or more group codes associated with it. Only those
systems with matching GROUP codes have access to a given area.

Description: Weekly Fidonet NodeDIFF files

This description field will be used throughout the system to describe the
conference.

Storage method: Directory  (Or N for None/Passthru)

This question is where you specify if the files will reside on your system.
If NONE is specified, the area is regarded as an area "passing through"
your system. The files are stored temporarily until the last system has
been sent the files during mail-tossing. The files are then erased later.

Directory path: C:\MYFILES\NODEDIFF

The DIRECTORY PATH is any DOS directory where D'Bridge should store the
received files for this conference. It may be a local drive and path or
a drive and path that is "mapped" from another computer on a network.

Conference name: NODEDIFF

Each fileecho area must have a unique CONFERENCE NAME. This may be the
same as or different from the CODEWORD specified above, but must reflect
the actual fileecho name or conference tag specified in the corrosponding
TIC files that arrive with the files.

The CONFERENCE NAME may be up to 54 characters and must not contain any
spaces; when creating a new fileecho conference, it is suggested your
CONFERENCE TAG should not exceed 16 characters if at all possible to
maintain compatibility with other systems.

NOTE: D'Bridge does not allow "NETMAIL" or "BADECHO" to be used as
      conference names. Those two names are reserved by the internal mail
      processor. Any received TIC's with those names are immediately flagged
      as "bad" and will not be processed further.

Alias address: 1:1/130

If you are a member of more than one network, it might be necessary to
use an "alias" address on a fileecho area. This means that the address
put on the Address field of the outgoing TIC files will be different than
your primary address. Most systems would leave this blank.

NOTE: Be sure that ALIAS ADDRESSING is properly defined in BASIC CONFIG when
      using another address other than the Primary.

Default priority: Normal (Immediate/Crash/Normal/Hold)

For each conference, you specify a DEFAULT PRIORITY for forwarding of
fileecho files and TIC's. Choose either IMMEDIATE, CRASH, NORMAL or
HOLD; This default may be overridden for any specific system.

Forward to: 1:229/426

The FORWARD TO fields allow you to specify a list of systems to whom you
wish to forward files received in this conference. You may specify as many
systems as will fit on the lines available.


FILEECHO/TIC SETTINGS
---------------------

In this screen, basic parameters relating to the filecho/TIC subsystem are
defined here:

FILEFIX SYSTEM ON/OFF:

D'Bridge automates Echomail management with a subsystem called AREAFIX. So
it makes sense that fileecho/TIC areas be managed with a simular system, and
that is called FILEFIX. Answer YES if you wish to accept FILEFIX requests
or answer NO to shut this feature off.

NOTE: D'Bridge responds to FILEFIX requests from FileFix, FileMgr and Allfix
      keywords. Those three are usually the most "common names" in Fidonet.

FILEFIX USES AREAFIX:

Answer YES if you wish to merely use the exact same passwords and group/
security access defined in the PACKET/MAIL CONTROL screen. Note that any
defined forwarding-information files defined in that screen will NOT be
applicable here; so only answer yes if you are the main "Hub" for your
network or you carry an entire fileecho feed from your uplink.

FILEFIX Information: 1:229/426 PASSWORD A,501 Normal Yes Yes AREAS426.BBS

This window controls the FILEFIX subsystem, allowing automated area
list and ECHOmail distribution management. For each system, specify:

<ADDRESS> <PWD> <GROUPS,LVL> <PRIORITY> <NOTIFY?> <FWD REQ?> <AREAS.BBS>

Where:

<ADDRESS> is the address of the system in the form ZONE:NET/NODE.POINT

<PASSWORD> is a codeword agreed upon by both systems (you and the system
specified) for FILEFIX. The password may be from 1 to 32 characters.

<GROUPS,LEVEL> contains the groups allowed and security level assigned to
the system. ie. ABC,501 allows groups A, B and C and areas with a security
level equal to or less than 501.

<PRIORITY> is the file priority associated with the link. In most cases,
you would use CRASH for systems in your local calling area and NORMAL or
HOLD for long-distance links. Valid priorities are: Immediate, Crash,
Normal and Hold.

<NOTIFY?> asks whether the specified system should be sent a notification
NETmail when files are sent to it. In most cases answer YES or NO if the
specified system is an uplink.

<FWD REQ?> determines whether requests for unavailable fileecho areas
will be forwarded to your file hub(s). If you answer Yes, all unknown
requests will be passed along to the first applicable fileecho hub. As per
the next question, you should specify an AREAS.BBS file for forwarding. It
is not required however.

<AREAS.BBS> specifies the filename of the system's AREAS.BBS file to
use when forwarding fileecho/TIC requests. This should only be specified
for the systems which are your hubs or uplinks. Any conference listed
in this file may be requested by other allowed systems. Make sure these
lines are listed in the desired search order.

* REMEMBER *  CTL-N inserts lines, CTL-Y deletes lines in a window.

TIC PASSWORDS: 1:110/68   Secret

This window allows you to specify any TIC passwords that may be required
by systems you exchange files with. Passwords are case sensitive.

Auto-add TIC areas? Yes       Only add from specified systems? Yes

Answer YES if you wish to automatically add unknown TIC areas from specified
systems or NO if not. If you answer NO, any TIC files that are received that
do not have areas defined will be moved to the "BADTICS" directory.

The next two questions control if you wish to allow auto-adding from
certain systems only. Answer YES and then specify which systems D'Bridge
should only auto-add fileecho areas from. If you answer NO to the next
question, D'Bridge will auto-add fileecho areas from any system.

Level/Add controls the default security level assigned for auto-added
fileecho areas. Level/Passthru controls the default security applied
to areas that are added as Passthru. Passthru areas should have a low
security level in order to allow any downlinks to un-Filefix them later.

Remove empty passthrus? Yes (Yes/No)

Fileecho/TIC hubs which carry many passthru areas may wish to remove
unused conferences automatically. D'Bridge will erase these unused areas a
few days after the last fileecho feed is cut. FILEFIX TIMEOUT DAYS will
control the number of inactive days to wait before killing the last feed
and sending a FILEFIX request to your feed, removing the conference.

Filefix forwarding days? 3

This parameter controls the number of days to wait for a new conference
to arrive after forwarding a request. After this many days, if a new
conference requested has not been received, a message is generated to
the original requesting system, explaining why their request was not
honored.

This also controls the number of days before removing a passthru area
with no links left.

Route Receipts? Yes

When a downlink requests a fileecho conference that does not exist on your
system, and that request is forwarded to your uplink, D'Bridge can route
the Filefix reply that your uplink generates back to the downlink that made
that request. Answer YES to turn this feature on. Answer NO (default setting)
to leave it shut off.

Unknown area forwarding:

Here, you may specify the address of a fileecho hub to use "blindly",
forwarding FILEFIX requests for unknown areas. If the area is not found
in any listed AREAS.BBS file, it will be sent to the specified system.


PASSTHROUGH TIC AREAS
---------------------

A note about Passthru TIC areas. The files are temporarily stored on your
computer until all of the systems have received the file. The files are
located in the DB\DATA\PASSTHRU directory.

When D'Bridge performs a QueueScan, it first scans the Queue entries on
disk to ensure no systems have the Passthru file waiting to be sent or
moved. If D'Bridge cannot find any occurance in the Queue entries, it will
erase the file out of the Passthru directory.


HATCHING/POSTING FILES
----------------------

There are three ways to do this. Using the UTILITIES menu, DBUTIL HATCH or
an automated ACTION that performs the hatching.

FILENAME: The complete path and filename to be hatched/posted.

FILEECHO: The name of the fileecho where this file will be "posted" to.

ORIGINAL: Use if this is an "original" file so it is not erased when sent.

    DESC: The description of the file (limited to 10 lines). Note that if
          the file contains a "BBS description" file like FILE_ID.DIZ, then
          most systems would use that description instead of what you type
          here; depending how that system is configured.

   MAGIC: If this file should have a "magic" keyword as per the TIC
          specification, then specify that here.

 REPLACE: If this file replaces another, then specify the name here.



READ/WRITE ACCESS CONTROL SYSTEM
--------------------------------

NOTE: It is extremely important for both newcomers and experienced D'Bridge
      administrators to understand this new feature. Incorrect settings can
      cause "problems".

D'Bridge 3.7 now has the ability to control read/write Echomail and TIC
fileecho access. And its as easy as one letter on your keyboard.

In the ECHOMAIL AREAS screen in the FORWARD TO section, you define the
Echomail links as usual. You already know that you can override priority
for a system, ie. 1:229/426,N to make sure that 426 has Normal priority.
Now by adding one more letter AFTER the priority, you can control that
system's access:

  R means READ ONLY access. W is WRITE ONLY. The letter B (OR NOTHING AT
  ALL - THE DEFAULT SETTING) means both read/write access.

1:229/426,NR    Means that 1:229/426 has Normal priority and READ ONLY access
                to the Echomail area. Messages are relayed to that system
                but any postings are rejected (with no acknowledgement).
                
1:229/426,CW    Means that 1:229/426 has Crash priority and WRITE ONLY access
                to the area. No messages will be relayed to this system.

1:229/426,IB    Means that 1:229/426 has Immediate priority and read/write
or 1:229/426,I  acesss - the default behavior (or when R/W/B is blank)

REDIRECT TO     If a violation occurs with READ ACCESS, as in, the system
                attempts to post a message forbidden by their restriction,
                you may specify an Echomail area to have those postings
                redirected to. The default setting is the BADECHO area.

You MUST specify a priority first before the read/write. In other words, do
not use syntax like 1:229/426,R.

For TIC/Fileechoes, the same rule/syntax applies except that the context
is different. So READ access means that the system will receive the file
but cannot hatch (post) files in the Fileecho area... useful for Fileecho
areas such as the Fidonet NODEDIFF:

Example: 1:229/426,N 619,R 728,R  Means that the NODEDIFF will be received
by 426 and relayed to 619 and 728 but both 619 and 728 cannot send NODEDIFF
files in return.


OTHER FIXES AND CORRECTIONS
---------------------------

This major release of D'Bridge has numerous corrections and revisions.

Careful attention to detail and rigorous testing was done to make sure
that 3.7 is the most reliable, stable D'Bridge yet.

- The commands ALT+N (New Echo Link) and ALT+R (Request Echo Link) have
  been slightly revised for the fileecho/TIC support. Now, a question
  asks you if the request is for Echomail (default) or TIC files.

  At the last minute, I added the ability to specify the "name" of the
  automated management system for fileecho/TIC files (ie. FILEFIX). So if
  a system does not respond to "FileFix", you may specify ALLFIX or FILEMGR
  (or whatever you want) as the manager name. The name is also saved for
  future usage.

- When using ALT+N or ALT+R to do an Echomail Areafix request, that
  specific request must be processed first before doing another ALT+N or
  ALT+R for a Filefix request. (This will be revised/corrected later)

- The ALT+N and ALT+R commands in the internal editor only function for
  Echomail requests and links. TIC functionality is not integrated (yet)
  into the internal editor.

- The ALT+N and ALT+R commands now properly use the alias-address provided
  that the address/zone matching is properly defined in Config - BASIC. The
  correct INTL, FMPT and TOPT kludges are injected into ALT+N/ALT+R
  generated packets before processing.

- At the last minute, I added support for FILES.BBS to D'Bridge. This means
  that whenever TIC's are processed and you are storing a copy of the file
  in a directory, D'Bridge can update any FILES.BBS present with the
  filename and description. A lot of BBS software supports FILES.BBS to save
  work involved in keeping your BBS filebases updated.

  There are two types of FILES.BBS formats supported by D'Bridge. Standard
  and Extended. Standard means the filename, a space, then a one-line
  description. Extended means that any description more than one line will
  be added to the next line in the file with a plus-sign (+) character.

  Example: TORWEATH.ZIP Latest weather reports for Toronto, Ontario.
           +This archive contains the latest weather survey data
           +for the city of Toronto, Ontario Canada.

- Also added was the ability for D'Bridge to import descriptions from
  FILE_ID.DIZ and DESC.SDI files if the above FILES.BBS is set to Extended.

- It is no longer possible to specify the directories for PSTN dialup
  "scripts" or FileBase files. They should be stored in the DATA directory
  from now on.

  This is not because they are being phased out. This was done to free up
  memory usage in the code; because scripts and Filebase files are nowadays
  a very seldom-used portion of the mailer. So the decision was made to
  remove the code that stores scripts and Filebase info in different places.

- You may now send file-requests (FREQ) to a remote BinkD system. Whether
  the remote system honors the request depends on how the remote operator
  has set it up. At this time, D'Bridge does not process incoming file-
  requests from BinkD sessions; only on dialup.

  This is due to the fundimental way that BinkD was designed; and its
  reliance on what is known as a "SRIF" (Standard Request Information
  File) to act as the go-between. The way that D'Bridge handles FREQ's was
  programmed in a way to make integrating a method like SRIF extremely
  difficult to do.

  This is not a D'Bridge-specific problem; it is difficult to get file-
  requests working even in a minimal BinkD system, without the use of
  scripting, other software, etc.

  I have chosen not to implement SRIF since in a later release I plan to
  address these (minor) shortcomings with a much more integrated solution.

- DBUTIL also now supports "moving" FREQ's out of the Queue as well.
  Whether or not the remote system will honour the FREQ depends on how the
  remote system has file request support configured.

- The NETmail filter/tracker system has been completely redesigned and
  reprogrammed from scratch. It is 100% integrated with the internal message
  tosser and uses much less code to process/filter NETmail messages.

- The NETmail filter/tracker also has been greatly simplified. It will only
  filter NETmail messages that are addressed to unlisted systems. By default
  the system is shut off. It is enabled by going to PACKET/MAIL CONTROL.

- All procedures that send automated NETmail responses to remote systems
  have been checked to prevent certain behavior if a D'Bridge operator
  does not correctly set up routing on a new installation.

  Note that D'Bridge by default only routes "In-transit" Netmail to systems
  destined within the same "Net". If your uplink or other systems do not
  reside in your "net" segment, you will need to specify correct routing.

- Corrected a problem where in certain conditions, D'Bridge appears dead
  for up to a minute before processing large volumes of mail with many
  Queue entries waiting to be sent out or many packets waiting to be
  compressed (XMAIL) (this is possibly a regression problem from prior
  versions)

- A new semaphore file, DBRIDGE.XON (short for ALT+X-Out-Now), can be made
  so that if you shutdown your D'Bridge system with ALT+X, any "after mail"
  commands in the scheduler will not execute... so the mailer will in fact
  stop everything its doing and shutdown immediately.

- A certain condition affecting SMTP/POP3 sessions should be resolved.

- The "Auto purge messages" option has been removed. It was not working
  properly and will be redesigned in a future version.

- The D'Bridge tosser no longer chokes on an invalid Fido *.MSG directory
  when that directory was loaded from a user-modified exported configuration
  (Note that this was an extremely rare condition and no cause for concern)

- A minor problem with unpacking large volumes of Echomail in Fido *.MSG
  format has been corrected.

- D'Bridge no longer acts strange when tossing more than 32,767 messages
  in a single Echomail area.

- Another miscellaneous problem with QuickBBS/GoldBase was corrected during
  the tossing of mail.

- D'Bridge should no longer hang on the AutoUpdate event if there are no
  Echomail areas defined.

- DBUTIL was further enhanced and is approx 10 to 15% faster than 3.64.

- More unused code was removed from the mailer for efficiency reasons.

- The strange appearance of ".$P2" files in the Queue should be gone.

- QuickDial should no longer randomly hangs the scheduler after a Quick-
  dial cycle has finished. This was an extremely difficult problem to
  resolve (suspecting a regression-bug from a prior release)

- D'Bridge should no longer immediately attempt a BinkD transaction when
  started for the first time in a day (a regression problem from prior)

- The mailer no longer hammers a dialup modem with initialization commands
  on every single trivial function such as menu interaction, etc.

- D'Bridge should no longer have any more random problems with Nodelist
  compiling or QueueScan's after the midnight-AutoUpdate event. This was
  a very difficult problem to replicate here but I'm pretty sure I fixed it.

- The Nodelist compiler "buffering" has been reduced to free up more memory
  internally. This is a TEMPORARY change and the first change to code that
  has not been changed in 20+ years. So if this is a problem, then let me
  know ASAP and in the meantime you may set an environment variable called
  NLBUFSIZE with a value of 256. This will make the compiler function as
  it did in 3.64 and prior versions.

- Cancelling the Echomail Areas screen exactly eight times in a row
  no longer crashes the whole system.

- D'Bridge should no longer crash with a "Write Log Error 2" black-screen-
  of-death problem on very large configurations.

- A black-screen-of-death problem when routing large amounts of Netmail
  should also be solved.

- The storage of internal events is slightly different; again please note
  that when you upgrade from a previous version, make sure to press CTL+A
  to abort running any overdue events if prompted.

- You may create a dummy/semaphore file called DBRIDGE.RAB (Rescan queue
  After a BinkD transaction). It will force a Queuescan after every BinkD
  transaction.

- The Internet Settings screen was not properly storing one (critical)
  piece of information when D'Bridge is configured for Linux BinkD.

- The XMAIL compress/decompress commands are properly configured on
  new installations. (This was another possible regression problem)

- A minor problem tossing Echomail messages from D'Bridge to certain BBS
  software was fixed, relating to the "Enhanced Echomail logging" setting.

- If "Enhanced Echomail logging" is enabled and the SCANDIRS.LOG file
  exists, then D'Bridge will no longer constantly report that it is scanning
  for outgoing Echomail if the semaphore/dummy file DBRIDGE.NSS exists.

  Incase you are unaware, D'Bridge has a lot of "hooks" in it to help
  integrate with BBS software or your own utilities. Enhanced Echomail
  Logging refers to D'Bridge communicating via log files which Echomail
  areas actually have pending mail to be tossed to (or scanned from) BBS
  software. This greatly improves performance during toss and scan cycles
  when your BBS has a large configuration with thousands of message areas.

  WARNING: Do NOT enable Enhanced Echomail Logging if you do not run a BBS
           or your BBS software does not support this feature.

- Pretty sure I solved the "Err 23" message in the Comm/Modem Setup screen.

- Problems with D'Bridge returning to the mailer instead of quitting to DOS
  after a Telnet connection "drops carrier" in multi-line mode should all
  be fixed now.

- Added a new option in BASIC CONFIGURATION to improve performance of the
  mailer when running under certain environments such as legacy computers
  running modern versions of Windows or "emulated" environments like VMWARE
  EXSI or Oracle VirtualBox. This new setting controls the number of "time-
  slice" routines D'Bridge generates when the mailer is Idle and waiting
  for commands.

  I tried to address this in the version 2 series but for many reasons I was
  not completely satisfied with the results. But the new code I have written
  for this release should hopefully solve all reported "high CPU usage"
  problems when D'Bridge is running.

  The higher the setting, the more timeslices are given back to your
  operating system and less CPU usage is allocated for D'Bridge processing.
  Performance of your computer may be significantly improved and/or
  background processes may be improved. D'Bridge may toss mail slower or
  be less responsive to system commands; with the exception of PSTN dialup
  sessions. PSTN dialup sessions are always assigned top priority CPU usage.

  Configuring a lower value implies that D'Bridge will use more CPU time
  (processing mail faster) but other applications and/or background-services
  on your operating system are allocated less time. If there only a few
  other applications running or D'Bridge is predominately the "only" program
  running then the value can be set lower.

  Most of you should leave the default value as it is. Note that technical
  support is not provided for operating system issues; and it is perfectly
  normal for CPU usage to "spike" occasionally.

  When the mailer calls certain functions, external programs or a DOS-shell,
  then this option has no effect since control of the session is returned
  to the command-processor (COMMAND.COM, CMD.EXE, 4DOS, etc) which is
  usually an OS-native executable.

  WARNING: Do NOT use programs such as Tame to control the CPU usage. These
           programs are known to cause serious problems with D'Bridge.

- The timeslice question should be left at its default setting for OS/2.
  OS/2 has very comprehensive "slice" options for DOS programs and even the
  default settings for DOS programs under OS/2 is sufficient. When using
  Ray Gwinn's SIO replacement drivers for dialup modems, a D'Bridge setup
  runs very efficient and "plays nice" with other programs on OS/2.

- The Auto-Poll feature in the Scheduler has been slightly corrected to
  resolve a possible "file left open" problem that may creep up and cause
  problems elsewhere, when the mailer is left running unattended for long
  periods of time (weeks, months)

- Fixed a problem where under rare circumstances, D'Bridge would not save
  the COMM/MODEM settngs properly. Note that as per the beginning of this
  document, it may be necessary to reconfigure/adjust the settings in
  the COMM/MODEM setup screen after upgrading from a prior version.

  If you upgrade and D'Bridge does not start, then erase the COMM.* files
  and try starting it again. Reconfigure your PSTN dialup modem in the COMM
  MODEM setup screen again. The settings will be properly saved for future
  versions.

  The same step applies if you are downgrading to 3.64 or a prior version.

- Cleaned up some redundant things when D'Bridge is ran in a "Multi-line"
  configuration.

- The lastread pointers for QuickBBS and GoldBase were slightly corrected
  and adjusted to resolve a small problem that comes up over a period of
  time when large amounts of messages are stored.

- Very minor cosmetic corrections done to the way BinkD transactions are
  displayed.

- A very minor problem relating to the behavior of Areafix requests destined
  for Usenet has been fixed.

- A minor logic-handling problem was fixed with Areafix.

- The semaphore delay-checking code for Areafix requests destined
  for Usenet has been increased.

- Cleaned up the appearance of some setup screens.

- Minor adjustment to the way "Forward-to" systems are added to Echomail
  Areas.

- Added a few "sanity checks" to some of the D'Bridge setup questions and
  commands... since Murphy's law is that newcomers can (and do) crash things
  or do things I would not expect.

- Changed some very minor delay timing in the outbound-call logic.

- It is now possible to abort an Areafix request destined for a Usenet
  gateway (rewriting USENET.BBS and NEWSRC files), since large requests
  may take a significant amount of time to complete.

- Pretty sure I solved the random problems with BinkD domain settings
  not importing properly from 3.64 or prior versions.

- Corrected a cosmetic "bug" in the VIEW QUEUE ENTRY command, when a Queue
  entry no longer exists the mailer no longer merely shows the nodelist
  info and its no longer necessary to display the "Phone/baud" field
  on a BinkD transaction.

- Fixed where in some conditions, running D'Bridge normally then exiting and
  running DB SETUP, then exiting and doing this over and over again for
  dozens of times in a row would crash the system.

- Slightly revised the code for automatic checking of D'Bridge updates.

- I can't even begin to count the numerous things cleaned up in the code
  as a result of all of these changes.

A lot of hard work and countless hours went into programming 3.7. It is my
hope that it was "worth the wait" for you.

Enjoy,

Nick Andre
www.net229.org



VERSION 3.64 - JULY 31 2011
---------------------------

This is a very minor release which addresses some issues with QuickBBS and
GoldBase. It resolves certain problems when Echomail areas are auto-added to
the configuration and when unpacking messages when Netmail storage is NOT in
the QuickBBS/Goldbase format. The "Database path" question in the Directory
Paths screen works slightly different.

Various problems with the internal message editor in the GoldBase edition
have been resolved.

Nick Andre
www.net229.org



VERSION 3.63 - JULY 12 2011
---------------------------

WARNING: Be prepared to rollback to 3.62 or prior if this release does not
         perform as expected.

This is a minor release of D'Bridge which has a completely redesigned and
rewritten DBUTIL program.

For newcomers, the DBUTIL program is the command-line utility which controls
Queue entries, manipulates D'Bridge Queue entries into FTSC/FTN-compatible
filenames (*.PKT and ArcMail), sorts the Echomail database and purges old
messages. DBUTIL can be used in a variety of ways to automate or control
various aspects of the Queue and mailer. So, this release deals specifically
with that utility program.

The main reason for rewriting DBUTIL was for reliability reasons when DBUTIL
is being run repeatedly in a complex batch file or a batch that makes
complex use of the CALL or FOR-nesting directives. DBUTIL was also rewritten
to properly support and conform to standard console redirection in DOS;
something which was unreliable in 3.62 and prior.

This DBUTIL also removes various dependancies in the source code. In
addition the performance gain from the more efficient codebase results in
much faster operation.

Careful attention to detail was made for every DBUTIL function and all were
tested thoroughly in a few different scenarios. However please test this
release in another directory if possible before upgrading; especially if you
are a network co-ordinator or major "Hub" system.

The following DBUTIL commands have been depreciated/removed:

- DBUTIL PROCESSWEB to create websites from message areas. This command is
  being revised for a future release.

- GUI (or no parameters); global editing can be done via other means
  instead of re-inventing the wheel by writing another editor.

- AUTOASSIGN; the same function is accomplished with DBUTIL CHANGE.

- BACKUPMAIL, CFGFIX, DELETEAREA, DELETEINSIDE, DROPTHEBOMB, DROPTHEBIGBOMB,
  EMAIL, NAME, REPAIRADF and RENDATE commands are gone.

Differences from prior versions of DBUTIL:

- The error-checking and way it handles problems no longer pauses or halts
  the console session on Windows operating systems.

- A rare but serious stability bug was resolved when running it on Windows
  operating systems.

- DBUTIL REMOVEDEADECHOS no longer un-Areafixes an area from the uplink. The
  command only removes the areas from the Echomail database. As per the
  documentation, the areas deleted will be logged to a seperate file
  called NUKEECHO.LOG. You would then use this file in conjunction with
  manaully un-Areafixing the areas from your uplink. This change was done
  for reliability and stability reasons.

- DBUTIL REMOVEDEADECHOS does not use the semaphore files as per help
  section 7.00 in prior versions of D'Bridge. It is implied that by using
  this (somewhat destructive) command, you know what you are doing.

- The GROUPACCESS option in DBUTIL CHANGE and DBUTIL DELETE has been changed
  to AREAACCESS (ie. DBUTIL CHANGE AREASECURITY 5000 AREASECURITY 25)

- DBUTIL now purges, renumbers and sorts Echomail areas approximately 300
  to 400% faster than before; depending on the speed of your computer.

- DBUTIL no longer purges the LASTREAD pointer for the NETmail area. This
  is only temporary; some 3rd party utilities, InterBBS games and so on may
  have problems when the LASTREAD pointer file is purged.


- PURGERENUM does not renumber messages in the NETmail area for the reasons
  explained above.

- It is not currently possible to renumber messages in Hudson and GoldBase.
  To do so would require an extensive amount of code; and the design of
  those two storage formats calls for "recycling" empty database records.

- The DBRIDGE.RSN file is created to tell the mailer to rescan the NETmail
  directory whenever messages have been purged from that area; thus
  resulting in a Queue-scan. When the Queue is rescanned, note that any
  temporary holds, limits, etc for a system are reset.

- DBUTIL no longer logs operations and no longer makes DBUTIL.LOG. The dummy
  semaphore files DBUTIL.NLG and DBUTIL.DLG are depreciated. The option to
  purge DBUTIL logs has been removed from BASIC SETUP. If you wish to have
  logging to file, you will need to run DBUTIL redirected to a file of your
  choice, ie. DBUTIL PURGE > MYLOG.TXT

Minor fixes to the mailer:

- Help section 7.00 was slightly rewritten.

- The "Route Areafix receipts" feature has been slightly revised, and the
  onus is more on the requesting system to request areas properly rather
  than the host/hub system.

- The installation screens and questions for newcomers were slightly re-
  worded and revised to make it sound less confusing and less "techie".

- A minor cosmetic bug in BASIC SETUP made it confusing for newcomers to
  enable the screen-saver parameters.

- A minor cosmetic bug was resolved when displaying the outgoing session
  information for a system which has a PSTN dialup line but is overridden
  by the BinkD configuration.

- The VIEW QUEUE ENTRY command in the mailer now displays the staging
  directory if the Queue entry is a BinkD system.

- It is assumed that most of you are using the Standard Edition, so the "s"
  and "g" designations in the mailer have been removed.

- A completely revised README file was done for this and future releases at
  the request of some of you, to better explain installation requirements
  and preparing for deployment.



VERSION 3.62 - JUNE 4 2011
--------------------------

This is a very minor release which slightly improves the performance and
turnaround of PSTN dialup modem connections. It also resolves an
unnecessary "phone off hook" operation when doing a BinkD transaction.

Nick Andre
www.nickandre.com




VERSION 3.61 - MAY 6 2011
-------------------------

This is a very minor release which corrects some appearance/cosmetic
problems which happen when D'Bridge is tossing mail on drives with low disk
space. The XMAIL status bar on the bottom of the mailer also threw a nice
little division-by-zero error several times per second that nobody would
notice... because the screen updates so fast that its overwritten instantly.

Note that the tosser has a predetermined "threshold" when it comes to disk
space. When disk space falls below a certain percent of the total size of
the partition, the tosser packs XMAIL bundles a lot more frequently when
unpacking Echomail. This is to conserve as much space as possible.



VERSION 3.6 - APRIL 23 2011
---------------------------

WARNING: When upgrading from a prior version, D'Bridge may prompt to execute
         overdue events. CANCEL this operation if prompted.

WARNING: This release changes the behavior of BinkD "mailbox directories".
         DO NOT UPGRADE TO 3.6 FROM A PRIOR VERSION UNLESS MAILBOXES ARE
         ALL EMPTY FIRST. This is explained in detail below.

This release may not seem like much, but behind the scenes a lot of code was
rewritten, reorganized or otherwise cleaned up for efficiency. A lot of
stuff that was originally written years ago but never finished has been
removed forever - such as fax support, 5D-domains, multiple open COM ports,
and so forth. Those things were started but never finished; and the code
just takes up memory. By eliminating that, the end result is a mailer that
uses less memory and code to accomplish common tasks. D'Bridge will now run
in 384k as opposed to needing a full 640k memory.

All of this may sound trivial to newcomers but for those of you who have
followed my work over the years understand how complex D'Bridge really is
and that every single byte, opcode, variable or procedure I can shave off
that code makes a world of difference. I now have more memory to fix
longstanding problems or add little "nice to have" features here and there.


NO MORE BINKD MAILBOXES
-----------------------

A lot of work was done in further simplifying BinkD. After careful studying
of the code and meticulous use of system memory, BinkD transactions are now
much more integrated and handled more dynamically than before.

D'BRIDGE 3.6 WILL NOT PROPERLY UPGRADE AN EXISTING INSTALLATION until the
packets in all of the mailboxes are sent out. When the mailboxes are
emptied, then you may upgrade your system. It will NOT automatically remove
the old mailboxes. The "Base Directory for Mailboxes" question is also gone.

WARNING: ANYTHING on your system or BBS that was dependant on the mailbox
         structure of 3.59 SR6 or prior, will need to be revised or changed.

3rd-party utilities or attempts to copy mail into mailboxes will fail. Note
that DBUTIL MOVE is still supported and will work as before. The above
change is strictly related to the way D'Bridge manages the staging of mail.
It is not necessary to change the way your system operates if you are using
the DBUTIL MOVE in some sort of advanced setup.

BINKD PASSWORDS MOVED TO SECURITY/MISCELLANEOUS SCREEN
------------------------------------------------------

You no longer specify BinkD session passwords in a seperate screen from
passwords used for PSTN dialup mail. You now specify them in the SECURITY/
MISC SCREEN.

When upgrading from 3.59 SR6 or prior, D'Bridge will "move" the passwords
out of the BINKD SESSION INFO screen and into that screen.

So... with everything I explained above, whats left of BINKD SESSION INFO
you may ask? Just the Fido address, domain, and IP/hostname. Optional
parameters are the BinkD TCP port and "U" for Uncompressed mail.

Example: 1:229/426 fidonet bbs.darkrealms.ca

The help file / manual has been updated accordingly.

QUICKBBS
--------

A long neglected problem has finally been solved and that is QuickBBS and
GoldBase systems (MSG*.BBS and MSG*.DAT formats). D'Bridge is now released
in two different versions - STANDARD EDITION for regular *.MSG and QuickBBS
support and GOLDBASE EDITION for BBS software that stores mail in GoldBase
format. The QuickBBS and GoldBase code has been tested and works with no
problems, in all operations, editor modes, etc. Any newcomers that decides
to store mail in that format as opposed to *.MSG can do so.

The reason this was done, is because another goal in this project was to
preserve, as much as possible, the originality of D'Bridge and in how
it was designed and released. It may not be important to the vast majority,
but anyone who installs D'Bridge and finds one thing broken may be swayed
away from trying any future version or even reporting the problem for
that matter.

I know what most think of that format and so I added several "safeguards"
to check and ensure consistancy of those database files. Personally I think
it is an okay format to use for very small D'Bridge systems that only have
a few echos or for older computers. 

OTHER
-----

This release also creates a semaphore/dummy file when mail is processed...
called DBRIDGE.PTM (short for Processing The Mail) and is erased when all
mail is finished tossing. This allows those of you who run custom batch
files to have a way to check when D'Bridge is idle.

The installation for newcomers should have all of its ongoing problems fixed
for good now.

Nick Andre
www.nickandre.com



VERSION 3.59 SERVICE RELEASE 6 - APRIL 2 2011
---------------------------------------------

This minor release slightly improves performance when D'Bridge has a large
amount of Queue entries with combinations of BinkD and dialup transactions
pending, along with XMAIL and file-attachments. 

Right off the bat this release changes the behavior of BinkD overrides. When
upgrading from 3.59 SR5 or prior, BinkD Queue entries immediately become
"Hold/Unlisted" if the system is not in any nodelist, irregardless of you
defining them system in BINKD INTERNET SESSIONS. You must manually define
actual nodelist entries for them. You may add these to a file called
DBNL.AUT (short for D'Bridge Automatic Nodelist). Recompile the nodelist and
those Queue entries will send out properly as before. The DBNL.AUT entries
can be like:

        ,1:322/999,Some_BBS,Somewhere,Some_Sysop,000-0-0-0-0,9600
        ,618:100/44,Some_BBS,Somewhere,Some_Sysop,000-0-0-0-0,9600

Note that full "4D" addresses are used in the second field in the DBNL.AUT
file. This is the only time-and-place where you may use 4D addressing in
a nodelist field. Regular nodelists in D'Bridge may NOT use 4D addressing.

Obviously, making this file is not the proper solution - you should contact
the proper individuals regarding why that system is not listed.

What might seem like a major change, in fact is very minor and trivial and
helps newcomers understand some things about running a compliant system in
all aspects. That means that if a system is not listed in a nodelist of
some type, it is not possible to send mail to that system. After all... if
a nodelist wasn't of some importance then we'd all be on QWK networking.

Note that when D'Bridge is used as a "hub", especially in large setups, it
may be beneficial to use Info-Zip's ZIP/UNZIP package as opposed to the
default Pkzip/Pkunzip. Performance of D'Bridge on modern computers such as
dual and quad core CPU's is significantly improved when using the Info-ZIP
utilities and you are tossing large volumes of Echomail.

Other corrections:

- A "QueueUpdate" cycle should no longer momentarily spike the CPU usage on
  all Windows computers or environments.

- The ECHOMAIL HISTORY screen no longer has the cosmetic "Undefined area"
  instead it says No Description if one cannot be found.

- The help screens for the COMM/MODEM SETUP screen were slightly revised
  to make it a tad less "intimidating" for newcomers who need help in
  configuring a dialup modem with D'Bridge. Maybe the help system should
  be removed entirely so the DBRIDGE echo gets more traffic?

- In the very rare event that someone wants to use it, the ClockSync code
  has been revised slightly for dialup modems. D'Bridge will contact
  the time laboratory at the National Institute of Standards & Technology
  in Boulder Colorado to synchronise the computer clock.

- To answer a question that hasn't been asked, if by chance a ClockSync was
  done when running D'Bridge under Windows, the computer clock WILL be
  changed (except if D'Bridge is running on an OS in a Virtual Machine)

- A minor issue with the startup code was revised.

- A minor fix was done when checking for new software updates.

- A very minor cosmetic fix was done to the "Outgoing Session" screen.

- The SCAN FOR AREA command in Config - ECHOMAIL AREAS now displays the
  type of storage for the Echomail area.

- When using the SCAN FOR AREA feature in Config - ECHOMAIL AREAS, the
  current message area is now remembered properly.



VERSION 3.59 SERVICE RELEASE 5 - MARCH 18 2011
----------------------------------------------

This is a very minor update which addresses a possible long-term reliability
issue in the internal tosser; when D'Bridge is tossing large volumes of
Echomail per cycle.



VERSION 3.59 SERVICE RELEASE 4 - MARCH 8 2011
---------------------------------------------

This is a very minor release which corrects another issue reported when
D'Bridge runs under the DOSBOX environment (0.7.4). Note that at this point
there is really nothing else that can be done to the mailer for DOSBOX
operation; therefore unless its a serious operational flaw I will no longer
handle anymore DOSBOX issues. That product was designed to run games,
not Fido mailers or BBS software.

In addition, another semaphore/dummy file can be made to control the probing
of COM ports. Making the dummy file DBRIDGE.DPC (Don't Probe Com ports) and
the mailer will no longer attempt to determine the port/modem settings.


VERSION 3.59 SERVICE RELEASE 3 - MARCH 4 2011
---------------------------------------------

This is a very minor release which ensures compatibility with DOSBOX 0.72.



VERSION 3.59 SERVICE RELEASE 2 - FEBRUARY 25 2011
-------------------------------------------------

WARNING: Prior to upgrading to this release; shut down the BinkD module if
         it is currently running.

This is a very minor release which addresses several issues with the BinkD
module. This release also corrects the default timer values in the
configuration of BINKD SESSIONS. In addition:

- The problem with "Domain is busy", "Too many servers" (even though the
  maximum server setting is set properly) and flooding the log file with
  "possible errors" should be all fixed now.

- The question "Use the BINKD.TXT file?" has been removed. D'Bridge will
  only use that file if it is present in your DB directory.

  NOTE: Any time that the files status has changed, ie. you put it there,
        or you remove it, you must shutdown and restart both D'Bridge and
        the BinkD system if running.

- The default cost table (for dialup modems) was not being set up properly
  for newcomers who install D'Bridge for the first time. This has been
  corrected now although the newcomer must specify their area code to place
  local dialup calls to another system; as is the case with other mailers.

  WARNING: When changing any Cost table entries and there are BinkD entries
           in the Queue, a "Decision" hold may be placed on those entries.
           This hold will automatically be removed at the schedule time.
           Ensure there are no Queue entries prior to changing Cost entries.

- The problem of having a cost table defined and a large amount of BinkD
  queue entries waiting producing a "Decision" Queue status has been fixed.



VERSION 3.59 SERVICE RELEASE 1 - DECEMBER 27 2010
-------------------------------------------------

This is a very minor release of D'Bridge 3.59 which changes the default
policy of how Fido Plug and Play works. Around a dozen minor corrections
were made along with changes to the way automatic updates works
with nickandre.com.

Nick Andre
www.nickandre.com




VERSION 3.59 - DECEMBER 21 2010
-------------------------------

This very minor release corrects the following:

- As per recent events in a certain echo, the INTL message kludge is no
  longer an option.

- Removed various references to DBUTIL MOVE in the code; and replaced them
  with a much more integrated approach. This has also shaved off a lot of
  overhead in certain areas.

- Resolved an issue with DBUTIL MOVE creating filenames starting with the
  dash character (-).

- Eliminated the use of M- control files. These can be deleted permanently.

- So from now on, the only things that should be in the Queue directory are
  Queue entries.

- Removed a very rare but possible loop-condition in the Queue re-scan code.




VERSION 3.58 - DECEMBER 10 2010
-------------------------------

This may be the last release of D'Bridge until sometime well into next year.

This is a minor release which has the following done:

- A major problem with D'Bridge randomly locking up the entire keyboard on
  a Windows 2000 computer and thus not responding to CTL+A, CTL+C or ALT+X
  (thus forcing the user to forcibly-terminate the DOS session) was fixed.

- A slightly revised stream was implemented in the Nodelist compiler for
  entries which make (over) excessive use of the Internet flags such as IBN.

- A somewhat-serious reliability issue was resolved; with the way that
  D'Bridge moves mail into mailboxes for Internet BinkD sessions. If
  a downlink exchanges mail with you via Binkd, then the mailer will
  automatically switch to Uncompressed packets if the number of XMAIL bundles
  exceeds 36 in a day (0 to 9, A to Z). It also kicks in when the downlink
  has not picked up their mail in quite some time and D'Bridge needs to
  store XMAIL in the mailbox directory that has the same filename. This is
  not a counter-check, but an actual file-check to verify this condition.

  NOTE: This does not affect PSTN sessions (EMSI, WaZoo, FTS-0001) because
        the naming of files is processed in a totally different manner.

  NOTE: If you switch a system from Internet BinkD to PSTN dialup, and there
        is mail leftover in the mailbox directory, simply use the ALT+T
        command in the mailer to transmit/send that leftover mail.

- D'Bridge is smart enough to revert back to compressed XMAIL packets in the
  above scenario when the donlink has picked up the mail bundles with those
  conflicting filenames. (But checks against the "U" setting in BinkD)

- The XMAIL CONTROL screen also has a new option to control the cycle-delay
  for uncompressed packets. This means that if the XMAIL cycle-delay option
  is used to stop D'Bridge from always uncompressing/tossing mail, then this
  rule would now apply to raw .PKT files. (The default behavior is not to
  use a cycle-delay or apply that rule to uncompressed raw .PKT files)

- A possible infinate-loop condition was corrected in the outbound Echomail
  scanner.

- A possible infinate-loop condition was also removed from the COMM/MODEM
  SETUP screen when D'Bridge probes the dialup modem you specify and then
  you change the COM port or IRQ setting by up-arrowing your way back.

- And yet another possible infinate-loop was removed out of the kernal when
  an operation completes and there is a problem executing the nightly Auto-
  Update event.

- Removed the health graph, entirely. It is not coming back and there were
  valid reasons as to why I did this.

- Removed Fido Plug and Play because its going to be rewritten from scratch
  to only automatically obtain addresses from 1:1/130 temporarily.

- Removed the entire cell phone / Emailing code because its going to be
  rewritten from scratch now that I have decided on a much more streamlined
  and efficient way to do that. (Scheduled for 3.59)

- Removed the use of the AFIXCTRL directory. You may delete that directory,
  it is located in your Queue.  

- Removed a lot of unnecessary debugger code and old stuff commented-out
  since version 2; and cleaned up a lot of structure.

- Overall mailer startup and shutdown times should be faster now.



VERSION 3.57 - NOVEMBER 21 2010
-------------------------------

This is a very minor release of D'Bridge that hopefully should fix the
forwarding issue for NETmail as reported - it works fine here. Some other
minor, almost trivial things were fixed.

I may not reply to NETmail or personal Email on a timely manner. Please
direct all support inquiries to the DBRIDGE echo first if possible. This
system has been on "auto pilot" for a long time as personal matters take
priority.

I appreciate everyones continued support and understanding.

- You may now create a dummy/semaphore file called DBRIDGE.REA (short
  for Remove Echo Area), which contains the default answer to the question
  "Remove Echo area?" in the ECHOMAIL AREAS screen. Rather than being
  prompted every time, this lets you save your choice. For example, if the
  file contained the letter U (for Unlink), D'Bridge will automatically
  unlink the Echomail areas after deletion without prompting first.

  WARNING: Use this file with caution. Back up all message forums and
           databases prior to using this feature.

- I have began to simplify, more or less, the format of the DBRIDGE.PRM file
  for 3rd-party developers. Jim Diel has written a good utility which will
  produce D'Bridge reports of mailbox activity and subsequently those can
  be sent via Internet Email. I get these emails every morning like
  clockwork. As time goes on I hope to eventually replace the DBRIDGE.PRM
  file entirely and just go with the format of the IMPORT / EXPORT commands
  as those are about as "plain English" as you can get.

- The Health-graph feature has been rewritten and enhanced to show a plain-
  English statistics line, showing total calls (data and voice), Echomail
  messages processed and forwarded.

- Several dozen miscellaneous cosmetic/appearance problems were fixed.

- A new question in BASIC CONFIGURATION, lets you specify if you wish to
  have incoming voice calls logged. In prior versions those calls were not
  logged properly unless the logging level was set very high (Verbose/Debug)

- A new question in PACKET/MAIL CONTROL lets you enable special log file
  support for 3rd-party / BBS software processing. Some software can make
  use of log files that tell it exactly which Fido *.MSG directories have
  messages files in them, rather than scanning every directory. D'Bridge can
  now create ECHODIRS.LOG and SCANDIRS.LOG, respectively, of what mail has
  been tossed and what it should scan. This feature was written to cut down
  on disk-access and usage when there are hundreds if not thousands of
  areas in your configuration.

- Chris is doing good and is busy with work and personal matters as well.

Nick Andre
www.nickandre.com




VERSION 3.56 - OCTOBER 11 2010
------------------------------

This is a very minor release which should correct a reported problem with
the sender/destination in the NETmail forwarding feature. Since this is a
fundimental change to the way the editor works, it is recommended that you
upgrade to this version if you are using 3.55 or prior and you use the
internal message editor (ie. not a BBS or 3rd-party editor)

Also there is a reported problem with the Fido Plug and Play (auto-
addressing) feature; whereas it may time out when connecting to my system
to obtain a list of FPNP systems or Echomail areas. If that problem happens,
please re-install D'Bridge and configure a Fidonet address and uplink
information manually - The nature of that problem is a little more involved
than I have time to devote to at the moment.


VERSION 3.55 - SEPTEMBER 15 2010
--------------------------------

This is a very minor release which was done to address an issue when you
are running D'Bridge as a major mail hub and many systems are connecting
simultaneously at once for mail via BinkD. A remote system connects to
yours and downloads hundreds of megabytes of mail waiting; meanwhile
D'Bridge is busy tossing mail and more mail for that connected system. The
system performance would suffer and CPU usage "spiked" when the mailbox
contents were updated for that connected system.

My time does not allow me to do very much work with D'Bridge. Rest assured
however that the 3.6 release has not been forgotten.

Nick Andre
www.nickandre.com



VERSION 3.54 - MARCH 7 2010
---------------------------

This is a minor release which adds a minor function when the "Inbound Mail
Handling" question is answered "External". If new mail arrives, it will
create the semaphore defined in "Semaphore" question that follows. The
field was also adjusted to allow a larger pathname.

To activate this feature, create a dummy/semaphore file called "DBRIDGE.EXT"
in the DB directory.



VERSION 3.53 - MARCH 6 2010
---------------------------

This very minor release only has various internal code cleaned up. The
default log level on new installations is "Verbose". When DB TERM exits,
it no longer jumps back to the SETUP screen. No other changes were made in
this release.



VERSION 3.52 - FEBRUARY 27 2010
-------------------------------

This is a very minor release which has the following changes:

- The reporting of "New mailbox entries" is disabled now by default and can
  be enabled again by making a dummy/semaphore file called DBRIDGE.NMM.

- A portion of the kernel was rewritten slightly, to address "Lock Queue"
  and the "Unlock Queue" problems.

Nick Andre
www.nickandre.com



VERSION 3.51 - FEBRUARY 14 2010
-------------------------------

WARNING: You must shut down the BinkD system, if it is running, prior to
         upgrading to this version.

This is a very minor release which should resolve the issues of having
Fido "nets" (FTN's) with domains in BinkD longer than 8 characters.

No other changes were made in this release.



VERSION 3.50 - FEBRUARY 9 2010
------------------------------

WARNING: This is an important release and should be treated as a CRITICAL
         upgrade for your D'Bridge system. Please back up system settings
         via the DB EXPORT command prior to installing. Please review these
         release notes carefully.

WARNING: You must shut down the BinkD system, if it is running, prior to
         upgrading to this version.

A very serious fundimental flaw with the BinkD system existed in 3.49 and
prior versions. This release corrects that problem, as it was mailer-
related. It also upgrades the BinkD module to address some other minor
problems.

Its not just BinkD that is addressed in this release. Some minor PSTN
dialup stuff has been slightly rewritten but more to improve the overall
"hybrid" nature of how D'Bridge handles both BinkD and PSTN transactions.

- The big problem in question relates to the way the BinkD system moves mail
  into mailboxes. A certain condition would cause either a duplicate entry
  to be made in the Queue, or the mail not be moved at all. That has been
  corrected in this version. In addition, a test was done to ensure that
  PSTN dialup still functioned correctly after the fix was made in this
  release (FTS-0001, WaZoo and EMSI) and before this release was posted
  to my website.

- The logic behind having both a PSTN dialup and a BinkD connection active
  in D'Bridge has been slightly adjusted so that if you define a PHONE
  NUMBER OVERRIDE in the NODELIST CONFIGURATION screen, that takes
  priority over the BINKD criteria. So what that means is that D'Bridge
  will NOT move mail for the BinkD system into the mailbox. It will keep
  the mail in the Queue for the outgoing PSTN call (EMSI/Wazoo/FTS-0001).
  And of course, having FORCED PRIORITIES in the PACKET/MAIL CONTROL screen
  takes priority over everything, including "Forced Hold" status. This
  change keeps D'Bridge within its original "flow" of how the Queue works.

  The above change in the logic, also makes it possible to have mail waiting
  for a PSTN system to poll you for picking up mail if you place everything
  on the above-mentioned "Forced Hold" status. You can also then run an
  event which would cycle the mail for the PSTN system into their BinkD
  mailbox whenever you want.

- The PHONE NUMBER OVERRIDE command was broken, now its fixed and works
  the way it should. The display of a Queue entry now properly displays
  the proper phone number if an override command is issued.

- Note that whenever "override" criteria is defined in the NODELIST
  CONFIGURATION screen such as phone numbers, synonyms, baud rates or
  flags, you should rebuild the nodelist database (UTILITIES -> BUILD
  NODELIST) or create a dummy/semaphore called DBRIDGE.FNC. The nodelist
  database is NOT recompiled automatically incase a user mistake is made in
  that screen or you otherwise botch your configuration.

- This version updates the Windows BINKD module from version 0.9 to 1.00
  thereby solving some issues in that module. The OS/2 BinkD module
  for D'Bridge remains at 0.9 since I no longer have an OS/2 computer to
  test it out on. Voulenteers?

- Several minor corrections were made to the mailer's BINKD code when you
  choose to run the module as a "service" under Windows. Note that when
  you run BinkD 1.00 as a service, it is not recommended to "downgrade" the
  BinkD module to 0.9 or lower as this may cause problems.

- The BinkD system now reports the filenames it is moving into the mailboxes
  of the systems. It also reports if it is making uncompressed mail if
  the "U" parameter is specified in BINKD SESSION INFORMATION.

- Added a new command, DBUTIL DROPTHEBOMB to completely nuke all
  messages from all directories, lastread pointers and "hi water marks"
  except for NETmail. This was required for proper operation of tossing mail
  on the Searchlight BBS software.

- Introduced a time-slice in the PSTN Xmodem, Telink/SEALink and Zmodem
  code to not hog the CPU so much, this should improve performance when
  using VOIP or SIP software such as the MagicJack device for PSTN dialup.

- Fixed "Database error #200" in the NODELIST CONFIGURATION screen.

- Also fixed a possible "Database error #200" in the FUNCTION KEYS screen.

- Revised and rewrote a few sections of the online HELP system while I was
  at it.

Nick Andre
www.nickandre.com




VERSION 3.49 - FEBRUARY 2 2010
------------------------------

This minor release should address some reported video-corruption problems.

No other changes were done in this release.



VERSION 3.48 - JANUARY 26 2010
------------------------------

This version has a very, very minor correction to Areafix that caused it
to stop responding to requests under a certain condition.

No other changes were done in this release.



VERSION 3.47 - JANUARY 22 2010
------------------------------

This release adds an item counter (next to the free RAM display) to all
system windows. A vertical scroll bar is added when multi-line input makes
a window "scroll". The new feature defaults to Off (disabled). Turn it on
by going to CONFIG -> ADVANCED -> WINDOW/DESKTOP.

No other changes were done in this release.



VERSION 3.46 - JANUARY 18 2010
------------------------------

This is yet another minor release but it addresses two issues. I know I said
that I would only fix serious problems, but these two were very easy to do
and felt that it was important. First, the disk-swapping and CPU time used
by the BinkD module during mail transactions, has been eliminated. The
entire code was rewritten to not use DBUTIL to move mail anymore; instead
its all done internally. It may seem trivial but the improvement greatly
"streamlines" how D'Bridge operates. It is definately noticable when there
is a large volume of mail being processed by your D'Bridge system.

On that note, I'll reveal an "undocumented" command, DBUTIL MOVEQUIETLY,
which functions the same as DBUTIL MOVE except it does not display any
output or log entries. DBUTIL MOVEQUIETLY was what D'Bridge was "running"
in 3.45 and prior versions.

The second change was done in the XMAIL code; an addition of checking the
FTSC-naming on XMAIL archives was done. Archived mail destined for other
systems including those not running D'Bridge (ArcMail) have filenames
ending with a two-letter abbreviation of the current weekday, followed by
a number from zero to nine, then the alphabet, from A to Z. After 36 mail
transactions, the code makes sure the "counter" in DBRIDGE.HIS is set back
to zero. DBRIDGE.HIS is a database simply containing the proper filename
"extension" to make when sending XMAIL to another system as an ArcMail-named
file. The counter mentioned here resets automatically when the date changes
and it does not rely on the AutoUpdate event to do this.

When dealing with other BinkD systems, I strongly recommend the use of
the "U" parameter to tell D'Bridge to send uncompressed mail (the PKT files)
as opposed to regular XMAIL/ArcMail; since mail can "turn around" more than
36 times a day thanks to the "always on" nature of broadband Internet. Also
make sure that the "session limits" value in the SCHEDULER -> UN-EVENT is
also adjusted accordingly.

The BinkD module already has a "built-in" file-renaming procedure in the
event that duplicate Fido mail is received... but we can trust the Russians,
right?

Nick Andre
www.nickandre.com


VERSION 3.45 - JANUARY 14 2010
------------------------------

This minor release corrects another rare but serious "lockup" condition
when your D'Bridge system is processing large amounts of mail. This
condition was caused by a large mixture of *.PKT and Arcmail/XMAIL bundles
in the INBOUND directory.

Another very complex, elaborate module of code that I had written 2 years
ago was slightly adjusted to prevent the gathering of statistical data from
tying up CPU usage. The problem happened when there was a large amount of
BinkD traffic being handled by your system and the size of the log files
were megabytes in size.

Note that at this point, I'm only going to try to fix what I consider to be
serious problems in the software... though I seriously doubt theres any more
problems like as per above. Reading the HISTORY file will give you an idea
as to the amount of work that has gone into a DOS product and that its time
to move forward.

No other changes were done in this release.

Nick Andre
www.nickandre.com



VERSION 3.44 - JANUARY 4 2010
-----------------------------

This is a very minor release which improves the performance of certain
Areafix conditions involving a Usenet/NNTP gateway.

No other changes were done in this release.

Nick Andre
www.nickandre.com


The following document is a "timeline" of D'Bridge development and history,
starting from most recent all the way to the earliest notes I could find.
Please note that this is not exactly 100% accurate and any corrections
should be sent to me directly. - Nick Andre.

VERSION 3.43 - DECEMBER 13 2009
-------------------------------

This minor release adds support for Info-Zip's "ZIP" and "UNZIP" programs,
as documented on www.info-zip.org. In addition, each of the questions in the
XMAIL SETUP SCREEN have been updated to allow for mixed-case parameters for
the programs.

Info-ZIP may be desirable over the default "PK-ware" if your D'Bridge system
is being used to hub a lot of mail to other systems.

If you decide to use Info-ZIP's programs in place of the PK-ware, ZIP.EXE
requires the "-mj" parameter (dash, lowercase m, lowercase j). -mj means
move the Fidonet *.PKT files into a ZIP file and strip the full pathnames
out of the mail bundle. UNZIP.EXE only requires "-j" (dash, lowercase j), to
strip the full pathname when extracting a Fidonet mail bundle.

If you wish to have Info-ZIP run in a "window" inside of D'Bridge, then do
not use the plus-sign (+) before the programs; otherwise if you do, then
D'Bridge will run them "full-screen" as it does with PK-ware.

Also note that D'Bridge still ships with and installs PKZIP and PKUNZIP by
default to your DB directory. You must obtain ZIP and UNZIP on your own
if you wish to use those programs instead of the default PK-ware programs.

Support for Info-ZIP may not function correctly on the OS/2 operating
system and on Linux it is recommended to stick with PK-ware under DOS
emulation.

No other changes were done in this release.

Nick Andre
www.nickandre.com

VERSION 3.42 - DECEMBER 5 2009
------------------------------

This very minor release corrects two long-term stability problems - one
with the start of a mail tossing session with thousands if not tens of
thousands of packet files waiting. The other problem was in regards to
"syncing up" the log files when BinkD is ran as a service (or seperate
process) and D'Bridge itself has not been ran for lengthly periods of time.

No other changes were done in this release.

Nick Andre
www.nickandre.com



VERSION 3.41 - NOVEMBER 13 2009
-------------------------------

This is a very minor, almost trivial release. Less than six lines of code
were changed in the D'Bridge kernel for a slight performance improvement.
No other changes were made in this release.




VERSION 3.40 - NOVEMBER 9 2009
------------------------------

This minor release corrects a possible "lockup" condition in the COMM/MODEM
HARDWARE screen. A very minor tune-up was also done to the D'Bridge kernal.
No other changes were made in this release.



VERSION 3.39 - OCTOBER 28 2009
------------------------------

WARNING: If you are upgrading from 3.37 or prior, please review the notes
         in HISTORY.TXT for 3.38.

This is a very minor release which corrects a possible long-term reliability
problem with the way large volumes of Echomail processing are accounted for
in the system log file. No other changes were done in this release.

Nick Andre
www.nickandre.com



VERSION 3.38 - OCTOBER 25 2009
------------------------------

After a short hiatus, I looked at the source code, tested something and sure
enough, another problem. This is a very minor release that corrects a rare
but serious fundimental problem with DBUTIL SORT AREAS, DBUTIL PURGE, DBUTIL
REMOVEDUPEDATABASES, DBUTIL SHOWDEADECHOES and DBUTIL REMOVEDEADECHOES. This
release shall be treated as a "critical" update for your D'Bridge system.

When DBUTIL runs, several checks are done against your setup to ensure that
any database modifications run trouble-free. A very serious problem with the
logic behind the Echomail "database integrity" check was resolved. Under one
rare but possible condition, it was apparent that DBUTIL was removing
perfectly valid Echomail areas out of your configuration and possibly
causing corrupt entries towards the end of the DBRIDGE.ADF database file. If
those missing Echomail areas was added again automatically by D'Bridge,
further corruption was possible.

The corruption evident in the problem in 3.37 and prior can be used
maliciously; since the security settings are often corrupt. For example, an
affected system could have downlinks Areafixing themselves to areas to which
they should not have access to.

Therefore, even if your D'Bridge system has no problems; it is strongly
recommended to upgrade to this release. If that is not desirable then
install this release in a seperate directory and manually copy over the
DBUTIL.EXE file to your current installation. An effort was made to ensure
backwards-compatibility with this fix with prior versions. This is really
the only time I would ever recommend this approach; only because the problem
is isolated to one "module" of code rather than the entire mailer.

I am not disclosing in this echo exactly what caused the "failed check" in
3.37 and prior - since that can be potentially used as both a security and
reliability exploit for existing systems. But rest assured that although
its serious, its very rare that anyone cares enough to try to hack another
system in Fidonet. Fido's dwindling numbers makes it possible to fix things
without mass-panic; I can only imagine if this problem happened during the
"glory days" of BBS'ing. So, be thankful for the low membership numbers of
this net (yet, please keep this net going with the usual FIDONEWS banter)

While I appreciate that there are those of you who follow my work
closely, I strongly recommend that you DO NOT allow prior versions
of D'Bridge for download on BBS's or websites. At the very least, explain
to the user to check for updates on my website first, before installing.
Newcomers to D'Bridge are strongly advised against installing any version
of D'Bridge 3.37 or prior and it is recommended that the "Notify when new
updates are available" setting be kept enabled.

I may not be participating in Fidonet as often as I (probably) should; so
any serious problems with D'Bridge please contact me via Internet Email
to nick at nickandre dot com.

I will not address the recent rumor-mill. What fun would that be? It is fun
to think, however, that it never occured to anyone that any downtime may in
fact be intentional. You know, just to see what happens when I deny certain
downlinks their daily dosage of important, educational, fair, balanced,
honest, life-imperative-that-you-always-participate-in echoes like Z1C,
FIDONEWS, FIDOGAZETTE, FTSC, and ALT.SEX.FETISH.ROBOTS. Uhh wait... I think
only one of those was ever really important. (Those offended should realise
that the sassy robot from Short Circuit needs love and affection as much as
your reliable Linux system needs my Inbox to know about it)

Nick Andre
www.nickandre.com


VERSION 3.37 - OCTOBER 12 2009
------------------------------

This minor release should correct reported excessive CPU utilization under
Windows 2000 and higher, including Vista and Windows 7. I say "should"
because its all relative to the number of other programs running at once
notwithstanding the speed of the CPU.

Nick Andre
www.nickandre.com



VERSION 3.36 - SEPTEMBER 18 2009
--------------------------------

NOTE: If you are upgrading from 3.31 or prior, please review HISTORY.TXT for
      the notes for 3.35 and previous versions.

This is a very, very minor release which corrects the display of personal
messages received from Wildcat, TBBS and any other systems which produce
mail with uppercase FROM fields. No other changes were done in this release.

Nick Andre
www.nickandre.com





VERSION 3.35 - AUGUST 15 2009
-----------------------------

NOTE: If you are upgrading from 3.31 or prior, please review HISTORY.TXT for
      the notes for 3.32, 3.33 and 3.34 first.

This is a very minor release which corrects a fundimental problem with
the purging of the BinkD log file. No other corrections were done in this
release.

Nick Andre
www.nickandre.com




VERSION 3.34 - AUGUST 5 2009
----------------------------

NOTE: If you are upgrading from 3.31 or prior, please review HISTORY.TXT for
      the notes for 3.32 and 3.33 first.

This is a very minor release which corrects the following:

- Another problem with the Areafix for NNTP has been fixed and all functions
  in that now appear to work properly as they should.

- When upgrading from now on, custom junk-filters defined in the JUNK*.CFG
  files are no longer overwritten. Instead, those files are now in the file
  called JUNKCFGS.ZIP.

- A minor problem with DBUTIL SORT AREAS has been fixed. It was not a
  stability problem; but a "leftovers sitting too long in the fridge"
  problem that I just never got around to, until now.

- Work has began for a "Favourites" feature in the internal editor, but
  won't be done until the next release.

Nick Andre
www.nickandre.com



VERSION 3.33 - JULY 29 2009
---------------------------

This is somewhat of a major release which contains more significant
improvements and changes to the underlining source code. Some minor problems
reported should also be resolved.

If you are upgrading from 3.31 or prior, please review HISTORY.TXT for
the notes for 3.32 first.

- A serious problem with the Areafix for NNTP (Usenet gating) is fixed.

- Two new semaphore files relating to the above Areafix for NNTP make their
  debut here, for better control over the gating when D'Bridge is being
  ran in the most demanding "hub" scenarios.

  Note that when I refer to the NNTP/USENET gateway, I'm referring to the
  actual Internet NNTP connection made via. the SOUPGATE/VSOUP modules
  (automatically managed by D'Bridge). So the following "bedtime story" is
  not suitable if you are obtaining Usenet in Fido/FTN format from someone
  else already (like me, Allen Prunty, Frank Linhares, etc).

  Before I explain, theres a file called NEWSRC (no extension) that is used
  by the VSOUP module to control what Usenet groups its supposed to
  download from your Internet provider. There is also a file called
  USENET.BBS, that is to be specified as the LAST line in PACKET/MAIL
  CONTROL if your hubbing Usenet for downlinks. It makes sense that if
  you're hubbing Usenet, you wouldn't want to carry 70,000+ Usenet groups
  on your system all at once. You would have it set up in a way where your
  downlinks will Areafix what they want and they are automatically added as
  Passthru areas. USENET.BBS should always come last in your PACKET/MAIL
  CONTROL setup. Put any other networks (including Fidonet) first and above
  the "line" where you have USENET.BBS defined.

  So, unknown Areafix requests for Usenet groups makes D'Bridge manage the
  NEWSRC file. (Or if you press ALT+R and enter your Gateway
  address followed by some "unsubscribed" groups). D'Bridge will also
  generate the USENET.BBS file automatically. When things are set up
  properly and the smoke clears, D'Bridge treats Usenet as if its any other
  Fido/FTN network.

  Now the new semaphores are only useful when D'Bridge has been configured
  to use an "External" gateway in the USENET/GATEWAY screen. The ability to
  use an external gateway allows a much more flexible and versatile way for
  D'Bridge to work in the most elaborate and complicated setups I could
  think of. You control your own software for Usenet by editing the included
  GATE.BAT file in this release.

  WARNING: Answering "External" to that question means that I cannot provide
           technical support for any Usenet problems beyond D'Bridge as you
           are going to be doing things I haven't thought of... yet.

  Not to worry as the GATE.BAT file that I included shows how D'Bridge would
  normally work with SOUPGATE and VSOUP that are called in "Basic"
  operation. By following my example, you should have a better understanding
  of whats involved and why the two new semaphores were necessary.

  DBUAFIXI.EXT is a dummy file that D'Bridge will check *before* processing
  any Areafix requests destined for the USENET gate. That file is created
  by the GATE.BAT file and deleted when the batch file ends. D'Bridge needs
  to wait for GATE.BAT to finish because any pending Areafix transactions
  for the Usenet gateway because the NEWSRC control file is rewritten as
  part of the Areafix code. If D'Bridge overwrote NEWSRC while GATE.BAT was
  running, partial or even complete damage of that file would result... and
  your downlinks would not receive any Usenet mail from you.

  Likewise, DBUAFIXI.TMP is a file that D'Bridge creates when its processing
  Areafix requests for the gateway. GATE.BAT checks for that file and
  immediately terminates if it exists, and again this is due to the changes
  being made to the NEWSRC file.

- It is impossible now to specify your Gateway address in the "Unknown area
  forwarding" question in PACKET/MAIL CONTROL. This was done for security
  reasons. If you had previously specified your Gateway, the setting will
  be erased.

- Two new control-files have been added to D'Bridge. They suppliment the
  file AREAS.TXT when new Echomail areas have been added either as
  "normal" areas or Passthru type. As you know, AREAS.TXT contains the
  Echomail tag, a space, then the description.

  AREAS.AKA lets you specify the originating Fido/FTN address to use for
  the new area added. The format of this file is the Echomail tag, a
  space, then the address to assign to the newly added area. For example,
  if theres a line called NICKANDREDOTCOM 1:229/426, then when that
  Echomail area is added, the 1:229/426 address will be assigned as the
  originating address.

  AREAS.SEC is the same except you can specify the default group and
  security level. For example, NICKANDREDOTCOM B,50 means to assign the
  group B, security level 50 when that Echomail area is automatically
  added to the system.

- The BinkD system no longer hammers the system log file with "error"
  entries. If theres a problem now, the system log will only be updated
  once with the error of that session. The problem happened in prior
  versions when BinkD was running as a server process and there was more
  than one session happening at once.

- The BinkD outbound operations can be aborted now via CTL+A if its
  really necessary to do so.

- The COMM/MODEM SETUP screen no longer probes the COM port or the modem
  if you start D'Bridge in SETUP mode from the command prompt, ie. DB S
  or DB SETUP. This was done to improve any diagnostics needed especially
  if you entered the wrong COM port and Windows "traps" with an error.

- The internal editor now finally supports CTL+LEFT and CTL+RIGHT movements
  to "skip words" when composing/editing a message.

  WARNING: The code for this is experimental. Let me know the minute that it
           messes up other functions.

- Cleaned up the help file a little more, once again.

- Cleaned up the logic behind various configuration screens.

- Rewrote a minor logic routine in the kernal. D'Bridge should overall run
  approx. 5% faster now... but its really a matter of perspective.




VERSION 3.32 - JULY 22 2009
---------------------------

This is a major release and it has significant and fundimental changes
done internally to the source code. A lot of work was done to simplify or
improve the functionality of several elements of D'Bridge.

Please try only to report any problems once 3.32 has been installed. The
source code for 3.31 and prior versions has been archived/moved off the
workstation. I will not be able to quickly diagnose any problems in 3.31
and prior versions. Thats not to say I can't do it; its just going to take
more time if you are reporting stuff from 3.31.

WARNING: If thats not possible or if this release does not perform as
         desired, then rollback to 3.31 or prior releases and send a report
         accordingly, ASAP to my attention via Internet Email. DO NOT send
         regular Fido NETmail.

The release notes for this version are lengthly; so I've broken it up into
several sections, and for posting in the Fidonet DBRIDGE echo:

REDESIGNED SETUP WIZARD - Explains the install/upgrade improvements.
     FIDO PLUG AND PLAY - Allows new users to automatically obtain addresses.
   UPDATES NOTIFICATION - Explains the new auto-updates notification feature.
  CORRECTIONS/FIXES/ETC - The largest section; outlining the obvious.


REDESIGNED SETUP WIZARD
-----------------------

The Setup Wizard has been rewritten from scratch; functioning exactly as it
did in the version 1.xx series. This was done for a few reasons, but the end
result is a more simplified procedure. And most important: Less code used.

The Setup Wizard will do a fair amount of "cleanup" of your DB directory
when you upgrade from 3.31 or prior versions. There may be a considerable
amount of disk-activity during this process. A fair amount of files will be
permanently DELETED from your directory. These are:

- ANY and ALL "leftovers" from terminated Soupgate/VSOUP sessions.
- DB07*.3 and DB08*.3; obsolete/retired code from 3.31 and prior versions.
- COMM.CFG, obsolete from version 1 and version 2 series.
- DBRIDGE.MSG, obsolete from version 2.
- DBRIDGE.NRN, DBRIDGE.NMW, DBRIDGE.EMW, DBRIDGE.BXS, DBRIDGE.RSN,
  DBRIDGE.RSE, DBRIDGE.MSR, DBUTIL.DAT, DBUTIL.NRN, DATA\*.DB?, DB06.DAT,
  AMERICA.COS, DBUTIL.C1, DBUTIL.C2, DBRIDGE.QSD, DBRIDGE.NMS are removed
  either for obsolescence or because of possible conflicts after upgrading
  to 3.32.
- The infamous empty "Queu" directory.

There may be a problem if you decide to rollback to 3.31 or prior versions
when these files are missing, however it would (theoretically) be more of
a cosmetic/minor problem than major.

FIDO PLUG AND PLAY
------------------

This was a past topic you may remember discussion on in the Fidonet DBRIDGE
echo.

A completely redesigned Wizard in 3.32 now gives the end-user the option
of either manually configuring their address, uplink and routing information
or to have that automatically-obtained. This is done via Fido Plug and Play,
or FPNP for short. FPNP is a way to dynamically-assign Fidonet/FTN addresses
to systems who connect to you for the first time.

When prior versions of D'Bridge were installed for the first time, a Wizard
would appear, asking the user to enter in their network address and that
of their Fidonet uplink/provider. And of course DB would configure itself
accordingly.

FPNP is now fully functional, works properly across "othernets", and is a
major step in allowing newcomers to join our hobby.

WARNING: This is an advanced feature. You should not enable FPNP unless you
         are an experienced administrator with a very thorough knowledge
         of how Fido/FTN addressing, routing and hubbing works.

When a remote system is assigned an address by you, they are given a POINT
ADDRESS and can optionally be connected to Echomail areas of your choice.
All of the complicated routing, scheduling and packet/mail settings are
automatically configured on both your side and the user's.

The Wizard will ask if the user already has a Fido/FTN address. If so, then
the system will be auto-configured with their address and uplink info, the
same way it worked in prior versions. However, if not, then FPNP works to
obtain the address.

The way it works is a new installation of 3.32 (and higher) connects first
with nickandre.com (1:1/130). The 1:1/130 address on Fidonet is a "primary
directory" of all known D'Bridge installations worldwide that are offering
FPNP services to end-users; along with which networks (ie. Fidonet, DBNET,
etc) and their corrosponding geographical locations.

The data exchanged with nickandre.com is your address and FPNP information
as configured in this screen. No other information is sent to that site.

WARNING: Systems who do not refresh themselves within a one-week period are
         automatically purged from the database at 1:1/130; to help present
         a most-recent list of available systems that an end-user can
         exchange mail with.

By carefully manipulating BinkD on the end-user side, a short query is done
and a list of available "hubs" is downloaded from 1:1/130 and presented to
choose from. The user can then choose one (usually whoever is closest
geographically) and optionally choose which networks to connect to.

A request is then sent to your system to obtain an address. D'Bridge then
computes and sends back the address along with special commands that
automatically configure that remote end-user with the proper address,
routing, Echomail areas and so forth.

The questions in the new FPNP SETUP screen control how it works:

ZONE:NET    This is where you specify the network Zone and Net where the
            addressing should start. For example, 1:229 means that I will
            auto-assign addresses in Zone 1, Net 229. The ZONE:NET must
            match at least one of your network addresses specified in
            the BASIC CONFIGURATION screen. The first matching ZONE:NET will
            be the one that addresses are auto-assigned from.

            WARNING: Be very careful with the deligation of Fidonet ZONE and
            NET properties. If you are not the Network Co-Ordinator (NC) of
            your local "net", you should ask permission to use FPNP first.

NETWORK ID  A unique ID to assign for this network. Up to 8 letters and
            numbers only. For example, FIDONET or DBNET. The network ID is
            presented to the remote system.

NODELIST    D'Bridge will send the specified nodelist to the remote system.
            Do not enter an extension; it will send whatever matches.

DEFAULT     Specifies the default security criteria to apply for new systems
SECURITY    and this should match the criteria in the PACKET/MAIL CONTROL
            screen. For example: A,50 means assign group A, security 50.

START       The starting "scope" for address assignment. For example, if
            you enter 50 and your network address is 1:229/426, then D'Bridge
            will assign addresses from 1:229/426.50 and onward.

END         The ending "scope", as per above, D'Bridge will assign addresses
            up to this criteria.

OPTIONAL    You may send an optional "infopack", usually a ZIP file that
INFOPACK    would contain an official application, rules and list of areas.
            Specify that name of the file here (*with* an extension)

FPNP updates and controls the points via the POINTS.LST control file.

D'Bridge is smart enough to figure out if the POINTS.LST already exists and
if its in that "Boss-node" format as discussed recently (as of this writing)
in the FIDOGAZETTE echo.

Originally it was my intention to provide NODE addressing and full support
for MakeNL-compliant segments, however, there are a few "political"
drawbacks of offering this service. Internally however, the code can be
adjusted fairly easily to provide NODE addressing.


AUTOMATIC UPDATES NOTIFICATION
------------------------------

When D'Bridge 3.32 is installed for the first time, a Wizard appears, asking
you if you wish to be automatically notified when new updates are available.
If you answer YES to this question, D'Bridge will check with nickandre.com
approximately once per week, to see if a new version is available. If so,
then a message is flashed on the MAILER screen accordingly.


CORRECTIONS/FIXES/ETC
---------------------

As explained earlier, a significant amount of work was done behind the
scenes to help improve the way certain fundimental components operate. In
addition:

- The overall installation/upgrade process should be several times faster
  than before.

- The overall operation of the mailer should be anywhere from 5% to 25%
  faster now.

- The overall operation of the BinkD subsystem should be anywhere from 10%
  to 75% faster now and use less disk access/swapping.

- D'Bridge will unpack any received mail immediately after a BinkD
  transaction if running in "client only" mode.

- D'Bridge uses slightly less memory when running now.

- A serious stability/reliability problem with the way D'Bridge handles COM
  ports has been resolved.

- A serious stability problem with Error 23 relating to COMM/MODEM setup
  should be resolved. The problem is in the length of the MCF files.

- A serious problem with the way BinkD stopped polling remote systems upon
  installation of some recent versions of D'Bridge should be resolved now.
  This version underwent serious testing to ensure that problem did not
  happen again.... but if it does, let me know.

- A serious problem with DBUTIL SORT AREAS has been resolved.

- A serious longstanding problem with DBUTIL CHANGE on alias-addresses
  (non-Fidonet) has been resolved.

- A minor improvement was done to the code of DBUTIL PURGE.

- The nightly "cleaning" of the system log files is now done internally
  in D'Bridge.

- A problem with a malfunctioning COM port-status in the menu system has
  been fixed, and no, it wasn't something I botched before... it was a new
  thing I botched.

- The internal editor should no longer duplicate the MSGID kludge on NETmail
  destined for multiple recipients.

- The internal editor's "Custom tear line" is no longer Wildcat.

- DBUAFIXI is no longer included in D'Bridge, I rewrote that entire program
  and all the code to function during the tossing of mail; internally.

- USENET.BBS is properly auto-generated on all transactions from the
  NNTP SOUP gateway that update the NEWSRC source file.

- AUTORUN.INF is no longer included in D'Bridge; for security reasons, and
  Microsoft has recently released a series of "patches" to their OS's to
  change the behavior of AUTORUN.INF. It is fairly simple to create your own
  if you decide to burn D'Bridge to CD-R to share with others.

I also rewrote a few sections of code to be less dependant on Assembler and
be a bit more compiler-friendly instead of just hammering the DOS session
with assembler calls.

After working on 3.32, I am inspired to start work on eliminating ALL of the
assembly-language calls out of D'Bridge entirely. There are two fundimental
problems in the code that I may need help on. Those are ZMODEM and the B-
Tree database system used by the Nodelist, Costbase and system Queue.

Eliminating the assembler code means that I can compile cross-platform DB
that will work natively in Linux, OS/2, Unix, FreeBSD, Win32/Win64, etc etc.

Depending on what feedback I get from that, I may just release that as
the version 4 series.

Nick Andre
www.nickandre.com



VERSION 3.31 - JUNE 13 2009
---------------------------

This is a very minor release which addresses some problems in the HARDWARE/
MODEM SETUP screen and other internal things too numerous to mention.

WARNING: Be prepared to rollback to a prior version if this one does not
         perform as expected.



VERSION 3.29 - MAY 23 2009
--------------------------

This is yet another minor release which corrects the following:

- The BASIC CONFIGURATION screen has two new questions for the purging of
  log files for DBUTIL and BinkD (and that old option for that log file was
  removed out of BINKD SETUP). Also, all logging purges as it should now.

- Problems with session-limits in BinkD transactions should be gone now.


VERSION 3.28 - MAY 19 2009
--------------------------

3.28 is a very, very minor release which corrects the menu system and Fido
Plug and Play (FPNP). FPNP is being revised for the next release.



VERSION 3.27 - MAY 15 2009
--------------------------

There is going to be an upcoming major release of D'Bridge (still version 3)
to fulfill certain promises I made in the past about things in the works.

A lot of hard work has gone into 3.27 as it was originally planned to be
that release... however... at this point I decided that the work so far was
worthy of release to "tide you over" until the major stuff gets done.

My Email address is not working until Monday due to yet another ISP issue
and I'm going away on holidays for the weekend. So... this is possibly the
first release that has been announced here in the DBRIDGE echo as opposed
to regular Email.

- Pretty sure I solved that problem with installing DB to a partition other
  than drive C.

- A very rare "Error 5" problem should be resolved when aborting a toss
  cycle to fire up the internal editor.

- Should of solved a very minor but serious problem with regards to the
  way D'Bridge manipulates COM ports on Windows 2000, XP, Vista and Server
  2003 and 2008 platforms. The problem does not happen with OS/2, real or
  emulated DOS "machines" such as DOSBOX or DOSEMU.

- A problem with QuickDial on PSTN dialup modems has been resolved.

- A problem with BinkD transactions immediately starting when D'Bridge has
  been started has been resolved.

- An inconsistent display of certain outbound BinkD transaction was
  corrected.

- The BinkD module for Windows has finally been upgraded from 0.9.6 to
  0.9.10. The OS/2 module still remains at version 0.9.6.

- A few minor changes were done to various setting screens, for logistical
  reasons.

- A minor issue with DBUTIL CHANGE has been fixed.

- BinkD can now be ran as a "service" on Windows 2000 and higher. When you
  answer "S" to the question "Run BinkD as a server?", D'Bridge will install
  the BinkD module as a service-process. That means that BinkD will run in
  the background, with no window.

  WARNING: If BinkD is currently running, shut it down before changing the
           answer to that question from YES to SERVICE. If you change from
           SERVICE to YES, you will need to manually start BinkD as before.

- D'Bridge will automatically shutdown and restart BinkD when a
  configuration change has occured; so manual intervention is no longer
  required on your part. Future versions of D'Bridge will also automatically
  shutdown and restart the Binkd service in Windows if an upgrade needs that
  to happen.

- Note that the process is left installed and running even when D'Bridge
  has been shutdown. It is assumed that if you are running BinkD as a service
  then obviously you intend to accept incoming connections all the time. If
  you want to automatically shutdown BinkD when you shutdown D'Bridge,
  create a dummy file called DBRIDGE.BSS (short for BinkD Service Shutdown)
  in your DB directory.

- Also note that when BinkD is installed as a service-process, it will be
  started whenever Windows starts. D'Bridge will assume that the process is
  always running. 

  WARNING: Do not use the Windows Task Manager or any 3rd-party software to
           change the priority of the BinkD service. Doing so may cause a
           malfunction. Under NO circumstances should the BinkD service be
           terminated manually. ALWAYS let D'Bridge shut the service down.

- It is not recommended to attempt to run "real time log viewers" or any
  simular programs with BinkD. Those programs may interfere with the way
  D'Bridge interoperates with the service.

- A new feature has been added to the EMAIL/USENET gating system to allow the
  operation to run as a seperate process rather than from D'Bridge itself.
  If you enable that setting in that screen, you need to run the batch/
  command-file "GATE.BAT" (or GATE.CMD on OS/2). You schedule this to run on
  your own, using your own scheduler.

  This was done to provide a bit more flexibility in the way that EMAIL and
  USENET is handled in D'Bridge. A lengthly gate session would tie up
  D'Bridge for several hours on end in 3.26 and prior versions.

  Note that when you enable that setting, the auto-checking of EMAIL and
  USENET groups is disabled.

- A new feature has been added to the ECHOMAIL AREAS screen which allows
  you to "unlink" systems defined in the FORWARD-TO fields prior to
  removing an area. When you press R to remove an area, D'Bridge asks you
  if you really wish to do it. If you answer "Unlink" or "U" then an
  unlink request will be sent out AFTER you exit the whole screen. Those
  are added to the main Queue.

  WARNING: Incorrect use of this feature may result in lost mail and/or
           upset and possibly "lost" downlinks if you catch my drift. This
           is a feature for experienced D'Bridge administrators only.

  WARNING: At the last minute prior to publishing 3.27, I changed the way
           the feature works so unlinking is "queued up" if D'Bridge has
           been started in SETUP mode (ie. C:\DB> DB SETUP). When D'Bridge
           is started "normally" then you can process those transactions by
           going back into ECHOMAIL AREAS again, and press ESC. The
           transactions will be processed immediately.

- After a series of REMOVE requests as explained above, D'Bridge will also
  create two textfiles. DBRIDGE.UAL (Unlinked Area List) contains the
  Echomail tags of whatever was removed when you exit the whole area screen
  and DBRIDGE.UAF contains the *.MSG directories (if applicable). These
  two files are created to assist with whatever batch files or events you
  decide to write to do other tasks when Echomail areas are removed.
  An example is creating/publishing a "removal log" in an echo of some sort.

  NOTE: At the last minute prior to publishing 3.27, I decided to not purge
        those files, for diagnostic reasons. Its up to you to delete them
        both if they are not required any longer in whatever manipulation
        you do with them or as part of a weekly "cleanup" event.

- In addition, when you remove Echomail areas, you may create a batch file
  called UNLINKED.BAT containing commands to run after one or more REMOVE
  commands were issued. One simple way to ensure that the *.MSG directories
  are "consistent" with your Echomail database is to create UNLINKED.BAT
  with the command DBUTIL SORT AREAS. This makes sure that whenever you
  remove an area, DBUTIL will also remove the directory (archiving any old
  messages first if the Archive criteria is defined). Personally I run
  DBUTIL SORT AREAS as part of a midnight event, but you may choose to do
  it the other way if you want.

- The code is smart enough to send unlink's as a "batch" and not individual
  messages.

- At the very last minute prior to publishing 3.27, I added a warning/
  confirmation question when you exit the ECHOMAIL AREAS editor and there
  are pending unlink transactions. Answer YES or NO accordingly. Its here
  because on Qwerty keyboards Y is next to U. And I didn't want U to make
  a mistake and ask Y.

- The work on QWK support has been removed and scrapped. After careful
  consideration, it was not a service which I felt would benefit a D'Bridge
  user. QWK is somewhat popular. Basically someone eventually figured out
  that a protocol designed for off-line mail reading could be used for
  networking. It didn't take long thereafter for the idea to catch on and
  soon, QWK-based "othernets" appear. Those appear to be prevailent on
  Synchronet, a popular BBS platform.

  Its true that it "serves its purpose" by allowing people to write messages
  back and forth. But with a lack of basic necessities such as organised
  network structure and lack of proper mail routing, the two problems result
  in an administrative nightmare. The problems are obvious when a BBS wants
  to run a dual-setup with both a QWK network and offering Fido/FTN
  connections. The QWK system is for Sysops who simply do not understand (or
  don't want to understand) how to set up a proper Fido/FTN system.

  Version 3.27 drops any and all references to QWK and removes a fair portion
  of code in both the mailer and the exported configuration files, freeing
  up some RAM.

- The code that controlled non-local-net Internet EMAIL routing, a rarely
  used feature in EMAIL/USENET GATING has been removed from 3.27 and is left
  to the user to set this up through the other question, ADVANCED GATING
  OPTIONS. If this feature was configured in 3.26 or prior versions, the
  D'Bridge Update Advisor (DBUPD) should automatically make the necessary
  "conversion" for the advanced-gating.

- Support for legacy CGA video card snow-suppression has been removed from
  3.27 as the compiler's CRT unit was modified and patched. If D'Bridge is
  being ran on an IBM XT with a CGA card and has a snow-problem, there are
  various TSR programs which can be installed overtop to fix it.

- The overlay diagnostics feature has been removed from 3.27 and will not
  return. It was superceded by various mailer-code reworkings in 3.24, 3.25
  and 3.26.

Nick Andre
www.nickandre.com



VERSION 3.26 - APRIL 14 2009
----------------------------

This is a very, very minor release which adds a question to maintain the
list of personal messages waiting in the internal editor, when the YOUVE GOT
MAIL option is enabled.

Some ongoing cleanup was done to the source code for all aspects of the
mailer, the internal editor, DBUTIL and the Setup Wizard... so, this release
affects all areas of operation. Nothing noticable or worthy of mention at
this time. D'Bridge should use slightly less memory and file-handles and run
approx. 25% faster in nodelist compiling, message tossing and scanning.

Incase "you didn't get that memo about the TPS reports", my new Email
address is nick [at] nickandre [dot] com. The Hotmail account will be
permanently closed, effective a month from today.



VERSION 3.25 - APRIL 9 2009
---------------------------

This is a very minor release to fix some reported problems since 3.24.

Based on feedback, a new feature, NETMAIL FILTER, makes its debut in the
SCHEDULER. This will show a new screen where you have these questions. Keep
in mind that these questions override any and all settings in all mail
events in the schedule including the "Un-event".

Also keep in mind that it is not my intention to program a full-blown
NETmail "tracker" system; but this should at least do some of the things
that those programs offer.

WARNING: This new feature is provided solely for aiding in troubleshooting
         and diagnosing "problems". It is not meant as a permanent solution.

NETMAIL FILTER: Answer YES to turn the system on or NO to shut it off
(default setting). This keeps all of the below settings intact and serves
as a "master override" to all operation.

FILTER TO: When building the outbound Queue, each NETmail message is checked
to see if it has a valid destination address AND that it can be routed. If
a message cannot be routed, D'Bridge can "bounce back" the message to the
sender. D'Bridge will explain to the sender that the destination address
is invalid or that they may not be authorized to route mail through your
system. Answer YES to do this or NO if not (default setting).

If you wish to bounce the message in your own words, create a textfile
called DBRIDGE.NFB with your "words of wisdom" to those senders.

If you wish to override what D'Bridge thinks is undeliverable; create a
textfile called DBRIDGE.NFO (short for NETmail Filter Override) and specify
the addresses; one per line. D'Bridge will not bounce-back messages destined
for addresses in the DBRIDGE.NFO file; it will leave them as undeliverable
in the outbound Queue.

BLOCK DESTINATIONS: This allows you to specify addresses that D'Bridge
should never route mail to. Any NETmail processed that matches the addresses
in this screen will be blocked. You may not use "wildcards" here; you must
specify the addresses individually. The blocked messages are bounced.

NOTIFY ON THOSE: Answer YES to CC you via NETmail or NO if not.

Other things done:

- Some aspects of the on-line help system (F1) have been either rewritten,
  updated or otherwise cleaned-up entirely.

- A rare freeze-problem in the internal editor when replying to certain
  NETmail messages should be fixed now.

- The status line should no longer be "garbled" and I will tell you all that
  there is over *2 thousand* lines of code that controls just the display
  of that one status line. 2 thousand lines of code to control the display
  of 80 characters on the mailer screen. This is yet another mystery to me.

- The DBUTIL BACKUPMAIL command has been slightly adjusted to now include
  a log file, BACKUP.LOG, inserted into the ALLMAIL.ZIP file created by
  the ALLMAIL.BAT file. If you do not wish to have a log file in
  the ALLMAIL.ZIP file; then modify your backup process to run
  the command "pkzip -d ALLMAIL.ZIP backup.log". While not really a "fix"
  per say, its there incase you need to troubleshoot things.

- A minor performance improvement was done to DBUTIL PURGE.



VERSION 3.24 - MARCH 30 2009
----------------------------

I recommend that those of you running a Fidonet server or "Hub" run that
on a server-level platform for maximum uptime and less likelyhood of data
loss. Thats how Net 229 has ran here for years. Net 229, my website and BBS
run on an industrial-grade rack server with RAID/mirrored hard drives,
redundant power supplies and fans. Yes, its probably overkill and "its only
a hobby" but a lot of systems depend on mine for all of their mail. Loosing
Fidonet would be like loosing a pet in real life, I guess.

Now I understand that the vast majority of users are running DB on average
desktop PC's. So with that in mind, this release should be considered
somewhat major. It addresses several issues with long-term stability and
"worst case scenario" problems with the Queue, databases and configuration
files. With this version; it should be possible to recover even a very
damaged DB directory missing the majority of its files.

I also understand that being told to backup your data is a lot like driving
somewhere with a girlfriend and being nagged at to "ask for directions".
Real men DO NOT ask for directions. If we can build nuclear weapons and NASA
probes, we're quite capable of finding the nearest shopping mall. So... you
don't need me nagging you to backup your data on a regular basis. Adding a
cheap external USB hard drive or "flash stick" and automating backups of
your D'Bridge directory is one simple way to avoid data loss.

- The exported configuration file (ie. DB EXPORT) now includes the contents
  of the DBRIDGE.XMA file. This is another important database that was
  overlooked since version 1. This is a temporary file used by D'Bridge
  when it generates packet files for other systems during a toss cycle. If
  this file was lost in a crash, D'Bridge would loose all pending
  transactions during that time; even if the packet files remained.

- DBUTIL itself has had over a dozen significant internal changes to ensure
  that it can successfully recover from a few exceptionally-rare conditions
  with corrupt files. A lot of hard work was done in "stepping through"
  various code to ensure it accurately checks the data on computations even
  with a severely corrupted database.

- A new command, DBUTIL RENDATE, will rename a file to todays date or a date
  you specify. The syntax is DBUTIL RENDATE [file] [optional date]

  The date format is mm-dd-yy, mm/dd/yy, mm-dd-yyyy or mm/dd/yyyy.

  For example, DBUTIL RENDATE DBCONFIG.ZIP will just rename the file to
  todays date - In this case, March 30th 2009, becomes 03302009.ZIP.

  Or, DBUTIL RENDATE DBCONFIG.ZIP 07/04/2009 will rename it to 07042009.ZIP.

  You would use this in conjunction with a backup schedule. Your backup
  would run this once a week. The DBCONFIG.ZIP archive contains over
  a weeks worth of "restore points". By renaming this file with DBUTIL
  RENDATE and moving that file onto another hard drive, CD-RW, or other
  media, you can have as many backups as you wish to restore from.

- The database DBRIDGE.ADF contains all of your Echomail areas. Now a new
  command, DBUTIL REBUILDADF, will read an exported configuration and
  generate a new DBRIDGE.ADF file only. This command shall only be used as
  a worst-case-scenario if you are repairing a damaged D'Bridge
  installation; whereas that file is corrupt. A lot of hard work has gone
  into this simple feature because incorrect entries in that database would
  result in "problems" down the road. This new feature should effectively
  and permanently solve any and all future issues with the ADF file.

  WARNING: Since this command destroys the database, DO NOT use this command
           unless absolutely necessary.

  Yes, I understand that DB IMPORT does the same thing; but this feature was
  done to avoid changing any settings in the mailer and other components.
  Note that "cropping" an exported configuration with just Echomail areas
  and then using DB IMPORT is NOT recommended - use this command instead.

- DBUTIL REBUILDADF will produce a text file called DBUTIL.CFX (short for
  Configuration Fixed) to allow manual inspection of possible corrupted
  entries.

- Another new DBUTIL command, DBUTIL BACKUPMAIL, will generate a batch file
  to backup all of your messages in the NETmail directory and each
  individual Echomail directory. The batch file will be called ALLMAIL.BAT.
  It will use PKZIP to do this and produce an archive called ALLMAIL.ZIP.
  I've also made sure that the batch file was designed around the handling
  limitations of PKZIP as well. The batch file is NOT called after running;
  you must manually start it or "call" it from another. By using the RENDATE
  utility, you can then move/rename that archive as part of a backup plan.

- The startup sequence of the mailer and the midnight "AutoUpdate" cycle
  have had several changes done to ensure that in a scenario where crucial
  databases are missing; that D'Bridge will still start and function, even
  if its at the bare minimum.

- Minor corrections were done to the BinkD system; no noticable changes.

- A few other problems with regards to "Error 202" and "Error 203" should
  also be resolved.

- An extremely rare condition was corrected where D'Bridge would "freeze"
  entirely during a toss cycle.




VERSION 3.23 - MAR 19 2009
--------------------------

WARNING: If you are upgrading from 3.1 or prior versions, please read
         the HISTORY.TXT file for important changes done for version 3.2.

This is a very minor release which corrects the broken Twit feature and
the REMOVEDEADECHOES "field overflow" bug.

Only a single line of code had to be changed in both. So its probably not a
wise idea for me to be working on this project in the early morning hours...

Nick Andre
www.nickandre.com



VERSION 3.22 - MAR 16 2009
--------------------------

WARNING: If you are upgrading from 3.1 or prior versions, please read
         the HISTORY.TXT file for important changes done for version 3.2.

This is a very, very minor release which should (hopefully) address the
"magic 8000" problem in the internal message editor in addition to the
lost-leadreads when reading messages. It was tested here successfully. It
is not imperative that you upgrade to 3.22 unless you have a large number of
messages; or the internal editor always starts on message #1 when selecting
an Echomail area for the first time.

Nick Andre
www.nickandre.com




VERSION 3.21 - MAR 13 2009
--------------------------

WARNING: You must shut down the BinkD system, if it is currently running,
         prior to installing this version.

This is a very minor release which corrects the following problems:

- D'Bridge 3.21 should no longer crash on unpacking new personal Echomail or
  scanning out (caused in 3.2)

- D'Bridge should mind its manners and not belch Error 202 on a QueueScan
  (caused in 3.2)

- D'Bridge now accurately reports time spent on a Queue entry for BinkD
  transactions (did not work entirely correctly in 3.2)

- The use of DBRIDGE.RSN in the BinkD module has been replaced with
  a less disk-intensive DBRIDGE.UFM (short for Unpack/Forward Mail).

- The same change has also been done to Internet EMAIL/USENET gating.

- Usenet group "sync-up's" were not being properly done in prior versions
  and this has been fixed here.

Nick Andre
www.nickandre.com


VERSION 3.2 - MAR 12 2009
-------------------------

Okay, I have a little bit of time to spend here.

This is a minor release but contains dozens of corrections, fixes, and
improvements to the mailer and the internal message editor. It is
recommended that everyone upgrade to this version as this version contains a
fair number of improvements to operation and overall stability.

A very important stability/security update was also done in this version.

- A very serious "lockout" bug when a series of BinkD transactions are done
  in a row has been fixed. In prior versions this could have been used as
  a potentially annoying way to interfere with a D'Bridge system.

  The way that D'Bridge processed BinkD transactions was not based on the
  kernal's timer code. With PSTN transactions, the mailer sends stuff out
  and returns to "Idle/Next Call" state and waits a specified number of
  seconds (as defined in the UN-EVENT). So the problem was that in a series
  of BinkD transactions were sent out, the mailer would not return to Idle/
  Next Call status and wait.

  The bug would cause the mailer to not respond to *any* commands including
  the ALT+X shutdown command, until all BinkD transactions were done. It
  was equivalent to using the QuickDial command with PSTN transactions...
  with no way to stop it.

  If a remote system was clever and malicious enough, he could keep sending
  mail packets (destined for others) on a continuous-loop, thereby causing
  the mailer to continuously process BinkD transactions and effectively
  locking-out the Sysop from intervening or using his own system.

- This version tremendously improves the performance of the way that the
  Queue works with BinkD transactions, greatly reduces disk access, and
  things that I have written for BinkD have been streamlined and "fine
  tuned". Disk access is down approx. 50 percent; about a thousand lines of
  code have been eliminated; and a few K's of valuable memory-space freed up.

- A new TWIT feature makes its official debut here... yes, the internal
  editor was long overdue for having one.

  The way it works is when browsing a message you may press the T key. A
  new window will appear, where you can add/remove people to the TWIT LIST.

- The TWIT filter will no longer show messages from twits either via
  browsing messages or using the LIST command. It does NOT, however, "skip
  over" those messages. To do so would require reworking the way the
  browser works and thats not something I had time to get into...

- I added a new question to EDITOR OPTIONS, to control whether or not you
  wish to be notified of personal messages from twits when D'Bridge unpacks
  messages. The default setting is NO.

- You cannot twit D'Bridge. Doh!

- Messages from twits are never deleted; so they're still stored. Changing
  the TWIT FILTER instantly hides/reveals messages... handy for those who
  just want to read certain messages from certain individuals when they
  feel like it. Better than adding a "Mood filter" I guess. To auto-
  delete messages from twits would require reworking the browser and/or
  mail tossing and thats not something I had time to do.

- The twits are stored in the text-file DBRIDGE.TWT.

- Try to twit me and see what happens.

Keep in mind that it is not my intention to get carried away offering
anymore new features to the version 3 series - aside from what I've promised
that I would do.


VERSION 3.1 - FEB 26 2009
-------------------------

WARNING: If you are upgrading from a prior version, you must shut down
         the BinkD module if it is presently running. After the upgrade
         is complete; you may restart the BinkD module again.

This minor but CRITICAL release corrects yet another stability flaw in the
way that D'Bridge interacts with BinkD.

Under certain conditions, the BinkD system would not deliver mail destined
to a remote system that was running Charles Cruden's Internet Rex (IREX),
or it would not be possible to exchange mail with remote systems running
D'Bridge versions 3.08 or 3.09.

It is imperative that you upgrade to this version to avoid future problems
with the way that BinkD functions on your system.

A minor improvement was also done to the way that the "Uncompressed mail
packets" operates (the U option in the BINKD SESSION INFO question). The
improvement was done only because it shares the same code module as the
subroutine that manipulates the behavior of BinkD.

No other corrections or fixes were done at this time.

Nick Andre
www.nickandre.com



VERSION 3.09 - FEB 15 2009
--------------------------

WARNING: If you are upgrading from a prior version, you must shut down
         the BinkD module if it is presently running. After the upgrade
         is complete; you may restart the BinkD module again.

This is a very minor but CRITICAL release which corrects a serious stability
and design flaw with the way D'Bridge interacts with BinkD.

It is imperative that you upgrade to this version to avoid future problems
with the way that BinkD functions on your system.

No other corrections were done at this time.

Nick Andre
www.nickandre.com




VERSION 3.08 - JANUARY 13 2009
------------------------------

This is a very, very minor release. The mailer now responds to Areafix
requests addressed to "D'Bridge Areafix" because I've noticed that some
Sysops will just reply to Areafix requests that D'Bridge sends out to
request what they want.

Nick Andre
www.nickandre.com



VERSION 3.07 - JANUARY 3 2009
-----------------------------

WARNING: This release deals with message processing. Please back up the
         contents of your NETmail directory and the outbound QUEUE if you
         are upgrading.

This is a very minor release, although a fair amount of work and testing
went into it. This release routes Areafix receipts from your uplink back to
your downlinks if a downlink requested an area that did not exist.

There is a new question in the PACKET/MAIL CONTROL screen, "Route receipts?"
and it defaults to NO. When enabled, you will need to specify the address
of your uplink in the "Unknown area forwarding" question at the bottom of
the screen. Note that this feature does NOT work for uplinks in listing-
files specified in the AREAFIX INFO question.

You will need to edit the file DBRIDGE.RBU (Route Bad Uplink receipts),
which tells D'Bridge what "qualifies" as a bad receipt from an uplink. When
NETmail is unpacked, if the criteria is met, the message gets re-routed.

Only 3.07 will be made available on my website.

Nick Andre
www.nickandre.com



VERSION 3.06 - DECEMBER 27 2008
-------------------------------

This is a very minor release which should correct a rare problem in
the DBUTIL SORT AREAS and DBUTIL MOVE commands. Other reported issues will
take some time to resolve.

Only 3.06 will be made available on my website.

Nick Andre
www.nickandre.com



VERSION 3.05 - NOVEMBER 30 2008
-------------------------------

This is a very, very minor release which corrects a serious FTSC compliance
problem with the "Add missing kludges" feature in the PACKET/MAIL CONTROL
screen. Under certain conditions, the kludges added to a non-compliant
message would be corrupted entirely.

The "Add missing kludges" question now has three choices: OFF/DISABLED,
LOCAL ONLY and ALL. Answering "Local" tells D'Bridge to only add missing
kludges to messages scanned locally (ie. for those of you running legacy/
non-compliant BBS software), or "All" for adding missing kludges to all
messages passing through your system.

The feature has also been changed to NOT add INTL or FMPT/TOPT kludges
because I felt that it was over-complicating things in the NETmail processor
code; and to help out with the proverbial finger-pointing over whoes mailer
software is better than the others. Lets look at it this way, if someone
isn't running compliant software, wouldn't it be nice to have DB show the
glaring facts instead of someone else messing around with the kludges?

Note that this feature should be left OFF (disabled) unless you exchange
mail with a system who insists on running non-compliant Fidonet software.

If you have not upgraded yet to 3.04 - I strongly suggest you read up on
the notes in HISTORY.TXT.

Only 3.05 will be made available on my website.



VERSION 3.04 - NOVEMBER 25 2008
-------------------------------

WARNING: This release contains dozens of updates, fixes and corrections to
         all message processing code and the internal message editor. Back
         up your entire D'Bridge system before applying this upgrade. Be
         prepared to rollback to a prior version if necessary.

Three important security/stability fixes have been issued in this release
and so with all the work done, this is a major update for those of you
running 3.03 or prior. Some new optional features have also been added.
Even if you are not experiencing any problems, it is recommended to upgrade
to this release.

A lot of hard work was done in this release; not of a programming-nature,
but more in trying to understand exactly where these problems reside,
because D'Bridge is a very large program. So large, that changes I make to
one section of code can have adverse effects on other areas.

Whether you choose to use 3.04 in permanent full-time operation is up to
you, but I strongly suggest a "trial run", if possible, before assuming
that all is running well.

- The major security fix in 3.04 is for Echomail areas that are auto-added
  by the Echomail processor. A possible minor exploit exists in ALL prior
  versions because there was no logic to control whom to add areas from. It
  was possible for any system to exploit, to some extent, the Echomail
  database file or "usurp" operation of the Echomail processor entirely.

  WARNING: It is highly recommended to enable this particular fix especially
           if you are a Network or Zone Co-ordinator. But not paying
           attention to the instructions below will result in "problems" and
           possible angry/upset messages from the operators of systems whom
           you exchange mail with.

  In the PACKET/MAIL CONTROL screen, I added two new questions: "From Listed
  Systems Only?" and "List of Systems to Auto-Add From". These two questions
  tell D'Bridge that it should only be auto-adding areas from systems you
  specifically list, or if it should just auto-add whatever it encounters.

  So now if these new questions are enabled, D'Bridge will reject all new
  areas from unknown systems into the BADECHO area, if new echoes arrive
  and those systems are not explicitly listed in the ADD-FROM screen. The
  default setting is NO, or blank, meaning that if you want to use this, you
  need to turn it on manually.

  WARNING: Only your immediate uplinks should be specified in ADD-FROM only.

  Careful testing was done to ensure that all Echomail unpacking/tossing
  worked properly after I wrote the fix.

- Two new security questions were also added to PACKET/MAIL CONTROL to allow
  you to set the default security levels for Echomail and Passthru areas
  that are auto-added to your system. I've kept the default settings to 5000
  for both; that was the security that D'Bridge has always assigned. Only
  the "Level/Passthru" setting should be lowered: During testing, I found
  that a downlink cannot "un-Areafix" themselves from a Passthru area
  because their security was too low. As for the other setting, that one
  should only be lowered to match the security of existing downlinks if you
  wish to make added areas from your uplink available immediately, without
  your review. If thats not what you want, then leave it set to 5000.

- A second vulnerability has been corrected in the Areafix system where a
  downlink could possibly take advantage of the Areafix "quotas" that had
  been set up and the system had not successfully completed a prior
  AutoUpdate routine due to a system crash or other event. The quotas and
  security now works the way it should, no matter what "events" happen (or
  don't happen)

- The major stability problem with DBUTIL should be resolved - DBUTIL was
  using way too much memory and I was able to replicate Ward's problem on
  my own server after careful diagnosis and testing. I rewrote a huge
  portion of the program, moved other code around, reduced file-handles
  required, and generally cleaned up a lot of stuff inside of it.

- I added a new DBUTIL command, DELETEINSIDE, which will erase Echomail
  areas out of your system from a text file specified. So if you ran
  DBUTIL DELETEINSIDE DEADECHO.TXT, then DBUTIL will erase areas that match
  whats contained inside DEADECHO.TXT.

- And a new DBUTIL command, DELETEAREA, will erase one Echomail area out
  of the system. For example, DBUTIL DELETEAREA TESTECHO will erase TESTECHO
  out of the system.

- Those two new commands will also archive messages to a text file (if
  specified in the Echomail Areas screen) and erase the *.MSG directory.

- DBUTIL MOVE, has yet again been slightly modified for stability and
  performance concerns.

- A possible problem was corrected for DBUTIL PURGE and an odd mixture of
  Passthru areas.

- The D'Bridge NNTP Areafix component (DBUAFIXI.EXE) has also been
  redesigned and rewritten for stability and performance reasons. It has
  been tested over this past weekend and does not appear to have any
  problems at all.

  I get the odd Email from people wondering what this DBUAFIXI.EXE file is
  and what it does. D'Bridge has the ability to automatically manage
  Passthru areas via the Areafix system, for uplinks and downlinks. So it
  only makes sense that in a Usenet-gating setup, that the Usenet gateway
  also be automated. DBUAFIXI is the module that is called in the rare
  occasions when an Areafix request is sent to the outbound Usenet gateway
  when the EMAIL/USENET GATEWAY system in D'Bridge is enabled (and set up
  properly). It updates the NEWSRC file with add (or drop) requests by
  D'Bridge and/or your downlinks. Essentially its a "tosser within a tosser"
  because its taking the binary packet and doing its own translation on it
  into something useful that the VSOUP component can work with. It requires
  absolutely no intervention on your part. In order for automated NEWSRC
  management to work correctly, the "AREAFIX TIMEOUT DAYS" parameter must be
  set to 1 or higher... but not too high. The default setting is 3 days and
  should not be changed unless you are an experienced D'Bridge administrator
  and AREAFIX TIMEOUT DAYS is found in the PACKET/MAIL CONTROL screen.

  WARNING: Do not run DBUAFIXI manually. It is specifically designed to be
           ran automatically from D'Bridge only.

- A slight correction has been made to two questions in the EMAIL/USENET
  GATING screen. They were not exactly working the way they should. The help
  system has been slightly updated:

  SOUP MAXIMUM NUMBER OF MESSAGES TO DOWNLOAD:

  This sets a cap on the maximum amount of messages that should be downloaded
  per group whenever a connection is made on Usenet. The default setting is
  500 messages and that should be good enough for most installations.

  If you answer zero (0) to this question, no cap is put in place. THIS IS
  NOT RECOMMENDED for those of you who download large volumes of mail,
  because all it takes is a large posting in some group to effectively "tie
  up" your connection. A cap should always be put in place as a fail-safe.

  SOUP MAXIMUM NUMBER OF MESSAGES TO DOWNLOAD ON NEW GROUPS:

  Most Usenet providers keep a fairly large "retention" rate - That is, they
  tend to keep a lot of messages per group. So it makes sense that when you
  connect to a Usenet group for the first time, you would end up downloading
  all of the messages in that group to "catch up". This can easily tie-up
  your Internet connection for hours on end. So in this question, you can
  specify a limit as to how many messages to download when D'Bridge/VSOUP
  connects to a Usenet group for the first time.

  The default is 100 messages, and should not be changed for normal usage.
  Reduce this to 50 or even down to 25 when "hubbing" a lot of Usenet groups.
  Increase this number if you carry less than a dozen or so groups in total.

  If you answer zero (0) to this question, no cap is put in place. THIS IS
  NOT RECOMMENDED unless you're an experienced D'Bridge administrator and
  theres some strange or bizarre reason not to place a cap on new messages...

- A rare but possible "Xmail Bundle Corrupt" problem when forwarding Areafix
  requests to the EMAIL/USENET gateway has also been solved. The problem was
  replicated here during the testing of the other above-mentioned fixes.

- A possible non-compliance condition in the internal editor has been
  corrected, under certain conditions, the extensive use of kludge-lines
  would cause problems during Forward and Duplicate operations.

- A possible non-compliance condition in the internal editor has also been
  corrected for NETmail messages addressed to the EMAIL/USENET gateway if
  that feature is enabled. The correct kludge-lines are properly inserted
  if D'Bridge determines that the NETmail is in fact an Internet Email
  message bound for the gateway and/or the kludge-lines were missing.

- The internal editor should no longer add another INTL or FMPT/TOPT kludge
  when editing a NETmail message.

- D'Bridge should no longer complain of database problems under MS-DOS 6.22.
  Note that SHARE.EXE is required for operation under MS-DOS 6.22. This
  should be loaded in your C:\AUTOEXEC.BAT file.

- Minor trivial problems in exporting a configuration has been solved.

Only 3.04 will be made available on my website.

Nick Andre
www.nickandre.com


VERSION 3.02 - 14 OCTOBER 2008
------------------------------

WARNING: Be prepared to rollback to 3.01 (or prior) incase this release
         doesn't work as expected.

D'Bridge 3.02 is a very, very minor release, and is "experimental". It
should NOT be treated as stable. It is ONLY for those of you who are hubbing
mail to point-systems. This release should address the issue of exporting
duplicate messages to points during an EchoScan.

If duplicate-messages-to-point-systems is not of a concern to you, then
you should NOT install 3.02. You should stick with 3.01 or prior versions.
Do not install 3.02 just because its a new version. As Ward "points out",
newer is not necessarily better.

During testing, this release did not appear to break a related section of
code which controls the way messages written in the internal editor get
exported during an EchoScan if you chose NOT to export immediately after
leaving the editor. But just because it didn't break here, doesn't always
mean thats the case for others.

Only one "cycle" of Echomail was tested for 3.02. It is absolutely
imperative that if you decide to install 3.02 that you test *ALL* Echomail
processing features and give it a good "run" of mail to work with.

A slight change has also been done to DBUTIL MOVE, mostly for Ward, and
nothing worth noting. The way that file-operations are treated in the code
was slightly adjusted and may fix a crash-problem.

On my website, both 3.01 and 3.02 will be available; not just this one.



VERSION 3.01 - 7 OCTOBER 2008
-----------------------------

D'Bridge 3.01 is a minor but very important release which corrects
the following problems. Even if you are not experiencing any issues now, you
should upgrade to 3.01 for stability reasons.

- A major bug in the Areafix system should finally be resolved for good now.
  If you use D'Bridge to hub mail, then any downlinks which have previously
  been "refused" their Areafix requests should be told to re-send them
  again... unless you fixed things yourself using the ALT+N command in the
  mailer. Just blame it on me and everything will be okay.

- DBUTIL MOVE shouldn't crash anymore under certain conditions but if it
  does, the log screen should be a little more detailed now.

- The internal editor should properly save messages numbered 8000 or higher.

- A minor change was done to the Web processor (DBUTIL PROCESSWEB) to
  account for "long Echomail tags" not properly being parsed into HTML code.

Okay so these things got *some* people's attention in the DBRIDGE echo,
therefore as usual I have done my part to save Fido from extinction....
(insert 80's-sitcom-canned-laughter here)

Nick Andre
www.nickandre.com




VERSION 3 - 30 SEPTEMBER 2008
-----------------------------

D'Bridge 3 contains all of the countless fixes since 2.99 in addition to a
minor fix in the BinKD system for "locked log files" under Windows.

In addition, a minor trivial fix was done to the EMAIL/Usenet subsystem to
prevent cluttering of the DATA directory with outbound packet files if you
use the gating system but you don't allow outbound posting to Usenet.

A minor problem was adjusted for Passthru echomail areas in the midnight
AutoUpdate routine.

The version 3 series is the final series of upgrades based on DOS. Future
releases will focus on Windows, Linux and Macintosh.

I'm taking a bit of a hiatus from D'Bridge development for a little while
to focus on my daughter.

WARNING: You must shut down the BinkD system, if its running, prior to
         upgrading to version 3.




2.99 - 26 SEPTEMBER 2008 - SERVICE RELEASE 24
---------------------------------------------

SR24 is a very, very minor release that should correct a rare MSGID/REPLY
kludge problem when pressing F8 in the internal editor (the "Multiple
Recipient" feature), or forwarding Echomail messages to the NETmail area.

Some minor cleanup was done to various aspects of the mailer, documentation
and help screens, nothing really worth noting. No changes were made to any
processing routines, so its more of a cosmetic fix. As an example, the
COMM/MODEM screen is now called HARDWARE/MODEM DEVICES and BINKD PROTOCOL
SETUP is now called the BINKD TRANSACTIONS menu.

It is not necessary to shutdown BinkD prior to upgrading your D'Bridge
system to SR24.

Nick Andre
www.nickandre.com


2.99 - 24 SEPTEMBER 2008 - SERVICE RELEASE 23
---------------------------------------------

SR23 is a very minor release to fix recent problems reported in the DBRIDGE
echo on Fidonet.

- I don't quite understand why some other Fido software insists on
  generating lengthly MSGID/REPLY kludging but the internal editor should
  properly handle those now.

- The Areafix system should properly respond to %LIST, %QUERY and %RESCAN.

It is not necessary to shutdown BinkD prior to upgrading your D'Bridge
system to SR23.



2.99 - 18 SEPTEMBER 2008 - SERVICE RELEASE 22
---------------------------------------------

SR22 is a very minor release. Only one problem is being addressed at this
time. Other things reported will have to wait.

A serious fundimental change has been done to the way the Echomail area
database file (DBRIDGE.ADF) is handled. It is important that you first back
up that file along with your D'Bridge configuration.

Prior to installing SR22, first inspect the size of the DBRIDGE.ADF file.

The size of the DBRIDGE.ADF file must be in relation to the number of
Echomail areas you have. On mine, with over 10,000 areas the ADF file
is around 24 megabytes, which is normal. On a system with only a few
hundred areas and an ADF that is 50 or 60 megabytes in size - thats wrong.

If the size of that file is "normal" then copy that file to another
directory. Then run DB EXPORT of your configuration, and copy that
file as well to another directory.

You're doing this because if your ADF is normal, then you will need to ZIP
them both up and send to me for inspection ONLY IF THE ADF BLOATS AGAIN.

It is not necessary to shutdown BinkD prior to upgrading your D'Bridge
system to SR22.



2.99 - 4 SEPTEMBER 2008 - SERVICE RELEASE 21
--------------------------------------------

This is a minor release which corrects a serious logistical flaw in DBUTIL
PURGE on the NETmail directory for compatibility with certain "InterBBS
games" such as the LORDnet module, Barren Realms Elite and Falcons Eye.

InterBBS games should be configured to operate in FrontDoor mode (or Fido
*.MSG mode). Do not configure any games to operate in any other modes,
regardless of what their documentation states.

Technical support is not offered for configuring InterBBS games to work
with D'Bridge; however, basic assistance with configuring proper directories
and packing of file-attachments may be provided in the Fidonet DBRIDGE echo
if it is a mailer-specific concern you have.

It is not necessary to shutdown BinkD prior to upgrading your D'Bridge
system to SR21.

Nick Andre
www.nickandre.com



2.99 - 29 AUGUST 2008 - SERVICE RELEASE 20
------------------------------------------

This is a minor service release for 2.99. Even if you are not experiencing
any problems outright; it is recommended that you upgrade to this version to
ensure stability and reliability of your D'Bridge system. Several minor but
fundimental changes have been done to various aspects of the program.

WARNING: This release contains significant changes to the DBUTIL program.
         Before installing SR20, please BACK UP your message directories if
         possible. The DBUTIL.LOG file should be inspected after running
         any Echomail-purging or renumbering operations in SR20. If you
         have disabled logging, then first delete the DBUTIL.NLG semaphore
         file (short for "No Log Generation") prior to purging or
         renumbering. Once you are satisfied that purging/renumbering works
         correctly, you can go ahead and shut off logging again if you want.

- A fairly serious fundimental problem with DBUTIL PURGE, DBUTIL RENUM and
  DBUTIL PURGERENUM has been corrected and is the main reason for this
  upgrade. As per above, the first run of those commands should be done
  while you're at the console; and/or ensure that logging is enabled.

- A serious stability problem when attempting PURGE or RENUM operations
  across a LAN drive share that encounters a disconnection (for any reason)
  should be fixed now.

- A serious problem with FAT32 hard drive partitions possibly encountering a
  significant degree of data loss in the Echomail directories if the
  computer crashes during DBUTIL PURGE or RENUM has been corrected.

- The serious problem with "empty messages" in Echomail directories has been
  fixed. The empty messages will be removed during the first DBUTIL PURGE
  operation. They will not be archived if the Archive Message criteria is
  specified in the Echomail Areas manager - only "real" messages get
  archived during a PURGE operation.

- A very rare and "worst case scenario" of possible Queue problems after
  DBUTIL PURGE completes a run on the NETmail directory has been solved.

- A minor stability flaw, caused by DBUTIL PURGE with a "full" NETmail
  directory has been fixed. The problem could not be used to the advantage
  of any downlinks. But 3rd-party legacy software that generates NETmail
  messages with file-attachments ("InterBBS" games) was shown to cause
  trouble in certain rare conditions.

- A very rare but serious problem of the Queue "locking up" under certain
  conditions if there is a large mixture of outgoing mail for PSTN dialup
  and BinkD transactions in the same Queue has been fixed.

- A minor security flaw in the Areafix Rescan feature has been fixed. The
  flaw could not be exploited by a downlink to cause trouble - but repeated
  Areafix Rescans was proven to slowly degrade performance until the next
  nightly AutoUpdate procedure. Under one condition, it was possible for
  subsequent Areafix requests to fail if those requests also wanted a Rescan
  of the Echomail areas.

- The internal editor should no longer crash during certain PURGE or RENUM
  operations that may take place if such operations are running as another
  process on your operating system.

  WARNING: Purging or renumbering messages while you're in the middle of
           reading or replying using the internal editor is NOT recommended
           and technical support will NOT be offered for problems caused by
           this scenario.

- The problem of the DBRIDGE.ADF database growing out of hand should be
  fixed in this release. Two problem areas have been identified however
  the problem could not be replicated here; please test thoroughly.

- A cosmetic problem with the lastread-pointer problem in the internal
  editor should also be fixed after DBUTIL PURGE. The problem in this case
  had more to do with the way the editor works, rather than DBUTIL itself.

- A cosmetic problem with the DBUTIL log file has been corrected.

- A minor problem with error-logging in the BinkD system has been fixed.
  The fix does not require any adjustment whatsoever to your configuration.

- SR20 should also solve an ongoing "speedy timer" problem under the open-
  source DOSBOX environment (tested with 0.7.1). The problem should be
  solved on both Windows and Linux systems. Again, please do not use
  the "virtual modem" feature of DOSBOX with D'Bridge. The use of mailer-
  over-telnet is not recommended and is largely superseded by the BinkD
  protocol anyway. The dialup modem code in D'Bridge is specifically
  designed to work with hardware (non-emulated) modems.

It is not necessary to shutdown BinkD prior to upgrading your D'Bridge
system to SR20.



2.99 - 9 AUGUST 2008 - SERVICE RELEASE 19
-----------------------------------------

SR19 is a very minor update to D'Bridge.

- Soupgate executables for Windows and OS/2 are now included with D'Bridge.
  You will need to manually rename the desired executable to SOUPGATE.EXE.
  This only applies to those of you using the EMAIL/Usenet gating features
  in D'Bridge. If you aren't, then DO NOT rename any executable files.

- DBUTIL UNDELETE and DBUTIL DELETEDOS commands have been amalgomated into
  DBUTIL SORT AREAS for stability and logistical reasons. Those two commands
  are no longer supported; please modify any maintenance events accordingly.

- DB2RG (D'Bridge to Renegade utility) no longer ships with D'Bridge and
  will no longer be supported; it is being superceded by another program
  that I've been working on.

Nick Andre
www.nickandre.com



2.99 - 26 JULY 2008 - SERVICE RELEASE 18
----------------------------------------

WARNING: If the BinkD module is running in another process, please shut it
         down before installing SR18. After SR18 is installed, you may then
         restart BinkD.

This is a minor update to D'Bridge but you should consider installing this
to bring your system up to better functionality in some aspects of BinkD.

DBUTIL SEND and DBUTIL TRANSMIT have also been slightly corrected but
nothing earth-shattering done to it.

A new question, LOG ERRORS in the BINKD SETUP SCREEN will notify the
console if a BinkD transaction has failed (either in "client" or "server"
mode).

One issue brought to my attention is the use of BinkD on dialup, so I also
added two new questions - START TRANSACTIONS and END TRANSACTIONS. These two
questions allow you to specify any DOS commands you wish to run immediately
before and after D'Bridge manipulates BinkD to move the mail. You would
use those commands to initiate (and terminate) a PPP/SLIP connection on
dialup-Internet. Keep in mind that whatever "dialer" you plan to use in
such a scenario must not ask for console input - otherwise D'Bridge becomes
stuck asking you to do things. For those of you running OS/2 Warp, you must
initiate your dialer with the use of the HSTART utility by Henk Kelder.

WARNING: Under most circumstances, these two questions should be left blank
         and technical support will NOT be offered for BinkD problems if
         you are running external commands using these new options. Only
         experienced D'Bridge administrators with a very thorough knowledge
         of the BinkD protocol should use these features.

Attempting a BinkD session over regular PSTN dialup (non-Internet) is not
supported and I will not offer technical support for any attempts at
manipulating the mailer into beyond what it was designed to do. I don't
care if the protocol "may" work this way; I will not support this method
in the mailer. To be honest, anyone who wants to do that obviously has
a much more pathetic social life than I do.

This also includes running D'Bridge as a mailer-over-Telnet. Sorry but as
of this release I will now stop offering technical support for those setups.
There is simply way too many things that can go wrong with that setup, and I
found myself attempting to help out with OS-related and TCP/IP-related
issues and other things that are far beyond mailer-related stuff. However I
will not remove or change any of the code that makes all of it work; it will
remain as is. You are on your own with mailer-over-Telnet.

I also received questions about TransX compatibility in the EMAIL/USENET
GATING screen. I'm sorry but that is beyond the scope of what I had
originally designed. Only SMTP/POP3 NETmail routing and Usenet gating is
supported in D'Bridge. I do not recommend the use of Internet Email to
transfer your Fido mail as this form of transfers is largely superseded by
the use of the BinkD protocol.

Nick Andre
www.nickandre.com


2.99 - 10 JULY 2008 - SERVICE RELEASE 17
----------------------------------------

This is a very minor update to D'Bridge.

- The problem of writing messages in the internal editor and then having
  the mailer perform an entire Echomail scan instead of just scanning the
  areas written in has been fixed. The problem may of caused duplicate
  messages exported to point systems as per SR16. Please review HISTORY.TXT
  and the notes for SR16 if you are upgrading from SR15 or prior versions.

- An improvement was done to the way that D'Bridge handles Areafix security
  violations.

Nick Andre
www.nickandre.com



2.99 - 6 JULY 2008 - SERVICE RELEASE 16
---------------------------------------

This is a minor release which should solve the problem of messages received
from point systems, then immediately exported back to those same points.
The problem is caused by a misinterpretation of the FAKE POINTNET setting
in the NODELIST setup screen.

Even if you do not forward or hub mail to points, it is highly recommended
to install SR16 to avoid "problems" down the road if you decide to provide
mail for points.

This was a very difficult problem to resolve as the message-processing code
in D'Bridge is very complicated. It took several hours just to figure out
exactly where in the code the problem took place; to say nothing of the fix.

Those of you who know me, know that I am VERY reluctant to change any of the
message-processing code... but in this case it was necessary.

WARNING: This release must be tested VERY carefully if you are hubbing mail
         to point systems. Be prepared to rollback to a prior version in
         the event of problems. DO NOT, UNDER ANY CIRCUMSTANCES, attempt
         to install SR16 if you have "Fake Pointnet For" settings defined,
         without first consulting me directly via phone, Email or NETmail.

Based on tests performed with SR16 on my site and using another workstation,
the problem of duplicate messages appears to be resolved with this release.

Actually I feel bad about it. Its another thing I solved that the non-DB
crowd can't complain about anymore; thereby reducing valuable discussions
and traffic in Fidonet, thereby causing you to actually have social lives on
weekends, thereby leading to the downfall of western civilization.

Nick Andre
www.nickandre.com




2.99 - 1 JULY 2008 - SERVICE RELEASE 15
---------------------------------------

WARNING: You must shutdown the BinkD system, if it is running, prior to
         installing SR15.

This is a somewhat-major functionality update which fixes the bug of not
being able to poll a point-system defined in BINKD SESSION INFO. The problem
was caused by an incorrect method of generating the control files for the
root domains due to an entirely different method used by the BinkD system
for Fido/FTN point address management. The way that D'Bridge manages the
root domains and their corrosponding control files has been slightly
adjusted and improved.

Please note that D'Bridge will NOT exchange mail directly to a point of
another system. If your Fido/FTN address is 1:229/426, you may not generate
a poll-entry for 1:229/427.30. However, you may host-route NETmail and other
"direct packets" to that system's uplink, ie. 1:229/426.1 to 1:229/427 to
1:229/427.30. So basically you may only send Echomail packets or other
direct-corrospondence to any points off your Fido/FTN address,
ie 1:229/426.xxx. I don't quite understand the need to deal directly with
points off other systems; not that I'm asking to be proven wrong as it is
impossible to add support for that without reworking the entire Queue code.
And that my friends, is something that will never happen. The Queue code
has worked for 20 years unchanged for a good reason.

A minor fix was also done to the COMM/MODEM SCREEN - if you disable
the multi-line support, it actually stays disabled now. Shutting down
the mailer is no longer necessary unless you are modifying another node
other than node one.

When SR15 is installed, your D'Bridge system will still show 2.99 as the
version number, but the build-date will show July 1st 2008.

Nick Andre
www.nickandre.com



2.99 - 19 JUNE 2008 - SERVICE RELEASE 14
----------------------------------------

This is a very, very minor release which corrects the MSGID kludge in the
internal editor when you write Echomail messages in networks other than
Fidonet, or more specifically, when the primary address changes to an AKA
address. The problem could not be replicated for NETmail messages.

When SR14 is installed, your D'Bridge system will still show 2.99 as the
version number, but the build-date will show June 18th 2008.

Nick Andre
www.nickandre.com



2.99 - 15 JUNE 2008 - SERVICE RELEASE 13
----------------------------------------

WARNING: You must shut down the BinkD module, if its running as a server
         process, prior to installing SR13. After this upgrade is installed,
         you may then restart BinkD.

SR13 is a very minor release which only corrects and adjusts the way that
sent and received items using BinkD are accounted for in the INBOUND and
OUTBOUND HISTORY SCREENS as well as the INFORMATION menu. Several
fundimental changes have been made to the BinkD support so please test
carefully. Report problems in the Fidonet DBRIDGE echo or to me directly.

Also, the "Show messages in D'Bridge" question in BINKD SETUP has been
changed to "Log BinkD transactions". The default answer is NO, for both
newcomers AND upgrades. If you answer Yes to this question now, a file
called DBBINKD.LOG will be created in your D'Bridge directory.

Some minor corrections have been made to the Setup Wizard. It has been
tested on a few workstations here - but NOT with Windows XP SP3. If
installation problems persist on Windows XP SP3, please let me know.

When SR13 is installed, your D'Bridge system will still show 2.99 as the
version number, but the build-date will show June 15th 2008.

Nick Andre
www.nickandre.com



2.99 - 11 JUNE 2008 - SERVICE RELEASE 12
----------------------------------------

WARNING: SR12 includes the BinkD fix of SR11. If your D'Bridge system is
         version SR10 or older, you should first refer to HISTORY.TXT
         or consult the Fidonet DBRIDGE echo as a fundimental change was
         done in SR11 to correct a problem with the BinkD system.

This is a very, very minor release that fixes a few ongoing "behind the
scenes" problems in the mailer, editor, DBUTIL and Fido Plug and Play.

There are no new features in this release; only corrections to the code.

I may not be able to participate in Fidonet as often as I would like to,
over the next few weeks. I will still answer all personal corrospondence
but am recommending that troubleshooting/diagnostic issues be discussed
in the Fidonet DBRIDGE echo. If you are a newcomer, the "fan club" will
be more than happy to assist you with your D'Bridge installation questions.

When SR12 is installed, your D'Bridge system will still show 2.99 as the
version number, but the build-date will show June 11th 2008.

Nick Andre
www.nickandre.com




2.99 - 22 MAY 2008 - SERVICE RELEASE 11
---------------------------------------

A recent test on a workstation revealed a SERIOUS fundimental problem with
the way that I programmed a certain aspect of the integrated BinkD support.

This is a CRITICAL stability update for D'Bridge if you are using the
integrated BinkD support AND you are creating uncompressed mail packets
via the "U" option in the BINKD SETUP screen. If you are not using the
Uncompressed Mail Packets feature; then it is not necessary to install
this upgrade or concern yourself with the specific problem it addresses.

***IT IS ABSOLUTELY ESSENTIAL THAT YOU INSTALL THIS UPGRADE*** if you are
using that feature. Technical support will NOT be provided for that specific
feature if you do not install the SR11 upgrade. Please DO NOT post requests
for help in the Fidonet DBRIDGE echo for the Uncompressed Mail Packets
feature until you have upgraded to SR11. Only after the upgrade has been
installed will I answer questions about what the problem was.

SR11 only corrects that problem. It does not resolve any other issues.

When SR11 is installed, your D'Bridge system will still show 2.99 as the
version number, but the build-date will show May 22 2008.

Nick Andre
www.nickandre.com




2.99 - 16 MAY 2008 - SERVICE RELEASE 10
---------------------------------------

This is a minor update for D'Bridge, to address some problems with the way
certain operations work for PSTN dialup sessions. Rest assured that the
fundimental code that controls dialup mail exchanges has NOT been changed.

The only reason this update is being released is from recent testing with
the MagicJack VOIP solution (www.magicjack.com). If it wasn't for that, then
I would not be able to correct the following problems.

WARNING: You should not install this release until the Queue is empty. If
         this is not possible for whatever reason; then pay close attention
         to the way the Queue works and report any problems to me ASAP.

In a scenario where there are a large amount of Queue entries and its a
mixture of both BinkD and PSTN dialup calls, a cosmetic problem began to
occur when the Healthgraph is enabled. This has been solved, along with
a very rare but potential stability problem when you have PSTN dialup Queue
entries and you press Q (for QuickDial mode).

A potentially serious delay problem has been solved during an EMSI session
on PSTN dialup if you use the Intercom (Instant-messaging) feature and you
elect to view the remote system's BBS or mail-waiting by pressing F1, and
then press ALT+X to instruct D'Bridge to shut down after the session has
completed.

A potential security problem has been resolved in the instant-messaging code
for PSTN dialup in the form of a Zmodem-exploit situation where it was
possible to cause a long delay in the response of whoever initiated the
instant-messaging conversation by sending Zmodem frame-initializing bytes.

A minor delay problem has also been fixed if a PSTN dialup session cannot
establish EMSI or WaZOO and reverts to FTS-0001 mode, and something is
preventing a successful session. The code has been adjusted to abide to a
maximum 3 minute time-out (180 seconds) if all else fails in D'Bridge-land
and for whatever reason the mail can't be exchanged. Usually in such cases
the lack of communication is caused by MNP compression failure in the dialup
modem, line noise, or other factors (ie. call-waiting)

When SR10 is installed, your D'Bridge system will still show 2.99 as the
version number, but the build-date will show May 16th 2008.

I'm also going to the E-Bay conference in Chicago the second-last weekend of
June, if any of you "fellow churchgoers" are within that area and want to
meet up downtown.




2.99 - 10 MAY 2008 - SERVICE RELEASE 9
--------------------------------------

This is a very minor release which corrects a few ongoing display problems
in certain aspects of D'Bridge.

When SR9 is installed, your D'Bridge system will still show 2.99 as the
version number, but the build-date will show May 10th 2008.

Nick Andre
www.nickandre.com



2.99 - 1 MAY 2008 - SERVICE RELEASE 8
-------------------------------------

A very minor release which fixes the obvious problem with personal mail
waiting along with a minor improvement on how its shown in the mailer. A
stability problem with DBUTIL PURGE on NETmail messages has been fixed.

When SR8 is installed, your D'Bridge system will still show 2.99 as the
version number, but the build-date will show May 1st 2008.



2.99 - 29 APRIL 2008 - SERVICE RELEASE 7
----------------------------------------

This is a small update for D'Bridge, which corrects a few minor problems,
mostly specific to the internal message editor as per recent discussions
in the Fidonet DBRIDGE echo. If you don't use the internal editor, then
its not necessary for you to install this update right now.

When SR7 is installed, your D'Bridge system will still show 2.99 as the
version number, but the build-date will show April 29th 2008.

- The lastread pointers resetting to message 1 (in most cases being
  the "NOECHO" message) should be fixed now.

- Messages numbered over 8150 should display correctly now.

- A slight adjustment has been done to the display of personal messages.

- Hal keeps quiet now after personal mail is unpacked and subsequent
  QueueScan's are performed.

Coincidentially, the release of SR6 killed the traffic in FTSC_PUBLIC. As
a newly elected member, this is very concerning. So therefore, I plan to
add a feature to purposely cut-off quoting of messages replied to in that
echo as well as letting you add hidden message kludges of your choice
(ie. ^AZONE_1_SUBLIMINAL_MESSAGE). I promise I'll come up with something fun
for an entertaining flame war from our friends in the non-DB crowd.

Nick Andre
www.nickandre.com



2.99 - 20 APRIL 2008 - SERVICE RELEASE 6
----------------------------------------

This is somewhat of a major upgrade for D'Bridge. It adds some new
facilities to automate routine tasks for those of you who are Network
Co-ordinators so your D'Bridge system can be better maintained. An extremely
rare but serious stability flaw has also been fixed in this release.

WARNING: The format of the DBRIDGE.ADF file, which controls the Echomail
         areas, has changed. If you are a 3rd-party developer, please
         refer to TECHSPEC.TXT for the updated database structure for
         this file.

WARNING: DO NOT, UNDER ANY CIRCUMSTANCES, use any other version of DBUTIL
         with SR6. It is not recommended to downgrade/rollback to a previous
         version of D'Bridge if the new features are going to be used.

When SR6 is installed, your D'Bridge system will still show 2.99 as the
version number, but the build-date will show April 20 2008.

- If DBUTIL MOVE is being ran in another window or process on your computer,
  it now waits for any Queue operation on the node in question to finish, or
  an entire Echomail scan to finish first before proceeding. This was done
  to prevent any "problems" with moving mail under certain conditions on
  busy server systems. A dummy/semaphore file called DBRIDGE.QIP (short
  for QueueScan In Progress) is created when the Queue is accessed. Its
  removed when the QueueScan is done. Its also created during Echomail
  scan operatons (initiated manually only) and removed when thats done too.
  The DBRIDGE.QIP semaphore is not created during UnpackMail (tossing)
  cycles because the way that D'Bridge handles forwarding of mail and
  the Queue itself is treated differently in a manner that does not cause
  problems for DBUTIL MOVE.

  And yes, the code is smart enough to determine if a QueueScan is taking an
  unreasonably-long amount of time to finish as well in the event that the
  computer has crashed; because D'Bridge creates a semaphore file to tell
  DBUTIL that its busy modifying the Queue entry for the node in question.
  The code is also not affected by "QueueScans before midnight".

  If all else fails, DBUTIL MOVE resumes operation after approximately
  1 minute 30 seconds if it can't "gain access" to the Queue because
  its locked.

  The QueueScan "locking" is controlled by a dummy/semaphore file called
  DBUTIL.DCQ (short for Don't Check Queue status). If this file exists,
  then DBRIDGE.QIP semaphore checking is NOT done and DBUTIL will execute
  the way it has in SR5 and prior versions.

  WARNING: THIS IS THE DEFAULT SETTING, to prevent problems with existing
           processes or batch files - If you want the checking, you MUST
           erase the DBUTIL.DCQ file that will be created when you install
           SR6 for the first time. QUEUE CHECKING IS DISABLED BY DEFAULT.

- A new command, DBUTIL SHOWDEADECHOES [days] will produce a log of any
  Echomail areas that have not had any traffic in them in the specified
  number of days. This is saved in both the DBUTIL.LOG file, and, a
  plain ASCII text file called DEADECHO.LOG is created (or appended)
  containing just the Echomail tags, a space, and their description if
  available. That text file can be used as part of any "robot" reporting
  process or anything you can think of.

- The new command DBUTIL REMOVEDEADECHOES [days] [optional uplink] will
  actually remove the dead echo from your system.

  DBUTIL REMOVEDEADECHOES 90 1:123/500

  means that DBUTIL will remove any Echomail areas that have not had any
  traffic in them after 90 days, AND create an Areafix request to un-
  subscribe from my uplink. Note that for the Areafix feature of this
  command to work, the proper criteria must be defined in the PACKET/MAIL
  CONTROL screen in D'Bridge for your uplink in the AREAFIX INFO question.
  You do not specify the Areafix password in this command because its
  being culled from your D'Bridge configuration.

  An ASCII text file NUKEECHO.LOG is created (or appended) whenever Echomail
  areas have been removed from your system. The format of this file is
  the Echomail tag, a space, followed by a space, then the description if
  available. As per above, this can be used as part of automated
  "housekeeping" events you may be running.

- When a dead echo is removed by DBUTIL, it doesn't just kill the message
  directory; it does a PURGE on all messages. So, if you specified message
  archiving criteria, then DBUTIL will archive all of the messages in
  that echo into whatever text-file you specified. After the PURGE is done,
  then the message directory is removed and the database entry is erased
  out of the Echomail manager. 

  WARNING: I understand that an Echomail message directory may be in use
           by other processes or 3rd-party applications. I wouldn't want
           DBUTIL to encounter a problem and cannot continue and having it
           apologizing for the inconvenience. So if removing the directory
           after purging dead echoes is not what you want, create
           a dummy/semaphore file called DBUTIL.DRD (short for Don't Remove
           Directory). If you don't want the messages purged either, create
           a dummy/semaphore file called DBUTIL.DPM (short for Don't Purge
           Messages).

- It is possible to use DBUTIL UNDELETE to restore any Echomail areas that
  have been erased by the above commands, provided that you did not perform
  a SORT AREAS request on the database.

- Note that the above new commands do NOT work for Passthru Echomail areas
  because the messages in those areas are not actually stored on your
  system anywhere. Removing Passthru areas is automated by D'Bridge itself,
  not through the use of DBUTIL; refer to the questions in PACKET/MAIL
  CONTROL for more explanation.

- A new command, DBUTIL RESETLASTACCESSEDDATE, will reset all of your
  Echomail areas "last accessed" dates to todays date. This is performed
  when SR6 is installed for the first time - and is only done once.

- QWK index numbers have been corrected on auto-adding Echomail areas.

- The "Global Change" command in DBUTIL has been updated to do SORT AREAS
  first before any mass-editing takes place.

- The overall performance of the Health Graph should be vastly improved now.

- Feeding D'Bridge mail after midnight no longer causes the Gremlin to
  mysteriously and randomly hang the mailer during an UnpackMail cycle
  on plain PKT files.

- A new question, "ADD MISSING KLUDGES" has been added to the PACKET/MAIL
  CONTROL screen. Specifically, this allows D'Bridge to allow legacy BBS
  software to function properly within basic Fidonet kludge-line compliance.
  It also allows you to effectively "trap" non-compliant routed messages.

  Under most circumstances, answer NO to this question - the default
  setting - unless you have very good reason to suspect that a system is
  routing messages through you that are not conforming to standard. This
  should only be used as a debugging tool, or for legacy BBS software; not a
  permanent solution. It will slow down processing.

  When you answer YES to this question, the kludge lines which will be added
  if they are missing will be the INTL and FMPT/TOPT for NETmail messages,
  and MSGID for both NETmail and Echomail messages. The TID kludge will also
  be added to indicate that the message was modified by D'Bridge "in
  transit" to destinations.

  WARNING: DO NOT, UNDER ANY CIRCUMSTANCES answer Yes to this question
           unless you are an experienced Fido network administrator.

- Generally speaking, if the above mentioned feature has actually reported
  "problems", then you should politely notify the Sysop via NETmail and
  possibly ask if its possible to check for a program update, or, bring
  this to the software author(s) attention. Don't make a big deal about it
  as this feature is nothing more than a stopgap-measure. Above all, it
  should be understood and appreciated that there may be new Sysops who want
  to "re-live the good ol' days" by installing their favourite BBS software
  from the 80's and early 90's. Recent Internet web sites for "abandonware"
  BBS software such as Phil Becker's TBBS and Galacticomm's MajorBBS/
  WorldGroup products are beginning to spark renewed interest in our hobby.

  It is not my intention to get into debates about kludge-lines. The above
  feature was primarily added for legacy BBS support only.

- A new question, "CHRS Line Kludge" has been added to EDITOR OPTIONS, and
  this allows you to override the default character-set definition for
  messages written using the internal editor. The default setting is IBMPC 2
  and has been that way since version 1.87. I really don't quite understand
  the significance of changing the value, but if you need to do that, its
  now a feature instead of a hardcoded value.

- The TID kludge addition in the internal message editor has been removed
  and D'Bridge only generates TID kludging as per the ADD MISSING KLUDGES
  question explained earlier. The PID kludge is still intact.

- A slight improvement to the way the code works for MSGID/REPLY kludging
  has been done. And yes, it was tested quite rigorously to ensure that it
  still works properly after I made my changes.

- Quoting kludge lines in the internal editor when the SHOW KLUDGES feature
  has been enabled in EDITOR OPTIONS no longer causes "duplicate" kludge
  lines on the saved message.

- Making a change to a NETmail message no longer causes duplicate kludges.

- Multi-user notification of personal mail in the internal message editor
  has been corrected.

- When using the internal editor with aliases/handles, you must be sure to
  specify your real name first, followed by the aliases/handles in the
  ADDITIONAL USERS question in EDITOR OPTIONS. This is not necessary if
  you are using D'Bridge to participate in networks other than Fidonet.

- Personal mail via the Y command works again as it did before but it is
  going to be redesigned for a future release.

- The date and time of the system log display should be correct now.

Don't worry, theres more bugs. But hopefully I'll find that perfect balance
between bugs-that-annoy-DB users and bugs-that-annoy-non-DB users. I promise
I won't solve them all - because if I do, then the non-DB crowd would have
nothing to complain about, thereby decreasing our valuable precious Fido
traffic, thereby Echomail forums would die, and thereby Fidonet itself would
die. Aren't you glad I'm doing my part to keep our hobby alive?

Nick Andre
www.nickandre.com



2.99 - 5 APRIL 2008 - SERVICE RELEASE 5
---------------------------------------

This is a very minor update to D'Bridge which should correct several minor
ongoing problems with DBUTIL. An extremely rare lockup condition has also
been fixed in the AutoUpdate event routine.

When SR5 is installed, your D'Bridge system will still show 2.99 as the
version number, but the build-date will show April 5rd 2008.




2.99 - 3 APRIL 2008 - SERVICE RELEASE 4
---------------------------------------

Service Release 4 is a very, very minor release to D'Bridge that should
correct the "Xmail Bundle Corrupt" or "Unable to create ZIP" problems
when the BinkD support is disabled. The problem was replicated here
on a workstation and was to do with the logic behind how certain variables
conditions were treated.

Please test SR4 carefully and report any problems ASAP via the Fidonet
DBRIDGE echo or MSN Email.

When SR4 is installed, your D'Bridge system will still show 2.99 as the
version number, but the build-date will show April 3rd 2008.

Nick Andre
www.nickandre.com



2.99 - 31 MARCH 2008 - SERVICE RELEASE 3
----------------------------------------

Service Release 3 is a major update for D'Bridge 2.99.

Two new enhancements were done to the BinkD system in addition to a revised
and redesigned flag-translator in the nodelist compiler. It is now possible
to poll any system in the nodelist using the D'Bridge BinkD system rather
than whats just defined in the setup screens; please review these release
notes in detail. Minor cosmetic improvements have been done as well.

When SR3 is installed, your D'Bridge system will still show 2.99 as the
version number, but the build-date will show March 31st 2008.

WARNING: I will not get into political discussions about the new native
         support for BINKD.TXT or nodelist INA/IBN flags, the features were
         added to let you scale/customise D'Bridge better to your needs.
         Any work on things to do with nodelist handling has been done with
         the upmost care and respect for those of you who wish to have such
         support "disabled" - and the new BinkD feature defaults to disabled
         when upgrading from 2.99 SR2 or previous versions.

- Minor updates were done internally to the D'Bridge Setup Wizard to
  facilitate improvements to the FPNP system for Service Release 4 (SR4)
  which should be due the middle of April.

- A new question, USE THE BINKD.TXT FILE, has been added to the BinkD setup
  screen to support the use of BINKD.TXT. It was actually suggested quite
  some time ago back when I released 2.95. But due to the large amount of
  code required to support integrated BINKD.TXT file management; it was
  something I never really got around to do until now.

  WARNING: This feature is for experienced D'Bridge administrators and
           requires that a file called BINKD.TXT be obtained from your
           uplink and/or a reputable system. This must be placed in your DB
           directory before you enable this feature.

  If you wish to poll systems outside of whats defined in the BINKD SESSION
  INFO screen, then D'Bridge needs to know where to obtain the Internet
  address information from... since the BinkD subsystem does not access
  the nodelist databases directly.

  If you answer YES to this question, then D'Bridge will check for the
  presence of BINKD.TXT, which appears to be a weekly "list" of BinkD
  systems culled from the master Fido nodelist. D'Bridge will then add
  entries from the BINKD.TXT file to your BinkD configuration when its
  necessary. Ask your uplink for more information or in the Fidonet DBRIDGE
  echo for more information about the BINKD.TXT file.

  This now lets the POLL command work properly, and in theory lets others
  such as TRANSMIT FILES work as well; however, be warned that a temporary
  directory called BLISTDIR is created. This holds any mail that shall be
  sent to the system during a transaction based on a BINKD.TXT file entry
  and not whats defined in the setup screen. The contents of BLISTDIR are
  not erased; and in the event of failure; it is up to you to erase it.

  Answering NO to this question shuts this feature off (the default setting)
  and makes D'Bridge behave as it has in 2.99 SR2 and prior releases.

- Now, if polling a system from BINKD.TXT fails, then it may be necessary to
  create the domain directories manually. D'Bridge and DBUTIL create the
  domain directories in the DATA folder. If you are exchanging mail in a
  Fido zone other than your own, then you need to create the directory
  for that zone. For example, if my 1:229/426 address tries to exchange mail
  with 2:2/20, then I must first make sure the DATA\FIDONET.002 directory
  exists beforehand... otherwise the transaction fails because D'Bridge
  can't find the proper domain directory. DBUTIL and D'Bridge do not
  automatically create out-of-zone domain directories. Use caution when
  testing polls for out-of-zone systems.

  Further discussion on BinkD domains or domain usage in more elaborate and
  complex setups may be better posted in the BINKD echo on Fidonet.
  Technical support is limited to diagnosing D'Bridge-specific domain
  configuration and usage only.

- In the case of a "hybrid" listing (a node number with a PSTN entry and a
  BinkD entry), D'Bridge defaults to using the BinkD information. If a
  dialup modem is not configured, then the Queue entry becomes "Hold/
  Unlisted". This was actually programmed awhile ago in a previous release
  but needs to be brought to your attention if you have a "hybrid" setup.

- Further issues with polling "BINKD.TXT-listed" systems requires additional
  diagnosis by either myself or others in the Fidonet DBRIDGE echo.

- A "looping poll" condition has been solved when running D'Bridge on
  the OS/2 Warp operating system and Serenity's ECS environment.

- A "trap-keyboard" condition has been solved when running D'Bridge
  on MS-DOS 6.22 with DESQview/386.

- A possible lockup condition has been fixed in the built-in terminal
  program when downloading a file using Zmodem and for some reason the
  connection failed; causing a timeout.

- A possible lockup condition when navigating the help system and doing an
  extensive use of "See Also" has been fixed.

- The built-in "Intercom" system (instant-messaging during file transfers)
  has been fixed so that the "Chat commands" works the way it was designed
  to do so originally. If by chance you happen to use the Intercom, D'Bridge
  now lets you see what the waiting mail is (allowing you to discuss it),
  request files (FREQ), or access the remote Sysop's BBS if its configured.

- The STANDARD SCANS question in PACKET/MAIL CONTROL has been removed
  entirely (and D'Bridge will only use standard-scans in Echomail now).

- The RUN DOS COMMANDS in the SCHEDULER for Mail-type events has been
  removed. The presence of a dummy/semaphore file called DBRIDGE.AMR (short
  for After Mail Received) now tells D'Bridge to run the DOS commands
  defined in the SCHEDULER for any Mail-type events. This file is NOT
  removed after such events are ran, and was actually an undocumented
  feature since 1.58 - the code for it was never finished. Until now.

  WARNING: The use of DBRIDGE.AMR on multi-line setups is not recommended.

- When YOUVE GOT MAIL is enabled, the internal message editor now shows
  messages addressed to you in a brighter color when you LIST them. This
  should make it easy to pin-point personal mail now. Due to the fundimental
  design of the editor, it only works when pressing HOME, PGUP, PGDN or END
  as the ARROW KEYS currently "prevent" the new coloring.

- YOUVE GOT MAIL has also been enhanced to play audio files of your choice
  when new personal mail arrives. If a batch file exists in your DB
  directory called PLAYMAIL.BAT, then D'Bridge runs this upon showing the
  notice in the LOG screen. The PLAYMAIL.BAT file should contain nothing
  more than a command to play the audio file at the DOS prompt.

- I've included a sample setup called PLAYMAIL.ZIP in this release, for
  Microsoft Windows environments. Unzip the PLAYMAIL.ZIP into your DB
  directory if you are running Windows... and Hal from 2001 will greet
  you personally.

- The playing of audio files will only happen during the times specified in
  the Audio Options questions in BASIC CONFIGURATION.

- The D'Bridge Web processor (DBUTIL PROCESSWEB) has been slightly
  enhanced to support XML markup language, embedded Javascript and the use
  of frames-based HTML code. A trap-condition in 2.99 SR2 and prior
  versions prevented the use of more "complex" code in the template files.

- A minor cosmetic correction has been done to the Information Display
  screens.

- The help file has been slightly updated in this release.

Nick Andre
www.nickandre.com




2.99 - 21 MARCH 2008 - SERVICE RELEASE 2
----------------------------------------

Service Release 2 is a very minor update to 2.99, as per recent discussions
in the Fidonet DBRIDGE echo. This release only deals with semaphore/dummy
files. A very minor cosmetic correction was also done to this release.

When SR2 is installed, your D'Bridge system will still show 2.99 as the
version number, but the build-date will show March 21st 2008.

- If you create a DBEXIT.xxx [where xxx is the DOS errorlevel you want],
  then D'Bridge will be shutdown accordingly when the system is IDLE or
  between "calls". When multi-line is enabled in the COMM/MODEM SETUP
  SCREEN, then all running copies of D'Bridge will be shutdown upon
  seeing DBEXIT.xxx.

  Due to the fundimental design of the internal D'Bridge multi-tasker,
  the mailer will NOT be shutdown during the processing of mail, exchanges
  with PSTN sessions, or executing a DOS event defined in the Scheduler.
  Only after such events are finished will the mailer check for the presence
  of the DBEXIT.xxx files and shutdown accordingly. This may be of concern
  for those of you running processes or batch-files that are somewhat of
  a "timely" nature and D'Bridge is busy processing large volumes of mail.

  When D'Bridge has shutdown, it will erase the dummy file it made. So if
  you told it to shutdown via DBEXIT.200, then the mailer shuts down with
  errorlevel 200, and erases that file. When multi-line is enabled, the
  last running "copy" of D'Bridge will erase that file.

- A dummy file called DBRIDGE.NSP (short for "Not Shutdown Properly") is
  created whenever D'Bridge starts up and it has determined that the mailer
  has been improperly shutdown (as per the initial LOG window). This dummy
  file is erased upon proper shutdown of D'Bridge via QUIT commands or the
  use of the trigger-files mentioned above. The creation of DBRIDGE.NSP may
  be useful for those of you running D'Bridge on server-systems which run
  3rd-party software that may not "fire up" properly after a system crash
  such as Harold Harm's Allfix or Charles Cruden's Internet Rex. The dummy
  file would be used in a scenario in any such batch files to run "checks"
  on your setup, restore automated backups, etc etc.

- The DBRIDGE.TCK file should be erased now when "returning" from GoldED or
  other external message editors.

Nick Andre
www.nickandre.com


2.99 - 18 March 2008 - SERVICE RELEASE 1
----------------------------------------

WARNING: D'Bridge requires a full 640k of memory to function properly. If
         your DOS environment is reporting 590,000 kilobytes or less, you
         may be unable to use this release properly.

Service Release 1 is designed to correct and address several reported
problems with D'Bridge 2.99. There are no new features in this release.
If you are a newcomer and installing D'Bridge for the first time, you don't
need to concern yourself with these notes.

When this release is installed; the version number stays the same but the
build-date will state March 17th. Remember that the version and build-date
are displayed when you exit D'Bridge, underneith the blue bridge logo.

- The display of modem activity is shown the way it was in prior versions
  when the Health Graph feature is shut off in WINDOW/DESKTOP settings.

- A very, very rare but potentially serious stability bug has been fixed
  when you are using a dialup modem with D'Bridge under Windows NT, 2000,
  XP, Windows Server 2003 or Windows Vista operating systems.

- Specifying a dialup modem in D'Bridge, then opting not to use it (ie.
  erasing the entry in COMM/MODEM SETUP) no longer "hangs" the mailer.

- The dialup modem requirement for ClockSync functionality has been removed.

- The problem of Echomail being written in the internal editor (with the
  Scan Echomail feature disabled), tossing new messages and then not having
  the original scanned out later on should be resolved now... for good.

- DBUTIL MOVE will no longer halt on "problems" if running from a batch file
  or external event.

- D'Bridge should properly perform a Queuescan when GoldEd is used instead
  of the internal message editor and the Rebuild Queue option is set to Yes.

- Reports of corrupt outgoing packets was investigated but I was not able
  to replicate the problem here. However, several minor changes were made
  that may solve the problem.

- Minor changes were done to the system timer to hopefully resolve the
  reports of freezing; again, a problem that I am not able to easily
  replicate here.

- D'Bridge should now properly install on "plain" DOS systems but be
  advised that SHARE.EXE must be installed when running D'Bridge
  in a plain-DOS environment.



2.99 - 10 March 2008
--------------------

WARNING: D'Bridge requires a full 640k of memory to function properly. If
         your DOS environment is reporting 590,000 kilobytes or less, you
         may be unable to use this release properly. The mailer doesn't
         check for free memory - Theres not even enough codespace anymore
         to do THAT.

This is a very, very minor release. Its designed to prepare your entire
Fido system for the upcoming version 3 series.

D'Bridge 3 will be the last of the DOS versions, unless serious bugs are
brought to my attention that require fixing. It takes over several hours to
fix one problem in the code; due to its assembly-language nature and
complicated use of codespace and variables. What that means to you, is that
I plan to offer what I promised for version 3 and call it quits with DOS.

Future development will be focused entirely on the Windows/Linux/Macintosh
rewrite (version 4) and will be 100% GUI with a completely redesigned kernal
and functionality. The look and feel, configuration file and so forth will
be kept the same and will be completely cross-platform; so more time can be
spent enjoying Fidonet and less time dealing with software issues.

D'Bridge 4 should be due out by summer/fall this year. When that happens,
all previous versions and work will be archived-up and retired for good.

- Switching from the BinkD support to Charles Cruden's Internet Rex or
  some other solution no longer causes problems when you've ran everything
  then opt to disable BinkD in D'Bridge.

- A problem in the scheduler with polling a UUCP/Email/Usenet system and
  having another poll execute immediately afterwards has been fixed now.

Nick Andre
www.nickandre.com



2.98 - 3 March 2008
-------------------

WARNING: When 2.98 is installed, it is NOT recommended to rollback
         to prior versions. Please backup your data accordingly.

This is a minor release that improves BinkD even more and fixes "Invalid
arguements" in Binkd setups by moving the domains into the DATA directory.
Minor adjustments have also been done to overall operation.

For newcomers: Whenever you upgrade a version of D'Bridge, a tiny assembly
language program called DBUPD (D'Bridge Upgrade Advisor) runs before
exporting your current setup and actually updating the files. DBUPD runs
because in certain previous versions; it was not possible to export or fix
certain problems of my doing. DBUPD is a normal part of the installation/
upgrade process of D'Bridge and is no cause for concern.

Note that if you plan to run D'Bridge on a Linux platform, the use of
DOSBOX or DOSEMU is highly recommended. How you plan to exchange mail is up
to you. A modem is not required obviously and it is not required to
define a "dummy modem" in DOSBOX.

NOTE: It has been reported that DOSBOX does not properly "refresh" when new
      mail or files are received.

So that being said, you have three options in this case. You may run BinkD
for Linux. D'Bridge 2.98 fully supports a Linux-based configuration file now
and significant work was done to improve support for the way that it runs on
Linux. However, BinkD for Linux does NOT ship with this release of D'Bridge
but you can download it from Janis Kracht - www.filegate.net/mail or
www.2f.ru/binkd. BinkD should be unpacked into your DB directory.

Your second option is you can either network or map-out the virtual DOS
session so D'Bridge looks to create outbound mail somewhere else for actual
sending (ie. another workstation on a LAN).

Your third option is to run D'Bridge entirely on a Windows PC and use your
Linux computer for message editing, BBS, etc etc. The BinkD that ships with
D'Bridge 2.98 can run with as far back as windows 95, so, an older legacy PC
can easily do the job.

Lars... your feedback awaits. ;-)

- When installing this release for the first time, the D'Bridge Upgrade
  Advisor (DBUPD component) will show you a list of domains that it needs
  to move. One by one, it will attempt to move them. At the end of the
  installation please check the DATA directory for the presence of the
  domains, if they are not there please let me know ASAP.

  The D'Bridge Upgrade Advisor only moves the domains once and once only.

- Additional checking is done in the BinkD setup screens against invalid
  domain names.

- A new question allows you to specify the base-location to store mailboxes,
  in BINKD SETUP. You must shutdown BinkD if its running, before changing
  this option. D'Bridge does NOT move the mailboxes for you; you must do
  this manually. The default setting is to have D'Bridge store the mailboxes
  in your DB directory.

  ***WARNING*** Only experienced D'Bridge operators should use this feature.
  The moving of BinkD mailboxes is NOT recommended. The feature is only
  provided for advanced troubleshooting/customising only. Technical support
  will NOT be provided for this feature.

- When set to Linux mode, BinkD now may only be used as a "server" - the
  "Run as a server" question becomes disabled because it is not possible
  for DB to call BinkD for Linux from within DOSEMU or DOSBOX, the way that
  it can for Windows or OS/2.

- Minor problems of my doing have been fixed in the mailer and Queue scan
  code.

- Missing BinkD domains should be properly created now.

- The default BinkD domain ("root-domain" in DBRIDGE.BNK) is now properly
  written and saved for those of you with multi-network configurations.

- Various problems with Soup gating with a dialup modem enabled have
  been fixed.

- The system uptime should be properly kept now.

- A possible crash in DBUTIL PURGE has been fixed when an archive-text file
  is specified in the Echomail Manager and for some reason it can't be
  opened properly.

- A slight correction has finally been done to the Editor Options screen so
  that if you chose anything but the internal editor as your preferred
  reader, then the other options would remain (ie. You've Got Mail).

- A slight correction has been done to the internal message editor when you
  choose to write NETmail messages to multiple non-CM recipients (CC'ing).




2.97 - 26 February 2008
-----------------------

This is a very minor release, essentially a "refresh" of 2.96 with some
cosmetic fixes done to the Queue and random freezing should be corrected.
I was not able to replicate that problem here as 2.96 was running fine
for days on end now, but I looked at the code and saw some things that may
of caused that problem. If this release does not fix things, please let me
know ASAP.



Version 2.96 - February 20 2008
-------------------------------

This is a minor release which adjusts performance of the mailer's overall
operation, and enhances BinkD. If you are NOT using the BinkD integration I
wrote or you're using Charles Cruden's Internet Rex, it is not necessary
to install this update.

- BinkD support is improved in this version and mixed into the mailer now as
accounted for the same as dialup sessions. When an outbound "call" is being
placed, the familiar OUTBOUND SESSION INFO screen (from the days of
dialup) is shown before the "swapout". Uncompressed raw Echomail does not
show up in this screen but all other types of messages should (ie. NETmail,
XMAIL, file-attachments and so forth).

- Random keyboard lockup problems and other such nonsense should be fixed
permanently now. I was not able to replicate some of these problems but I
found some glaring mistakes that needed to be fixed.

- A minor problem with DBUTIL SORT AREAS should be fixed.

- The web processor works about 25% faster now.

- Auto-polling systems, cancelling, then immediately starting D'Bridge again
causing another poll, should be eliminated now.


New feature - Health Graph
--------------------------

As an eye-candy treat for all of you, and my love of TBBS, I added a
"Health Graph" to D'Bridge.

This is a general graph of the overall performance of the mailer. The
graph shows CPU load, Exchanges (ie. time spent dealing with BinkD or dialup
calls), and mail processing. The total system uptime since last shutdown is
also displayed. The health graph is shown on the bottom of the screen and
updates approximately every 5 to 15 seconds depending on CPU load.

The health graph is color-coded. Green means your D'Bridge system is
operating normally under ideal conditions. Yellow means the mailer is
getting busy. Red means that D'Bridge is spending a lot of time processing.
If things get in the red, it would mean your computer is turning into quite
the little mail hub...

And folks - It even doubles as a message-ticker simular to a stock exchange.
Personal messages that are waiting for you are "scrolled" in the graph, one
by one, every few seconds. This of course only works if YOUVE GOT MAIL is
enabled.

The new feature is turned on or off in the WINDOW/DESKTOP SETTINGS screen.

Nick Andre
www.nickandre.com



Version 2.95 "final" - February 12 2008
---------------------------------------

This is a major release, quite possibly the most important one of the 2.xx
series since the first 2.0 was introduced a few years ago after the takeover
of the project from Chris Irwin.

A few months of dedicated hard work has gone into this release, and
several thousand lines of code later, I think this is the release that will
officially solve a LOT of ongoing problems we've been having for awhile.

Theres lots to talk about, so lets first summarise this document/posting:

- Redesigned BINKD support
- Redesigned Internet EMAIL/USENET gating
- Cell phone/SMS support
- Redesigned installation for newcomers
- Support for PKT-only generation for large systems
- Dozens of fixes and corrections since 2.94 including serious bug fixes.


Redesigned BINKD system
-----------------------

WARNING: When upgrading from 2.94 or previous versions, BINKD support is
         set to DISABLED, to make sure you understand how the new system
         works - and to prevent accidential loss of mail.

- The entire BINKD configuration screen has been rewritten from scratch, and
  support has been reprogrammed to fix bugs for both clients-only and
  those of you running servers. If you have enabled the BINKD support from
  2.94 or prior versions, your BINKD setup should be preserved but you may
  need to re-enter Internet ports and SOCKS 4/5 information.

  When you enable BINKD as a "Server", D'Bridge no longer calls BINKD to
  exchange mail - instead, you must manually run and "leave" the BINKD
  program running in another window on your operating system to handle the
  mail. D'Bridge will update the "Queue" for BINKD automatically. Please
  refer to the on-line help screens for the redesigned BINKD system as
  some things have been changed with how everything works.

  WARNING: The "-C" parameter mentioned in 2.94 and earlier MUST NOT BE
           USED when running BINKD in this version of D'Bridge.

- An enhancement has been done to the BINKD SESSIONS screen to allow you
  to connect to a non-standard "port" for a specified system; overriding
  the default INCOMING and OUTGOING PORTS in the BINKD Setup Screen. Non-
  standard ports for BINKD outgoing sessions is a feature found in certain
  3rd-party software and I am including it for convenience, for those of
  you who exchange mail with Sysops running bizarre or strange setups.

  WARNING: It is NOT RECOMMENDED to run BINKD as a server on a non-
           standard port with D'Bridge. You will not be able to accept
           connections from other BINKD systems unless they know exactly
           what your port number is.

- The format of the "new" BINKD Session Information screen is as follows:

  <ADDRESS> <DOMAIN> <ID> <IP OR PICKUPONLY> <PASSWORD OR NONE> <PORT>

    ie.

    1:229/426 fidonet NANDRE nickandre.com ABC123
    1:229/2000 fidonet RCOUTURE hub2000.darktech.org ABC123 24551
    1:229/0 fidonet PSIMPSON PICKUPONLY NONE

  The PORT parameter is new and tells D'Bridge that the BINKD system should
  connect on a specific port. Its optional and if not specified, it will
  use the value of the OUTGOING PORT defined. So if I've defined the
  OUTGOING PORT to the default 24554, every system in the BINKD SESSION
  INFO will use it unless, in the above example, its 1:229/2000, in which
  case it would "call out" on port 24551.

- The above new format renders the old "BINKD Domains" feature obsolete.

- The upgrade process (DBUPD) should be smart enough to import settings from
  the old BINK DOMAINS option and "merge" it into BINKD SESSION INFORMATION.
  But please double-check after the upgrade is completed... just in case.

  WARNING: Again, remember that when upgrading from 2.94 or earlier, BINKD
           support is set to DISABLED.

- The BINKD system now uses FLO files and BSO (Binkley Style Outbound)
  correctly and efficiently... at least while testing here. Test carefully.

- The BINKD system now works correctly with polling, either through mailer
  events or through the use of DBUTIL POLL. Note that it is not my
  intention to support different "flavors" of BSO/FLO control files as I
  see no difference with the way the BINKD system treats the priority of
  outbound BINKD sessions.

- A new command, DBUTIL GENBINK, generates a FLO file manually for a BINK
  system entry. The format of the command is:

  DBUTIL GENBINK [address] [domain] [directory]

  For example, DBUTIL GENBINK 2:2/0 fidonet C:\WARD will generate a FLO
  file in the Fidonet directory containing the contents of C:\WARD\*.* to be
  sent out by the BINKD system. DBUTIL GENBINK is smart enough to
  distinguish the "Home Zone" (ie. the first domain entry in the DBRIDGE.BNK
  setup file) and if its not the Home Zone, then the zone is appended as
  an extension to the domain directory. To understand this better, my BINKD
  setup has a domain entry for Fidonet for Zone 1, and then entries for the
  other Fidonet zones (2 to 6). My hard drive has a directory called FIDONET
  and then FIDONET.002, FIDONET.003, FIDONET.004 and so forth. Now if I was
  in Zone 2, the first domain just becomes FIDONET because thats the Home
  Zone. But the remainder zones (1 and 3 to 6) becomes FIDONET.001,
  FIDONET.003, FIDONET.004 and so on.

  DBUTIL is smart enough not to add the contents of a directory to an FLO
  file if the contents are already listed in the FLO for sending-out.

  DBUTIL GENBINK is called automatically by D'Bridge during the processing
  for BINKD; so it is unnecessary to run this manually. It does NOT read
  or parse the DBRIDGE.BNK file - it reads the D'Bridge configuration
  directly and uses that. The feature is completely integrated.

  Again, no GENBINK or DBUTIL MOVE is done whatsoever if the BINKD support
  has been disabled in the setup screen - to maintain compatibility with
  existing batch files or setups that you may have.


Asserting manual control over BINKD
-----------------------------------

Under most circumstances, you shouldn't have to maintain your BINKD
configuration manually. If you do, then I haven't done my job properly. :-)

I've added a BINKD OPTIONS screen that allows you to manually override or
specify your own settings for the DBRIDGE.BNK file. This should be good
enough for most situations.

If it is necessary to have complete, manual control over BINKD while still
using the BINKD setup screen, set the support to Linux/Other. The
DBRIDGE.BNK file would be managed automatically, but all aspects of
the actual connections themselves are left up to you to handle.

When BINKD support is disabled (set to None), it is left up to you entirely
to handle and process mail and packets for BINKD systems. No generation or
maintenance of the DBRIDGE.BNK file would be done.

When BINKD support is set to Linux or disabled, you will need to "move"
the mail yourself using DBUTIL MOVE and DBUTIL GENBINK.


Redesigned Internet EMAIL/USENET and Cell phone support
-------------------------------------------------------

- The entire Internet EMAIL and USENET support has been rewritten and
  redesigned from scratch to be integrated into D'Bridge as much as possible.
  The use of SOUPGATE and VSOUP is so closely-knit together now that it's no
  longer necessary to use any other workarounds for EMAIL and Usenet gating.

  In D'Bridge-land, you're used to having your settings migrated over with
  little hassle as possible during upgrades - but unfortunately, in this
  upgrade, you will NOT be able to migrate any "workarounds" or calls to
  other external programs for EMAIL and Usenet gating - Those should first be
  removed from 2.94 (or whatever you're upgrading from), before you install
  this upgrade - then re-entered in the new screens afterwards. So, make
  sure you have your ISP's information for SMTP, POP3 and NNTP/Usenet once
  you're prepared to use the redesigned features.

  To properly use the gating, you must first specify the address you wish
  to use as the gate in the PACKET/MAIL CONTROL screens as well as define it
  in the SCHEDULER. This could have been automated; but to avoid confusion I
  decided to have you do this manually. The policy of development is NOT
  to add things automatically to routing tables or packet control settings
  for security/stability reasons - That code has not been changed for
  years for a reason. But on new installations, thats a different ballgame;
  as per the new Fido Plug and Play feature.

  When you're finished that, you then begin to answer the questions in
  the EMAIL/USENET GATING screen. There is even two "Test" options in the
  top of the screen to ensure that you're doing things properly. In
  tradition with the keep-it-simple approach of D'Bridge; all of the
  questions in the redesigned screen have been carefully constructed so
  even a complete novice can set up a working gateway system. And the online
  help screens have been rewritten as well.

- When you wish to "poll" your EMAIL/USENET gate, you just do so with the
  ALT+P command or DBUTIL POLL like you would any other system. D'Bridge
  treats mail for the EMAIL/USENET gate just as it would any other system,
  and this approach greatly simplifies things for administration.

- When you change your input in the "NNTP address" question, or type
  something in there for the first time, D'Bridge may display a warning
  asking you to "Re-Sync" (using the option at the top of the screen). This
  is done because in my opinion no two newsgroup servers have the same
  count (or "retainment rate") of messages. Whenever you change NNTP
  servers, you MUST re-sync. Otherwise D'Bridge may not accurately download
  the messages from the newsgroup server.

  What happens during the "Sync" is VSOUP connects to download the full
  list of newsgroups available from the NNTP/Usenet server, and computes a
  quick count of how many messages are in each newsgroup. This process
  should only take up to a minute. If it takes longer (especially when you
  are using the "Test" features in the top of the screen), then this
  indicates a problem with the connection to your NNTP server. Diagnosing
  those problems can be complicated; its best to refer the matter to me
  personally. Contact me directly or on the DBRIDGE echo on Fidonet.

  Note that it is beyond the scope of the DBRIDGE echo to provide help
  and assistance for issues relating to your Internet Service Provider (ISP)
  so, it is recommended that you have at least a basic understanding of
  how some Internet services work, like routers, ports and so forth.

- The only thing that needs to be done to start the flow of Usenet traffic
  coming in, is to edit the NEWSRC file and change the "!" to a ":" for
  the groups you wish to receive. I plan to have this automated in the
  next release along with tying in the Areafix support to handle this. It
  is not necessary to edit NEWSRC to exchange Internet EMAIL.

- Note that if you are using OS/2, the EMAIL/USENET gate feature requires
  the use of the shareware program "HSTART", available from Hobbes. The
  HSTART program is not shipped with this release of D'Bridge.

- If you require SSL encryption for SMTP or POP3 mail transfers in D'Bridge,
  be warned that the VSOUP program shipped with this release does not
  support SSL. However, on my website, you can download "X-Ray Mail
  Assistant" from the SOFTWARE DOWNLOADS section. When X-Ray is installed,
  it "takes over" the role from VSOUP and actually does the job of
  authenticating SSL. The installation and administration of X-Ray is fairly
  straightforward if you are knowledgable enough to configure SMTP and POP3
  settings. The on-line help in this release explains a little bit more
  about X-Ray and whats involved and how it works. However, providing help
  for installing X-Ray with D'Bridge will have to be done on a "case by
  case" basis (since SSL is an ISP issue); so please contact me directly or
  post a message in the DBRIDGE echo on Fidonet for assistance.

- D'Bridge now supports cell phone/SMS message "gating". In other words,
  with the YOUVE GOT MAIL setting set to "EMAIL" and ALL of the settings
  in the EMAIL/USENET GATING screen answered correctly, you can use your
  cell phone to participate in Fidonet. Please refer to the on-line help
  screens for more assistance, or contact me via EMAIL or in the DBRIDGE
  echo on Fidonet. Cell phone support has been tested with BlackBerry 7290
  and 7100 series. It also supports MSN and Yahoo Mobile EMAIL accounts.

  As these release-notes are cross-posted into the DBRIDGE echo; I will not
  get into an elaborate discussion about SMS support until necessary; as
  covering whats involved is beyond these release notes. Discussion is more
  than welcome in the DBRIDGE echo on Fidonet so long as
  pertains to configuring/troubleshooting your cell phone or software
  with D'Bridge. It is beyond the scope and topic of the DBRIDGE echo to
  troubleshoot issues pertaining to specific cell phone models; so its
  assumed that you have a working knowledge of how text-messaging works on
  your cell phone (ie. you know how to configure alerts, settings, etc)

  Be warned however, that you should first check with your cell phone
  carrier (ie. Rogers, Bell Canada, Telus) to ensure that you have a "plan"
  that includes free text-messaging or at least gives you significant
  messaging to let you enjoy the SMS support in D'Bridge without
  incurring substantial charges. Avoid plans that charge a per-message fee
  if at all possible.


Improvements to management and administration
---------------------------------------------

- D'Bridge now has an "AutoPurge" feature, to improve efficiency and
  eliminate the need for DOS events to manually purge your message forums.
  The AutoPurge feature can be found in the PACKET/MAIL CONTROL screen and
  obviously defaults to Disabled during upgrading - but is set to Enabled
  for new installations. When AutoPurge is enabled, old messages are purged
  on-the-fly after Unpacking/tossing of messages based on the criteria.
  Of course, you may still use DBUTIL PURGE if necessary.

- You can now specify "Aliases" for the Queue screen. Now you can look at
  your Queue window and see the name of the Sysop, not just the address.
  This is controlled by the QUEUE ALIASES question in the PACKET/MAIL
  CONTROL screen and defaults to blank (disabled) on upgrades. Any name up
  to 16 characters is okay, except "EMAIL/NNTP" which is a reserved name by
  the Internet features explained earlier. No spaces are allowed.

  So lets say you've got things set up with Roger as your uplink. You just
  type in his Fido address and name in QUEUE ALIASES, and whenever mail is
  destined for Roger's system, his name shows up in the outbound Queue.

  This feature was added to give a little bit more clarity in the Queue
  window; its easy to see now who has mail, if you prefer to referring
  to other systems by name instead of memorising Fido addresses. It was
  also added for the Fido Plug-and-Play auto-addressing feature.

- If you like the Queue Alias feature, I can see about enhancing that so
  the names can be used elsewhere, like in routing events, ie. ROUTE
  TO WARD FOR 2:ALL or ROUTE TO SEABORN FOR 1:ALL. I can even make it go
  so far as DOS events, ie. DBUTIL MOVE JOE C:\JOE. Let me know...

- The "You've Got Mail" feature has been enhanced to show a running total
  of personal mail waiting as a non-intrusive flashing indicator in the
  ACTIVITY window, simular to InterMail and TBBS/FLAME. The indicator will
  start flashing after D'Bridge idles for about a minute, and stays there
  until you read your mail. So now you can simply just glance at your
  monitor from a distance, and know right away if anything is waiting for
  you personally. When you read your mail, the flashing indicator goes
  away. Obviously none of this stuff happens if "You've Got Mail" is OFF.

- A new command, DBUTIL NETMAIL, will NETmail a specified system the content
  of a text file of your choice. The format is DBUTIL NETMAIL [address]
  [file] ie. DBUTIL NETMAIL 1:229/426 C:\BUG-RPT.TXT. DBUTIL automatically
  does a "zone match" if you are running other "nets" on your system.

  The first two lines of the text file must be who the message is to,
  and what the subject is. For example:

  [Start]
  Joe Sysop             - Who the message should be address to.
  New features          - The subject line of the message.
  Hi Joe, I have tested the new features,
  here is some things I've noticed so far...         
  [End]

- For Echomail, you may use DBUTIL POST and specify the FROM and SUBJECT
  and even the Echomail area as parameters - In this case, DBUTIL won't
  attempt to read that from the text file. The format would be:

  DBUTIL POST FROM "Sysop" TO "All" SUBJECT "Testing" IN FIDO_TEST
  C:\TEST.TXT

  The use of quotations is necessary when using the FROM, TO and SUBJECT
  commands. DBUTIL POST can also be used as an alternative to DBUTIL
  NETMAIL; just use NETMAIL as the area name.

Redesigned installation for newcomers
-------------------------------------

The installation for newcomers has been rewritten to auto-configure D'Bridge
much easier than before. By simply answering the new on-screen questions
properly, D'Bridge can be up and running in minutes.


Fixes / Corrections since 2.94
------------------------------

- Dozens of corrections and improvements have been done to the Setup Wizard
  to facilitate Fido Plug and Play and to simplify things even more for
  newcomers to our hobby.

- A very rare but serious bug from the Chris Irwin days has been fixed
  in the mailer startup sequence.

- A potential bug in DBUPD (D'Bridge Update) has been fixed.

- A serious bug with command-line options in D'Bridge itself has been fixed.

- An extremely rare but potential EMSI security problem from the Chris
  Irwin days has also been fixed, for dialup modem sessions running in
  both multi-line and a combination of highspeed/lowspeed where CONNECT
  strings unrecognized caused a strange behavior in the mailer.

- A serious problem with the AutoUpdate routine not properly exporting
  configurations on multi-line setups into ZIP files has been fixed.

- Echomail is now unconditionally scanned out first instead of after
  the Unpack cycle if the DBRIDGE.RSE semaphore is created or you
  select UTILITIES -> PROCESS MAIL MANUALLY. This change was done to
  simplify the integration of certain BBS software.

- The bug where Echomail is entered in the internal editor and not being
  packed out if inbound mail is waiting upon exit has been fixed. Note that
  for this fix to work correctly, the "Scan Echomail" question must be
  answered YES in the EDITOR OPTIONS screen. 

  If you answer NO to the "Scan Echomail" question, Echomail written in the
  editor will still go out but the next Echomail scan may take much longer
  to complete since D'Bridge must scan each and every message to determine
  if in fact it must be sent out. So, the recommended setting is YES, and
  this is the default setting for new installations - but not for upgrades,
  because in very complex and large setups it is preferred to have it off.

  This problem was very hard to replicate here based on how my configuration
  works, which I'm sure is different than others due to it also being used
  for testing-purposes, but I saw exactly where the problem was.

- D'Bridge should no longer "freeze" with the 1-second-remaining on events
  that require outbound calls, because the majority of that problem was
  based around the old BINKD code. Now that the BINKD support has been
  completely rewritten from scratch (with stability and reliability in mind)
  the problem doesn't happen anymore.

- D'Bridge should no longer crash during the AutoUpdate routine if
  no Echomail areas have been defined.

- A serious bug with the way COM ports are handled for Dialup modems has
  been fixed.

- D'Bridge no longer randomly crashes or hangs a Windows 2000/XP/2003 Server
  session when you have a dialup modem defined and you decide to run DB
  UNPACK or DB ECHOSCAN and multi-line support is enabled.

- DBUTIL has been updated so that having at least one Echomail area to make
  it work has been removed - except for DBUTIL SORT AREAS, DBUTIL PURGE and
  others that specifically deal with NETmail or Echomail. This was done
  for those of you running a "NETmail only" scenario, or for testing.

- Another serious problem with DBUTIL MOVE not functioning correctly in the
  above scenario has been fixed.

- DBUTIL's overall performance and stability has been improved and tested
  to be stable here on my server - a machine that has over 10,000 Echomail
  areas and processes over 100,000+ messages per day.

- The logic behind DBUTIL DELETE, DBUTIL DELETEDOS and DBUTIL SORT AREAS
  has been slightly modified now. If you use DBUTIL DELETEDOS, the Echomail
  areas (and Fido *.MSG directories) are removed, but the actual record
  still remains in the database; if you decide it was a mistake and you
  want to use the DBUTIL UNDELETE command. Now, Echomail records marked for
  deletion are not actually "purged out" until the use of DBUTIL SORT AREAS.

- A minor enhancement was also done to the Unpack cycle which should improve
  the initial speed of unpacking on systems with large amounts of Echomail
  areas. While not necessarily a "fix", it does "fix" poor performance when
  tossing mail on large configurations (ie. over 10,000 Echomail areas)

- Mail turnaround and unpacking when Idle and activated by semaphores should
  be vastly improved now; D'Bridge should no longer sit idle for too long
  when theres waiting mail to be processed.

- The bug where a "BinkD" call is placed and the mailer attempting to dial
  that same system immediately afterward (if a dialup modem was specified)
  has been fixed.

  This means that a system has to be defined as "one or the other" - either
  they are connecting via Dialup *OR* BINKD. Not both. If both scenarios
  are required to be supported simultaneously, let me know.

- D'Bridge should no longer "barf" on nodelist segment updates (DIFF files)
  that have been generated by MAKENL. Although this problem was corrected
  back in 2.92, some minor things have been fixed for stability reasons.

- D'Bridge no longer ships with a DBNET nodelist. DBNET is obsolete and has
  been entirely replaced by the Fido Plug and Play system explained earlier.
  Get rid of the DBNET nodelist entirely from your setup and delete the
  file altogether. If you have a DBNET node number as an AKA address or in
  your ROUTING table, delete it.

- Nodelist IBN/INA and IVM flags are translated properly now if those
  features have been enabled in the VIRTUAL MODEM/MAILER-OVER-TELNET screen.

- A somewhat serious bug in the IBN/INA/IVM translation has been fixed.

- The "Bad record number" bug in DBUTIL should be fixed in this release.

- A minor cosmetic problem has been corrected in DBUTIL PURGE, DBUTIL RENUM
  and DBUTIL RENUMDATES.

- D'Bridge no longer ships with the RAR archiver; if you wish to have
  support for RAR, please download RAR16 or RAR32 from www.rarlab.com and
  install to the D'Bridge directory. RAR support is still here, however.

- If the mailer complains of an "Echopack 5", please report this ASAP. The
  message DOES NOT affect processing or forwarding of mail - this was
  intentionally put in there to help me diagnose a possible condition that
  maybe one of you lucky folks will be kind enough to report if it happens!

- If the mailer complains of "Unable to open DBRIDGE.XMA" or simular
  situations, and you have a fairly large configuration, increase the
  size of the FILES statement to 60 or 80 in CONFIG.SYS or CONFIG.NT on
  Windows-based computers. If the problem persists, please notify me ASAP.

- Some minor things in the on-line help system have been updated, at some
  time in the future I would like to completely revise the entire help
  system and make it up-to-date.

- Numerous behind-the-scenes cleanup work was done to all of the code to
  improve performance in some areas as best as I could.

Nick Andre
www.nickandre.com



Version 2.94 - December 1st 2007
--------------------------------

WARNING: Although careful testing was done to ensure a stable release,
         please back up your D'Bridge directory before installing.

This is a major release of D'Bridge which "rolls up" all of the dozens of
bug fixes and corrections done in 2.93 with several improvements done to
the support for dialup modems and Internet Rex by Charles Cruden.

In case you missed it, 2.93 removed a lot of limitations with the Echomail
processor. D'Bridge can now process up to 32,000 Echomail areas and
error 202 and 203 problems are gone. As fellow Church of Andre member
Ward likes to point out, new features mean new bugs... and 2.93 was no
exception. Roger also pointed out a serious problem with DBUTIL. So, a lot
things happened as a result of removing the limits. Thankfully, most of it
was caught in time during testing, and 2.94 should be a very stable release
to "tide you over" while I now focus on the major feature I want to write.

Yes, the BINKD subsystem is being rewritten from scratch, and I've already
began work on a much more simplier approach for BINKD, Internet EMAIL
and Usenet groups. And Echofile/TIC processing is almost ready for testing.

- Dialup modem performance under Windows 2000, XP and Vista should be
  improved and there should be no more of this "The NTVDM session is
  attempting to access COM1" nonsense when running DB SETUP.

- The serious bug where if there is no dialup modem and D'Bridge tries to
  call a system anyway (thus causing a "freeze") has been fixed. When there
  is no dialup modem, all Queue entries will be marked as HOLD/UNLISTED.

  Please note that the recommended way to run BINKD is in "server" mode -
  ie. D'Bridge in one window and BINKD in another. Do NOT run it
  in "client" mode despite what the help file says - it doesn't work
  correctly.

- D'Bridge has been tested with the BlackBerry 7100 and 8000 series cell
  phones and the later revision Palm TRIO connected to a PC as a USB
  modem for placing outbound Fido calls using cellular technology,
  if such a need arises. The USB modem driver must be configured to
  operate on COM1 or COM2 usually under ADVANCED PROPERTIES.

- D'Bridge and DBUTIL now create a dummy file/semaphore called DBRIDGE.QSD
  (short for "Queue Scan is Done"). When Internet Rex sees this file, it
  will rescan its own Queue - when properly configured. Internet Rex works
  very well with this new improvement - though the use of DBUTIL MOVE
  and Mailbox directories in Rex's NODE MANAGER is still recommended.

  To configure support for the new DBRIDGE.QSD file in Internet Rex:

          - Fire up Rex Configuration (ie. REXWCFG or REXCFG)
          - FILES, PATHS and PROGRAMS.
          - MAILER TYPE should obviously be set to D'Bridge.
          - SEMAPHORE directory should be your D'Bridge directory, ie C:\DB
          - Set the RESCAN SEMAPHORE to DBRIDGE.QSD.
          - Set RESCAN FREQUENCY to "Use Semaphore files"
          - Save and Exit.

  To ensure proper operation of D'Bridge with Internet Rex altogether,
  follow these steps. We'll use my Fido address, 1:229/426 as an example,
  so lets pretend for arguements sake that you exchange mail with me...

  - Configure the new QSD file support mentioned above.
  - Lets say D'Bridge is installed in C:\DB and you've got me all set up.
  - Make a directory called C:\DB\NANDRE
  - Create a DOS event in D'Bridge which runs DBUTIL MOVE 1:229/426 NANDRE
  - Fire up the Internet Rex configuration program, ie REXWCFG.EXE
  - Go to GENERAL INFORMATION and be sure User Level is set to ADVANCED.
  - Then go to the NODE MANAGER screen.
  - Add a system, 1:229/426 with the MAILBOX DIRECTORY set to C:\DB\NANDRE
  - You would then configure all the other info, ie. BINKD, passwords, etc.
  - Thats it!

- The use of DBUTIL MOVE is recommended because Internet Rex does not
  properly read all of the Queue data in D'Bridge. Contrary to popular
  belief, this is a problem with Internet Rex itself - NOT with D'Bridge,
  and anyone who needs this proven simply has to watch the way that NETmail
  and Areafix requests are blatently ignored by the Rex scanner. So
  what you're doing in the above steps is essentially move things out of
  the Queue into another directory and tell Rex to look in there for mail.
  Note that for each system defined in the NODE MANAGER of Internet Rex you
  must have a seperate mailbox directory - don't just move everyone's mail
  into one directory. :)

  Please note that it is not my intention to provide any more workarounds
  or support for Internet Rex as that product has several serious and
  fundimental flaws in it which would require the authors intervention...

- The serious bug with purging obsolete entries in the ECHOMAIL HISTORY
  screen and the DBRIDGE.DL3 file growing out of hand has been fixed.

- A serious bug during the display of Echomail history with weird bizarre
  nonsense on the top of the first record in the list has been fixed.

- Minor bugs with the RESCAN feature of Areafix have been fixed.

- A serious bug in the Delete Empty Passthrus feature during the Auto-
  Update midnight event has been fixed.

- A serious bug in DBUTIL PURGE has been fixed with regards to date-purging
  as per Roger. DBUTIL PURGE now works correctly as it did prior.

- DBUTIL SORT AREAS has been rewritten from scratch and sorts areas much
  faster than before, especially on systems with lots of Echomail areas. It
  is a little more disk-intensive but much better.

  A system with over 10,000 Echomail areas (like mine) now sorts in less
  than a few minutes, instead of over a half hour.

- A serious bug with BBS callers being rejected regardless if the SCHEDULER
  and BBS CONFIGURATION was set to "Yes" has been fixed.

- A new feature, DBUTIL REMOVEDUPEDATABASES has been added, which will
  remove the DBRIDGE.DUP databases from each *.MSG directory. This has been
  added for debugging/testing purposes. Under normal circumstances this
  should NOT be used.

- Dozens of other minor corrections have been done as the mailer is being
  prepared for new features in progress.




Version 2.93 - November 24th 2007
---------------------------------

WARNING: This release makes several dozen fundimental changes to the
         Echomail processor, XMAIL and the DBRIDGE.ADF database file. After
         this upgrade has been installed, 3rd-party programs which
         directly access the Echomail database will not function properly.
         However you may downgrade/rollback to 2.92 or prior if you are
         not happy with this release. A lot of hard work and careful
         consideration has been given if you are not happy and wish
         to rollback. No version-specific files are created and no
         additional steps are required if you feel a rollback is necessary.

This is a very minor release but has a lot of internal code changed to
facilitate large amounts of Echomail areas, and to resolve Error 202 and
203 problems for good. After this upgrade has been installed, Echomail
tossing may slow down somewhat; depending on the speed of your computer.
However, other problems have been solved, so its a case of trading a little
bit of performance to solve problems elsewhere. D'Bridge can now process up
to 32,000 Echomail areas, as opposed to the previous limit of around 2,000
before Error 202 and Error 203 happened. There is also a little bit more
memory available for other settings such as routing tables, Packet/Mail
control lines and so forth.

It is not necessary to upgrade to this version right away unless you are a
Fidonet Zone or Network Co-Ordinator and you process large volumes of
Echomail AND you have a large amount of downlinks or other setup information.

It would be a good idea to pay attention to the system log files and you
should check your message bases after each "tossing" cycle has completed.

- If you are running D'Bridge under OS/2 Warp, Echomail performance is
  actually improved on HPFS partitions when the size of the cache is set
  *low*. A cache size of 128k to 256k is recommended.

- The entire Areafix system may run a little slower than usual because the
  whole code for requesting areas depended heavily on the old method. It
  has been tested here to be stable and bug-free.

- The keyword "ALL" now tells Areafix to add (or remove) all available
  Echomail areas for a system. For example, an Areafix request from 2:2/0
  containing just "ALL" would connect that address to all available areas
  based on security level (or all of them if the request was forced
  using the ALT+N command). Likewise, if 1:229/2000 sent a request
  with "-ALL", all current areas would be disconnected.

- The new changes to the Echomail processor have no effect if you are using
  the QuickBBS storage system. It is impossible to have thousands of areas
  with QuickBBS or GoldBase. In fact I plan to completely get rid of
  the support for QuickBBS/GoldBase support altogether... unless someone
  out there absolutely insists on having it.

- A new version of DB2RG has been included for the Renegade BBS software
  to work properly with this release.

- The internal editor now correctly handles Echomail areas up to 32,000.

- The BADECHO area where "bad" messages get sent to, is now numbered
  as 32767, instead of 9999.

- DBUTIL has been significantly updated to handle the new code changes.

- The problem in DBUTIL DESCFILE not correctly justifying descriptions
  is fixed.

- Please double-check all your events and routing information after
  installing; since the way that memory is managed with those screens has
  also changed slightly.




Version 2.92 - November 10th 2007
---------------------------------

WARNING: This release makes a fundimental change to the Echomail processor
         including changes to XMAIL and the internal message editor, and
         fundimental changes to the Nodelist Compiler. Please backup
         accordingly and test very carefully.

This is a major release which introduces the ability to compile nodelists
designed with MAKENL amongst Fidonet along with major fixes to DBUTIL PURGE
and several other corrections.

- The Nodelist Compiler should now properly process and compile Nodelist
  segments amongst the recent switchover events in Fidonet.

- DBUTIL PURGE has been redesigned to purge-out old messages first, instead
  of just "randomly purging".

- This is a release that has a minor fix that has shown to improve the way
  Echomail is imported by 3rd-party software that tosses mail to BBS's,
  for any areas that use Fido *.MSG storage. In each Echomail directory
  that uses Fido *.MSG storage, a file is written to keep track of the last
  message read by the editor or "tossed" by the D'Bridge Echomail processor.
  This is simply known as a "last-read pointer". This pointer may also be
  used by BBS or 3rd-party software that manipulates Fido *.MSG directories.
  Since the very beginning of D'Bridge, this file is called 1.MSG. Its the
  infamous "Ignore this message; used for internal Echomail processing" text.

  For example, Searchlight by Frank LaRosa / Telegraphix uses SLMAIL to
  import Fido mail into the BBS, Renegade uses either Renemail or CDRMAIL to
  import messages. I'm sure there are others that I just don't know about.
  When you are using such software, sometimes those programs may get
  "confused" and think that 1.MSG is actually a message, when in fact its
  just there to keep track of the last message in the area. The result would
  be that the message gets imported into your BBS software anyway. So, only
  change the filename if this is the case and you're having problems.

  I understand that the fix in this release is probably many years too late
  but this issue has finally been resolved in D'Bridge thus making it
  compatible with most 3rd-party software that handles Fido *.MSG format.

- A new search/replace field for the Forward-To lines has been added
  to the GLOBAL CHANGE command in DBUTIL.

- A minor correction to DBUTIL RENUM and RENUMDATES has been done for
  stability reasons.

- A somewhat serious problem has been solved in the Web Processor (DBUTIL
  PROCESSWEB) where large messages were not being handled properly.

- The Setup Wizard has been corrected to NOT overwrite any Web templates
  for DBUTIL and Anti-SPAM configuration files for SOUPGATE.

Nick Andre
http://www.nickandre.com




Version 2.91 - November 7th 2007
--------------------------------

This is a minor release.

- The D'Bridge SCHEDULER screen has been enhanced to allow you to run any
  DOS commands for a MAIL event either after a Dialup session, or after any
  mail has been processed regardless (such as manipulating via. DBRIDGE.RSN)
  The "Allow Filesharing" question has been changed to "Execute DOS
  commands" and you have two choices - DIALUP ONLY or ALL MAIL. The default
  is DIALUP ONLY which is the normal behavior that Chris had in the DOS
  command code since 1.58. This new feature was absolutely necessary to aide
  in the proper operation of certain 3rd-party software or for those of you
  who use DBUTIL MOVE to manipulate the Queue.

- The blinking-ANSI problem in the internal message editor has been found,
  replicated here, and should be fixed now as per Roger.


Version 2.9 - October 28th 2007
-------------------------------

This is a very minor release that doesn't fix any problems at all but
contains various changes to code and other "behind the scenes" stuff.

Please back up and test very carefully - this release changes some
fundimental code in the Echomail processor, that has been unchanged
since 1.58. The code has now been changed slightly in order to accomodate
some upcoming features for a future release.




Version 2.89 - October 15th 2007
--------------------------------

This minor release should correct the 8000-crash problem in the internal
message editor when you list the messages in an area.

Please test accordingly and keep in mind that the code for the internal
editor is a real spaghetti-mess and fixing one thing usually breaks
something else. Not that I did this release at the last minute mind you;
but I'm very reluctant to change any of the code in the internal editor.




Version 2.88 - October 13th 2007
--------------------------------

This minor release corrects a very, very rare and hard-to-notice problem
with DBUTIL PURGE. I will be spending some time on the other problems
in the next week or so... please be patient.




Version 2.87 - October 12th 2007
--------------------------------

This is a very minor release of D'Bridge that adds a new feature to
the DBUTIL program: RENUMDATES.

DBUTIL RENUMDATES will date-sort an Echomail area, putting messages in order
from oldest to newest dates. You can also specify an individual area
to date-sort, ie. DBUTIL RENUMDATES FIDONEWS.

Note that the RENUM and RENUMDATES features execute an Echoscan when
the mailer fires up again...




Version 2.86 - October 2nd 2007
-------------------------------

I will be "down" in Fidonet for at least a few weeks and busy with personal
matters. If you need to reach me, call my cell at 416-567-0117 or EMAIL
me at nick@nickandre.com.

I will try to catch up on the DBRIDGE echo as much as I can. Most likely
from Internet cafe's while on the road. Call it soul searching or a
personal journey I really need to take folks. In the meantime I may use
Docs Place BBS or whatever halfway-decent "Fido on the Web" board I
can find. Suggestions anyone?

Anyway, this is a very minor release. If there are serious bugs, please
call me or let me know via EMAIL and I'll do my best to write any fixes.

- D'Bridge now supports RAR archiver types. RAR support is configured
  in the XMAIL CONTROL screen. And yes - done so WITHOUT removing any
  existing support for PAK or ZOO. There was *just enough* codespace left
  in the XMAIL subroutines to squeeze that in...

- D'Bridge ships with RAR32 for DOS and comes with the RAR options already
  preconfigured for new installations. On upgrades, it *should* fill in
  the new settings but if not, just put the cursor in the RAR field and
  press delete or CTL+Y to erase it, and D'Bridge fills in the proper
  settings.

- The Setup Wizard will ask you if you wish to place the RSX/EMX libraries
  required by RAR, into your system path. This happens once only. If you
  need to do this manually, copy the RSX.EXE, EMX.DLL and EMX.EXE files
  to the WINDOWS\SYSTEM32 directory or OS2\APPS\DLL, respectively.

- The version of RAR that ships with D'Bridge 2.86 requires at least a 386
  processor. It may not run on a Tandy 1000 or earlier IBM PS/2 computers
  but should run okay on Tandy 2500 series.

- A plus sign (+) is required before the RAR compress/decompress
  commands in the XMAIL CONTROL SCREEN, just like the rest.

- If you are using D'Bridge under OS/2 Warp, you may need to change the
  properties for the virtual DOS session to enable DPMI (DOS Protected
  Mode Interface) if you plan to use the new RAR support under OS/2.

- NODEDIFF segments archived with RAR should unpack okay, but only if the
  extension of the segment has the letter R in the first part, for
  example, NODEDIFF.R12, NODEDIFF.R19 and so forth. For "net-wide"
  compatibility I recommend that segments only be compressed in ARC format.

- A minor bug has been corrected in the import/export functions.

- Removed the references to Squish and JAM... for now.





Version 2.85 - September 23rd 2007
----------------------------------

WARNING: Please study the release notes for 2.83 and 2.84 if you have not
         done so already. Theres a reason why we have three new releases
         in one night...

This is a very minor release which adds the ability to have a little bit
more control over systems who use no packet passwords and the SECURED MAIL
ONLY option is set to YES. This was absolutely crucial to have this feature
to aide in diagnosing/troubleshooting packet passwords between systems, and
was important enough to be coded and released immediately tonight.




Version 2.84 - September 23rd 2007
----------------------------------

WARNING: If you are upgrading from 2.82 or prior, please review the notes
         for 2.83 (included in the release file) if you have not done so
         already.

No sooner did I release 2.83, I realised one important thing was missing.
So this is a very minor release which enhances the PACKET PASSWORD feature
and the SECURED MAIL ONLY question in the PACKET/MAIL CONTROL SCREEN.

SECURED MAIL ONLY now has three choices. No, Yes and Detailed. The
feature works the same, except if you answer DETAILED, D'Bridge will
show the packet password from the remote system in the LOG window screen
(and also in the log file).

Even if you are happy with 2.83, upgrade to this release immediately and
test all mail processing again as I have made a minor correction with
the way D'Bridge handles missing packet passwords when the SECURED MAIL
ONLY option is enabled.




Version 2.83 - September 23rd 2007
----------------------------------

This is a minor release as per recent discussions in the DBRIDGE echo.
Although its a minor release, it addresses mail security. Because this
release deals with the way mail is processed, carefully test all features.
Pay attention to the system log during mail tossing and packing. A minor
correction to DBUTIL MOVE was also done as well.

WARNING: All inbound mail and pending XMAIL should be processed first before
         installing this release. DO NOT INSTALL THIS RELEASE if mail
         transactions are currently pending.

WARNING: If you are a Hub or Co-Ordinator, careful planning and precautions
         should be taken during this upgrade if you wish to use the PACKET
         PASSWORDS feature mentioned below. When using packet passwords,
         it will become impractical and time-consuming if you don't like
         this version and wish to rollback - seeing as how previous
         versions of D'Bridge did not support packet passwords. If at all
         possible, install a fresh copy of 2.83 in a new directory and
         do a "test run" with one system to ensure passwords and security
         are correct, BEFORE installing this release.

- The BINKD configuration now allows for mixed-case passwords. Note that
  when upgrading to this release, the BINKD configuration is imported as
  uppercase. This problem happens only once and is due to the import/export
  code in prior releases. It won't happen again on future releases. However
  if you rollback to a prior version, the BINKD configuration is imported
  as uppercase again.

  Some improvements are going to be made to the BINKD administration but
  probably not for a little while yet.

- PACKET PASSWORDS is located in the PACKET/MAIL CONTROL screen. You can
  now use packet passwords to secure your D'Bridge system even more, or to
  use passwords for exchanging mail with other systems that require it.

- SECURED ECHOMAIL ONLY in the PACKET/MAIL CONTROL screen has been renamed
  to SECURED MAIL ONLY.

- Some of the questions in the PACKET/MAIL CONTROL screen have been
  expanded to make things a bit easier when entering data, for those of you
  with large configurations.

- The Setup Wizard will offer to temporarily disable the SECURED ECHOMAIL
  ONLY setting if it detects mail or files in the INBOUND directory waiting
  to be processed, to allow proper testing of this particular version.

- DBUTIL MOVE now generates a unique packet name when moving NETmail and
  should solve the "lost mail" problem as reported. This unique name is
  generated every time DBUTIL MOVE is ran and does not rely on a counter
  or anything like that - So it should never overwrite any NETmail packet
  that is waiting in another directory or BINKD outbound queue. If... and
  I do mean *IF* this problem happens again, let me know ASAP and back
  to the drawing board I'll go...



Version 2.82 - September 20th 2007
----------------------------------

WARNING: This release makes a fundimental change to the DBRIDGE.ADF file,
         that stores your Echomail areas. Please back up this file first.

This is a very minor release which corrects some serious bugs in the new Web
integration module. A potential problem with the way the RENUM feature
of DBUTIL works has also been corrected. Although it doesn't look like it
on the outside, a lot of hard work went into writing this release.

In order to fix the bugs, a fundimental change in the way certain
information is stored has been revised. To avoid potential problems, I also
added various security checks to ensure that you are only using the DBUTIL
that is meant for this release... and not others. Therefore:

  ***********************************************************************
  *  DO NOT, UNDER ANY CIRCUMSTANCES, USE ANY OTHER VERSION OF THE      *
  *  DBUTIL PROGRAM WITH THIS RELEASE OR ATTEMPT TO COPY A DBRIDGE.ADF  *
  *  FILE FROM A PREVIOUS VERSION TO THIS ONE. DATA LOSS WILL HAPPEN!   *
  ***********************************************************************

- The Setup Wizard does not overwrite or update your HTML template files,
  only the SAMPHTML.ZIP file gets updated when upgrading. For this reason,
  if you have custom HTML code for the Web integration system, any changes
  that are done to the way placeholder variables work will need to be done
  manually. I don't expect this to be much of a problem if you are using
  the Web features; you should have a basic understanding of how HTML works
  anyway at that point.

- The ON WEB SERVER question in the ECHOMAIL SETUP SCREEN has been changed
  to three different choices now. You can specify NO, YES or DETAILED. The
  "detailed" setting saves the SEEN-BY, PATH and KLUDGE lines of a message
  on your Web server. The standard "Yes" option does not. The help file
  has also been updated with this change along with the import/export
  function in D'Bridge itself.

- A new feature, "Web ASCII" has been added to the ECHOMAIL SETUP SCREEN
  as well, enabling you to properly filter out high-ASCII from messages
  when posting to a Web server.

- Did some work in trying to correct the plethora of LF/CR confusion in
  HTML code generation but its not entirely fixed... so be warned. If
  anyone can suggest to me a proper way to handle the whole LF/CR mess, let
  me know via EMAIL or in the DBRIDGE support echo on Fidonet.

- The numbering of the messages shown in an HTML listing is correct now.

- Two new placeholders, %%%MESSAGE_NUMBER%%% and %%%MESSAGE_OF%%% have been
  added to the message body template file (MSG-B.HTM). The code looks like
  this:

  Message %%%MESSAGE_NUMBER%%% of %%%MESSAGE_OF%%%

  which translates to

  Message 1 of 102

  Please update any existing code on your web site accordingly. The new
  placeholders, like everything else in D'Bridge, are completely optional
  and your Web site doesn't need to use them if you don't want to. Note that
  the MESSAGE NUMBER placeholder in the message body template works
  differently than the one in the listing body template.

- The %%%MESSAGE_PREVIOUS%%%, %%%MESSAGE_LISTING%%% and %%%MESSAGE_NEXT%%%
  placeholders work properly now. The MESSAGE PREVIOUS placeholder will
  not be shown when viewing the first message. Likewise the MESSAGE NEXT
  placeholder is not shown on the last message.

- At the last minute, I also added two new place holders for the PREVIOUS
  and NEXT links - If you add a pound sign (#) in the above-mentioned
  placeholders, it will put the number of the referenced message in there.

  So for example: %%%MESSAGE_PREVIOUS#%%% will show "Previous Message (25)"
  as opposed to just "Previous Message", and %%%MESSAGE_NEXT#%%% will show
  "Next Message (27)" as opposed to just "Next Message".

- For icing on the cake, I updated all of the sample HTML files to show off
  all the new features... and updated my website as well.

Please note that it is not my intention to offer features such as font size,
typeface and the like - these are things you should be using your Web
publishing software to do. DBUTIL's primary task is to simply replace
placeholders with HTML code, nothing else. It is fairly straightforward to
implement whatever fonts and typeface you want in the template files.

Nick Andre
http://www.nickandre.com




Version 2.81 - September 14th 2007
----------------------------------

This is a very minor release that fixes the bug with the missing REPLY
kludge when writing messages in the internal editor. Another release
is going to be coming a little later to fix a variety of bugs with
the Web integration.




Version 2.8 - September 7th 2007 - WEB SERVER READY
---------------------------------------------------

WARNING: This release of D'Bridge now requires that any DOS events in
         D'Bridge that call DBUTIL have the plus sign (+) infront of
         the command, because DBUTIL now requires a full 640k of memory
         to function properly. Please check this BEFORE upgrading.

You can now let Internet Web users access Fido messages on your system.

This release of D'Bridge now supports Web servers such as Microsoft IIS
and Apache. I've done all the complicated hard work of making sure that this
new feature is "as easy as 1-2-3". The new feature is fully contained
in the DBUTIL program.

*** SUGGESTION *** You should view this document on your computer with
                   your web browser pointed to nickandre.com, so you can
                   fully understand how this works and how simple it is.

All is accomplished with DBUTIL PROCESSWEB followed by the directory to
generate HTML messages in. Six "template" HTML files exist in your D'Bridge
directory that you can edit and tailor to your liking. Once you're all done,
one simple command instantly transforms your D'Bridge mail to the Web:

For example: DBUTIL PROCESSWEB D:\WWWROOT\MESSAGES

This must be a directory strictly for use by DBUTIL - The contents of this
directory will be erased or updated every time DBUTIL PROCESSWEB is ran.

WARNING: Do NOT tell DBUTIL to generate messages in the root of your Web
         site for this reason. Always create a subdirectory off your site.

Any directory that can be accessible in DOS can be accessible by the Web
Server component. This means that D'Bridge can run on the same computer
as your Web Server, or on a "nanny" machine on a LAN on a networked drive.

The WEB SERVER HOME DIRECTORY question has been removed from the INTERNET
CONNECTIVITY screen in case you haven't noticed. I felt that this belonged
on the command-line with DBUTIL, so those of you who run Web servers can
offer the same Fido messages across multiple websites on the same server
(as opposed to having to install multiple copies of D'Bridge to handle
multiple websites)

When DBUTIL PROCESSWEB is ran, it scans through your Echomail database and
creates HTML messages on your Web server. First, it checks to see if
the "On Web Server?" question for each area is set to YES. For each area
it finds, it builds a list of Echomail areas on your Web server.

If you have a large number of Echomail areas that you want to set the "On
Web Server" question, just use the CHANGE feature of DBUTIL. For more help
on that, view the D'Bridge manual or consult the DBRIDGE echo on Fidonet.

WARNING: Please use due diligence. "Private" Echomail areas (such as
         net-wide, regional or co-ordinator only) should not be made
         accessible on your Web server. Web search engines such as Google
         and Yahoo could easily "crawl" these sites, thus making such
         forums available for the whole world to see. Be sure that private
         Echomail forums have the "On Web Server" question answered NO.

DBUTIL will then use the following files from your *DBRIDGE DIRECTORY* to
create the HTML files. Six HTML files are shipped with this release of
D'Bridge for you to modify as you see fit. The following files MUST exist
in your D'Bridge directory, otherwise the DBUTIL PROCESSWEB command won't
work.

If you wish to allow your website to have Fidonet areas available but NOT
allow "web robots" from Yahoo, Google or MSN.COM to index them, you should
create a ROBOTS.TXT file in the root of your website. Drop me an EMAIL
and I can explain how this is done, or just google "robots.txt structure"
if you want. In a future release of D'Bridge I plan to integrate support
for ROBOTS.TXT management.

There are three different "parts" to an HTML Fido message that DBUTIL will
work with. The Header, Body and Footer. The header should contain HTML code
that "sets up" the display of the area or message. The body contains any
code displayed along with the content of the message. And the footer is any
HTML code appended to the end of the display.

The HTML editing can be done with any HTML or text editor, or a fancy
"what you see is what you get" program like Microsoft FrontPage. If you
are totally lost, there are even Web-based editors such
as http://htmledit.squarefree.com or http://www.ewebeditor.com

There are some "placeholders" that you use when you write the HTML. When
DBUTIL processes a message, it will replace the placeholder with the
actual value.

Note that headers and footers of AREAS, LIST and MSG template files should
not contain any placeholders. DBUTIL only processes placeholders in "body"
templates.

Placeholders can be anywhere in the body, in any order, wherever you want
to use them is fine with me. If you are a web developer or programer, you
can even stick them even inside Javascript or Visual BASIC code if you want.

Heres what the six D'Bridge HTML template files are:

AREAS-H.HTM     HTML header to show before the list of available areas.
AREAS-B.HTM     HTML code containing the area listing itself.
AREAS-F.HTM     HTML footer code to append to the end of the area listing.

LIST-H.HTM      Header to show before the actual message listing.
LIST-B.HTM      The body of the message listing.
LIST-F.HTM      Footer to add to the end of the message listing.

MSG-H.HTM       Header to show before the message.
MSG-B.HTM       The actual body of the message.
MSG-F.HTM       Footer to append to the end of the message display.

AREAS.HTM       The compiled area listing code when DBUTIL PROCESSWEB ends.
                Your web site must point to this file. This file will reside
                in the base directory you define in INTERNET CONNECTIVITY.
                The user reads and views messages from here on out.

The user essentially sees AREAS.HTM, which will display the list of
available Echomail areas (generated from AREAS-H, AREAS-B and AREAS-F). The
user then clicks on an area they want. They see the list of messages in
that area (LIST-H, LIST-B and LIST-F) and clicks on a message
(MSG-H, MSG-B and MSG-F).

When DBUTIL encounters the following "placeholders" in AREAS-B.HTM, it will
substitute them with the proper information. Three percent signs (%%%)
tells DBUTIL that it should replace the code in the HTML file with what
you want.

          %%%AREA_TAG%%%  The Echomail "tag", ie. DBRIDGE or FIDONEWS
  %%%AREA_DESCRIPTION%%%  The description of the Echomail area.
%%%AREA_TOTALMESSAGES%%%  The total number of messages in the area.

When DBUTIL encounters the following placeholders in LIST-B.HTM, it will
replace with:

    %%%MESSAGE_FROM%%%    Who the message is from.
      %%%MESSAGE_TO%%%    Who the message is to.
 %%%MESSAGE_SUBJECT%%%    What the subject of the message is.
    %%%MESSAGE_DATE%%%    The date of the message.

When DBUTIL encounters the following placeholders in MSG-B.HTM, it will
replace with:

    %%%MESSAGE_FROM%%%    Who the message is from.
      %%%MESSAGE_TO%%%    Who the message is to.
 %%%MESSAGE_SUBJECT%%%    What the subject of the message is.
    %%%MESSAGE_DATE%%%    The date of the message.
 %%%MESSAGE_CONTENT%%%    The contents of the message.
%%%MESSAGE_PREVIOUS%%%    Adds a "Previous message" button to the message.
 %%%MESSAGE_LISTING%%%    Adds a "Back to Listing" button to the message.
    %%%MESSAGE_NEXT%%%    Adds a "Next message" button to the message.

DBUTIL PROCESSWEB should be ran as part of a nightly event, but for those
of you who are Hubs with busy traffic, DBUTIL PROCESSWEB should be ran as
a seperate process on your operating system, so it doesn't "tie things up".
Or, run another copy of D'Bridge on a nanny machine as described earlier.
Note that if you are tossing messages to a BBS, DBUTIL PROCESSWEB should
be called before the commands to toss the mail, and the message areas
should not be purged on a regular basis.

If you decide you don't want to use the Web support anymore, just delete
the base directory and erase the HTM files in your D'Bridge directory
(or rename them). DBUTIL is smart enough not to run if those HTM files
do not exist. So if you stored Fidonet Web mail in C:\INETPUB\WWWROOT\FIDO,
then erase the entire C:\INETPUB\WWWROOT\FIDO directory.

The method I chose to generate Web mail allows you to maintain your
existing site, whether its a real small simple one or a very elaborate
complex website. Be warned that it is still a little "crude", but I plan to
eventually add support for replies.

For an example of D'Bridge on the Web, visit my website!




Version 2.74 - August 27th 2007
-------------------------------

This is a very minor release which corrects a few outstanding issues,
including very rare bugs that may pop up from time to time.

- The obvious problem in DBUTIL has been fixed; I'm sure you know what...

- "Enhanced Areafix" options are gone; the built-in Areafix in D'Bridge
  now supports handling %LIST and %RESCAN natively. Upon studying the logic
  a bit further I felt that having %LIST and %RESCAN support as an option
  just didn't make sense...

- Along with the above mentioned cleanup, under exceptionally rare
  circumstances any Areafix requests destined for the host system were
  not being processed correctly if the previous "Enhanced Areafix" support
  was enabled.

- Areafix messages destined for SOUPGATE are no longer processed if the
  SOUPGATE address is not defined properly in the INTERNET CONNECTIVITY
  screen *and* if that address already exists as part of the AKA's.

- A problem with dialup modem support being set up by the user and then
  removed in the same instance of D'Bridge causing the "Unable to
  initialize the modem" problem has been solved.

- SQUISH and JAM support are still being worked on despite what D'Bridge
  says in the setup screens.

- Some minor things in the mailer have been cleaned up; nothing really
  worth noting here.

Nick Andre
http://www.nickandre.com



Version 2.73 - August 15th 2007
-------------------------------

This is a minor release correcting some outstanding issues with 2.72 and
adds a few features with regards to how D'Bridge handles Internet USENET
groups via. external software. This release should "tide you over" until
the upcoming version 3 series.

On the subject of USENET, if you folks need a Usenet feed (and delivered
to you as regular Echomail), I can set you up directly from my system
at 1:229/426, via BINKD, FTP or D'Bridge-Over-Telnet.

- If a TELNET connection came in and another system was running an Auto-
  Update cycle, D'Bridge would corrupt the backup configuration files. This
  problem has been fixed in this release. This was a very, very rare and
  difficult bug to track down, and only happened on multi-line setups.

- A new "placeholder", *L, has been added to the BBS CONFIGURATION screen
  as well as the EVENT SCHEDULER. When *L is encountered by D'Bridge, it
  will replace *L with the number of the current "line" running, if MULTI
  LINE SUPPORT is enabled. If you are not running a multi-line setup, then
  the line number placeholder will always be set to 1.

- The DESCFILE function in DBUTIL has been corrected to properly
  account for justification when importing descriptions from text files.

- DBUTIL has been significantly rewritten to use a more "modular" approach
  in the way it runs, please test all features and report any problems
  accordingly.

- Various minor fixes and updates have been done to the Setup Wizard.

- D'Bridge now ships with PKZIP/PKUNZIP 2.50 instead of 2.04g. When the
  Setup Wizard installs D'Bridge for the first time, it will ask if you
  would also like to copy PKZIP/PKUNZIP to your operating system's directory
  as well, ie. C:\DOS or C:\WINDOWS, etc etc.

- The Areafix system in D'Bridge has been corrected and enhanced to support
  the automatic updating of the NEWSRC file in VSOUP for Windows and OS/2,
  and other products that support the NEWSRC file standard. If an Areafix
  request comes in that is destined for your NNTP/USENET GATEWAY address
  as defined in the INTERNET CONNECTIVITY SCREEN, D'Bridge will treat that
  request as either adding or removing areas in the NEWSRC file. So for
  example, lets say my USENET gateway is 1:229/9999:

  From: Nick Andre, 1:229/426
    To: Areafix, 1:229/9999
  Subj: MyPassword
  ---------------------------------------------------------
  ALT.BBS.RENEGADE
  ALT.WORSHIP.WARD-DOSSCHE
  -COMP.SYS.UNIX
  -TALK.POLITICS

  Would make D'Bridge do the following to NEWSRC:

  alt.bbs.renegade! 0           becomes     alt.bbs.renegade:
  alt.worship.ward-dossche! 0   becomes     alt.worship.ward-dossche:
  comp.sys.unix: 12000-13000    becomes     comp.sys.unix! 12000-13000
  talk.politics: 22312-25333    becomes     talk.politics! 22312-25333

  The NEWSRC "standard" is such that a colon (:) indicates that the gateway
  software is to download the group from your NNTP server or host. An
  exclaimation point/bang character (!) tells the software not to download.

  And so forth. Note that if you did not define a NNTP/USENET GATEWAY
  address, the NEWSRC auto-updating is disabled.

- The missing files and sample configurations for SOUPGATE are now shipped
  with this release for those of you who want to setup a more advanced
  configuration for EMAIL routing in D'Bridge and SOUPGATE.



D'Bridge 2.72 / May 15 2007
---------------------------

This minor release fixes the bug where D'Bridge crashes during
the "AutoUpdate" routine if MULTI-LINE SUPPORT is enabled. A new version
of DB2RG is also included for those of you running the Renegade BBS
software.


D'Bridge 2.71 / May 12 2007
---------------------------

This is a minor release which addresses several bugs, and adds one
new feature - the ability to run D'Bridge as a shell process.

This release was programmed mostly in-flight from Halifax to Toronto at 7AM
so no doubt there will be bugs here and there... please test accordingly.

Enjoy.

- D'Bridge can now co-incide with a Telnet server or other front-end, and
  be called as a shell process. All you need to do is create a dummy/
  semaphore file called LINExxx.OTL (short for "caller on-the-line"), and
  whenever D'Bridge starts, it will check to see if theres a caller on
  the line. This can be a "human" (BBS caller) or a Fido mail session.
  This is how D'Bridge can be used to run via. Telnet on Internet setups.

  When the call is completed, D'Bridge exits. NOTE THAT THE SEMAPHORE IS
  DELETED UPON EXIT. If D'Bridge is running from within a DOS batch file,
  the batch file must explicitly create the LINExxx.OTL file before
  firing up - ie. "echo Caller On-The-Line > C:\DB\LINE1.OTL"

  You must also enable MULTI-LINE SUPPORT if you're intending on running
  D'Bridge as a "Fidonet over Telnet" server AND you intend to serve
  more than one inbound or outbound Telnet connection at a time. Run one
  copy of D'Bridge as usual; this will be the "copy" of D'Bridge that runs
  normally so it can execute events and process mail. Other "lines" would
  be what is called as a shell process by your Telnet server.

  Lets take a look at the below batch file for an example.

  This is what I actually use on my Windows Server 2003 system which runs
  my BBS and my website. I'm using the Renegade BBS software and Zoob Telnet
  Server. I can handle up to 4 telnet connections at once; or 4 "lines" if
  you want to think of it that way. Line 5 is D'Bridge 2.71 running in its
  own window, 24 hours a day to run events and process mail. It also has a
  dialup modem connection to it, so if someone wants to connect via. dialup,
  they would reach my BBS on Line 5.

  Note that NETFOSS, by PC-Micro & Associates, is required for Zoob
  Telnet Server to run with D'Bridge. When you download NETFOSS, simply
  place NETCOM and NETFOSS into your D'Bridge directory, then place
  the NETFOSS.DLL file in your Windows directory, ie. C:\WINDOWS.

  When Zoob Telnet Server fires up, the window looks something like this:

  --------------------------------------------------
  LOG                                              |
  |                                                |
  |                                                |
  |                                                |
  | * Ready to accept connections on port 23...    |
  --------------------------------------------------
  |    Command to run: D:\DB-TEST\RUNDB.BAT %N %I  |
  | Startup directory: D:\DB-TEST                  |
  |    Drop file path: (blank)                     |
  --------------------------------------------------

  The other options in Zoob, such as "Minimize new windows", "Number of
  nodes" and so forth are up to you. However, the CREATE DROPFILE should
  be UNCHECKED (blank).

  The RUNDB.BAT file simply consists of:

  (start of RUNDB.BAT)
  CD \DB-TEST
  ECHO Caller On the line semaphore > LINE%1.OTL
  NETCOM /n%1
  NETFOSS /n%1 /h%2 db.exe /%1
  DEL LINE%1.OTL
  NETCOM /u
  EXIT
  (end of file)

  Note that the "/n" and "/h" are case sensitive, and its NETFOSS that
  executes D'Bridge as a shell process.

  With this method, you can now just focus on putting all your BBS-
  related stuff in the BBS CONFIGURATION window in D'Bridge, instead of
  writing complicated batch files to handle Telnet connections.

- A serious bug in the way that D'Bridge handles inbound connections has
  been fixed; with regards to CONNECT strings. This bug was probably in
  the code since the 1.58 days. Whenever D'Bridge can't figure out what
  baudrate the incoming connection is, it would disable loading any BBS
  software. I didn't see this problem until I wrote the new code to
  handle the above-mentioned Telnet connections. I think I remember
  seeing a post in the DBRIDGE echo a long time ago about this problem.
  I really don't understand why Chris wrote the code this way, and most
  BBS software I've seen will handle such condition okay anyway.

- The unlink security code in Areafix should be fixed in this release.

- The message editor 8000+ messages problem should be fixed.

- A cosmetic bug in the XMAIL CONTROL SCREEN has been fixed; with not
  being able to cycle through the available options for each archiver.




D'Bridge 2.70 - March 30 2007
-----------------------------

This is a very minor release which fixes the QUOTE INITIALS IN REPLIES
feature. Should be working okay now.



D'Bridge 2.69 - March 26 2007
-----------------------------

This is a somewhat major release as it fixes some serious bugs and
introduces some long-overdue features.

A lot of hard work has gone into this particular release. This version also
prepares your system database files for the upcoming Version 3 release due
sometime in April. Until then, this should "hold you over" for now.

- D'Bridge now supports remote-installation using VNC and Radmin
  from Famatech Solutions Inc.

- The "No Echomail available for your security level" major bug is fixed,
  and has been tested here on a few workstations. A lot of testing has
  been done to ensure this problem is not replicated on ANY system (the
  fix was tested on various operating systems)

- There is a new option to allow QUOTE INITIALS IN REPLIES - this allows
  the internal editor to put the initials of the original poster before
  the ">" symbol. This feature is shut off by default, including on
  upgrades. The new feature is located in the EDITOR OPTIONS screen.

- A new feature, ENHANCED AREAFIX SUPPORT has been added to PACKET/MAIL
  CONTROL screen to allow the support of %LIST and %RESCAN commands in
  the Areafix system. This feature is set to OFF if you are upgrading
  to this release; you will need to turn it on manually if and when you
  are ready to test it. Note that these features currently function
  exactly like the -L and -R subject-line commands.

  What that means is that if someone sends an Areafix request with
  a line that says "%RESCAN DBRIDGE", D'Bridge will rescan ALL areas and
  not just the DBRIDGE echo. This is due to a fundimental design flaw in
  the way the Areafix system was written - it does NOT support select-
  scanning of Echomail areas. To add this feature would require a massive
  rewrite of the existing code. That is not something I'm going to do
  at this time. However, the %LIST command works okay when you put %LIST
  on one line and Echomail areas on the others.

- D'Bridge is now smart enough to understand that %LIST and %RESCAN are
  not valid Echomail areas if ENHANCED AREAFIX is enabled. But, if its
  not turned on and you get those type of requests, they won't be
  processed and instead will be noted in the system log - a possible way
  to catch "abuse" or "pinging" of the system.

- The ENHANCED AREAFIX feature also supports the %HELP command.

- Although the SCHEDULER supports File Sharing and Echofile/TIC processing
  settings, these will not be offered until the Version 3 release.

- Problems with deleting messages in the internal editor and having
  the "message leafing" system mess up should all be fixed now.

- The problem of browsing non-sequential Fido messages and having the
  display/listing mess up in the internal editor should be fixed now.

- The PROCESS XMAIL master-override question has been moved to the XMAIL
  CONTROL screen where it belongs.

- The HUB/ADMINISTRATORS screen is gone forever in this release. I decided
  that its time for it to go, and that if theres problems with D'Bridge,
  that you folks will use due diligence in reporting problems, and I have
  been releasing fixes on a somewhat regular basis...

- The RESTART AFTER NODELIST COMPILE question is gone permanently, as
  nobody has reported anything about it, so I'm assuming its not needed. If
  it is, let me know ASAP; and I'll put it back in immediately. Note that
  this feature is effectively useless anyway; if you need to restart after
  a nodelist compile, you should set the "Auto-compile Nodelists" question
  to NO (in the NODELIST settings screen), and create an event that runs
  shortly before midnight that creates a DBRIDGE.FCN (or DBRIDGE.TCN)
  dummy/semaphore file, to force (or test) the nodelist for compiling.

- Anti-SPAM features/configuration is removed permanently, a much better
  system for anti-SPAM is planned for the future.

- The DBRIDGE.MSR file should be deleted if it exists. It's obsolete.

I hope you enjoy this release of D'Bridge. Please report all problems ASAP
as usual...

Nick Andre
http://www.nickandre.com




D'Bridge 2.68 - March 7 2007
----------------------------

This is a very minor release, but significant for those of you still
running 2.64 because I screwed up the export-code.

- Problems upgrading from 2.64 should be finally resolved, but please back
  up before upgrading just in case.

- DBUTIL MOVE now creates unique filenames when moving NETmail packets.

- DBUTIL PURGE should properly save bodies of messages when archiving mail.




D'Bridge 2.67 - February 24 2007
--------------------------------

This is a very minor release, designed to address some issues with DBUTIL.
Nonetheless, please back up prior to installing.

- Some minor bugs have been corrected in the PURGE code. I'm assuming its
  stable - I've yet to hear any complaints...

- "Bleed-thru" problems with purging should be resolved.

- The total message purge count is now properly reported.

- Message renumbering is back; use DBUTIL RENUM to renumber your message
  directories. You can specify an optional area, ie. DBUTIL RENUM FIDONEWS
  if you want. Renumbering the NETmail directory is NOT supported, however.
  It is recommended that the RENUM be called immediately following a PURGE.
  Note that the renumbering code is CPU intensive and may take awhile to
  finish for those of you with large Echomail configurations.

- The OTHER56K.MCF file has been slightly corrected for new installations.


D'Bridge 2.66 - February 9 2007
-------------------------------

This is a very minor release.

- Problems with upgrading and having the Echomail database lost should be
  corrected in this release. I've tested this with both 2.64 and 2.65.

- A minor bug in the way the AFIXCTRL directory works with Areafix has
  been corrected.



D'Bridge 2.65 - January 14, 2007
--------------------------------

This is a release designed to address several issues for those of you who
are Hubs or co-ordinators of large networks.

A lot of hard work has been done, specifically to DBUTIL. Several bugs have
also been corrected for ITN/IVM flag support and Areafix not allowing a
"master override" to security (ALT+N) to process requests. Please back up
accordingly and report any problems.

- A major bug has been fixed for ITN and IVM flag support in D'Bridge. The
  bug was in relation to outgoing calls.

- The logic behind the translation has been slightly adjusted. If the
  nodelist for the network has the IP address for the system in the phone
  number field already and NO flags like ITN or IVM, D'Bridge will NOT
  attempt to "call" that system, REGARDLESS of the ITM/IVM flag setting.
  You will need to manually specify the address of the system in the
  NODELIST CONFIGURATION screen in FLAG OVERRIDES. For example, if The
  Titanic Board does not have an ITN/IVM flag with its IP address but its
  already in the phone number field, you need to add an entry
  like "25:25/0 ttb.slyip.com" in the FLAG OVERRIDE screen.

  Note that the ITN/IVM flag translation requires this feature to be turned
  ON in the INTERNET CONNECTIVITY screen. It is off by default because most
  of you don't use it.

- Problems with the Areafix system not allowing overrides or instant-
  processing and turnaround should be fixed in this release.

- Stability issues with DBUTIL should be corrected in this release, in
  regards to MOVE-ing mail to directories.

- DBUTIL's message purging code has been COMPLETELY REWRITTEN from scratch,
  to finally attempt to put an end to all the problems that currently
  exist in purging mail. It should now purge mail much faster now,
  and displays a much more graphical progress. This should make it easier
  to diagnose any problems. The purge code also should not touch the
  date/time stamp of messages.

- DBUTIL should no longer choke on any message directory, but if it does,
  it now terminates gracefully and displays a debug screen that will aide
  in diagnosis.

- DBUTIL now reports which messages have grunged date headers as per Roger.

- DBUTIL will check to see if the DBUTIL.BSY flag is over an hour old, if
  so, it will execute anyway and remove that file. This is to prevent
  automated systems from being "stuck in limbo" because of an improper
  DBUTIL shutdown and the busy flag being left over.

  If you DO NOT want DBUTIL to function this way, create a dummy text file
  called DBUTIL.DRF (short for Don't Remove Flag file). If this file exists
  then DBUTIL will not execute if DBUTIL.BSY exists, no matter what
  scenario happens.

- You may now choose to view the hidden "kludge" information of messages
  by answering yes to the VIEW KLUDGES question in the EDITOR OPTIONS screen.
  Note that this only affects the internal message editor only. It has no
  effect for those of you running another message editor or a BBS.

- The internal message editor now correctly displays messages that are
  numbered higher than 8000. It will correctly display messages numbered
  high, up to 32767.

- TAGLINE SUPPORT is no longer enabled by default. You must manually turn
  on support in the EDITOR OPTIONS screen.

- The option to specify the maximum amount of messages able to be read by
  the internal message editor has been REMOVED.




D'Bridge 2.64 - December 29th 2006
----------------------------------

To wish everyone a happy new year, I whipped up this minor release to
finally give D'Bridge support for TAGLINES! (I'm also sick in bed with a
major cold thats going around)

Taglines are just cute "words of wisdom" appended at the end of each
message before the tear line, ie:

 ... Work fascinates me.  I can sit and watch it for hours.
 ... The Big Bang is only the universe rebooting.
 ... NO MESSAGES FOUND. [H]it modem. [S]cream at fido gods. [Y]ell profanity
 ... Death before dishonor, neither before breakfast.

You get the idea.

- You can now specify in the EDITOR OPTIONS screen, if you wish to have a
  tagline attached to each message you write in the internal message editor:

            YES - Append a tagline to all messages.
  ECHOMAIL ONLY - Append a tagline to Echomail messages only.
   NETMAIL ONLY - Append a tagline to NETmail messages only.
            ASK - Ask each time if its okay to add a tagline.
       DISABLED - Shuts off the tagline support.

  The default setting is ECHOMAIL ONLY - Taglines will be added only to
  messages in Echomail areas.

- The taglines are saved in a text file called DBTAGS.TXT that is read and
  indexed by D'Bridge upon starting the internal message editor. Feel free
  to modify this file to whatever you like.




D'Bridge 2.63 - December 29th 2006
----------------------------------

- Yet another minor release that properly imports the Internet settings
  and other stuff from earlier releases. This isn't actually done by
  D'Bridge itself; but by the D'Bridge Update Component (DBUPD) that is
  part of the Setup Wizard.

  Once this release is installed, all settings should be properly imported
  and exported from now on...

- The SAVE files created during the nightly AutoUpdate should be properly
  moved into DBCONFIG.ZIP instead of building up in the directory.

- As per the last release notes (incase you didnt bother to download 2.62),
  DBUTIL only works for the version of DB its released with, and the Setup
  Wizard does a rather thorough inspection of your setup before upgrading.




D'Bridge 2.62 - December 28th 2006
----------------------------------

- This is a very minor release of D'Bridge, with a correction to DBUTIL to
  attempt to solve the issue of old Echomail being scanned out after doing
  a PURGE. DBUTIL should no longer purge the "lastread" pointer file.

- The Setup Wizard now examines your entire configuration much more in
  detail before upgrading and warns you of any potential problems. You may
  also export the warnings to a text file if you prefer.




D'Bridge 2.61 - December 22nd 2006
----------------------------------

This is a minor release done to correct some issues with 2.60. Merry
Christmas everyone, as always, report all problems to me or post in
the DBRIDGE echo on Fidonet.

- The MSGID kludge is now a unique serial number generated from both the
  system date and time. No file is necessary to store this information.
  This should solve any problems with duplicate/unprocessed messages
  resulting from a miscalculated MSGID kludge.

- The Setup Wizard will remove the DBRIDGE.MSG file when upgrading to
  this release, as its no longer necessary.

- The Setup Wizard no longer temporarily unpacks files to drive C. It will
  unpack to whatever drive has read/write access, from C to Z. And obviously
  when finished, the temporary files are removed.

- Pretty sure that the EDITOR INSERT ON/OFF value is properly saved now.

- DBUTIL should no longer "run out of memory" on large systems with
  thousands of Echomail areas. However, the interactive-mode of DBUTIL will
  not show all of the areas - Only the first thousand. All of the commands
  including the CHANGE command will work properly on all areas regardless.






D'Bridge 2.6 - December 17th 2006
---------------------------------

WARNING: The format of the DBRIDGE.ADF database has CHANGED. Any 3rd-party
         utility which makes use of DBRIDGE.ADF will no longer work upon
         installing this version. Please use only the DBUTIL that is
         included in this release. Do NOT use any older version with this
         release otherwise strange and bizarre results WILL happen.

A lot of hard work has gone into this particular release. Please test all
features and report any problems ASAP.

- A critical stability flaw has been corrected in Areafix. The AREAFIX
  ENABLED option in PACKET/MAIL CONTROL has been enhanced so you can now
  set a limit on the amount of areas D'Bridge will process at a time in
  one Areafix request. There is also a new setting, MAX REQUESTS PER
  NODE PER DAY, to prevent "abuse" of Areafix privileges. So basically,
  no one system can request thousands of areas and tie up or crash your
  system entirely. The default value has been set to 50 areas per request
  with 3 requests per day. The maximum value this can be set to is 1024 and
  1024 requests per day.

- In addition to this enhancement, I have added several new lines of code
  in the Areafix system to check for valid requests, bogus entries, and
  other garbage that may potentially crash the system. But with new code
  comes possibly new problems, please report any strange or bizarre
  behavior of the Areafix system immediately.

- Tiny database files used to keep track of the daily Areafix limits are
  stored in the AFIXCTRL (Areafix control) directory off of your QUEUE path.
  These files begin with the S- prefix. They are erased every night at
  midnight during the AutoUpdate routine.

- D'Bridge now stores the M- files in the QUEUE directory instead of
  the AFIXCTRL directory, as it used to be. The Setup Wizard program will
  automatically move any such files back into the Queue directory when you
  upgrade to this release.

- D'Bridge should now be able to handle and process messages up to 32k
  in size as opposed to 16k. IF ANYONE REPORTS A BUG DUE TO THIS CHANGE, I
  WILL CHANGE IT BACK AND RELEASE A NEW VERSION IMMEDIATELY.

- D'Bridge now supports Internet EMAIL and USENET groups, and is now fully
  integrated with VSOUP and SOUPGATE. Support can be configured in the newly
  redesigned INTERNET CONNECTIVITY screen. These tiny programs now allow
  D'Bridge to fully support Internet E-Mail and USENET groups from the
  Internet. VSOUP/SOUPGATE is configured via the INTERNET CONNECTIVITY
  screen, just like BINKD. VSOUP and SOUPGATE now ship with D'Bridge to
  get you up and running with as little work as possible.

  Note that in this release, USENET group functionality will require a little
  more configuring, in the way of scheduled events which call the VSOUP
  and SOUPGATE programs manually. This release was done to "get the ball
  rolling" and you are more than welcome to contact me for further
  assistance regarding USENET configuration.

- Although I wrote in the help system that when the VSOUP/SOUPGATE address
  is specified D'Bridge will adjust the rest of the setup accordingly, THIS
  IS NOT THE CASE IN THIS VERSION. You will need to manually add whatever
  gateway address you've decided to use to all of your ROUTING in scheduled
  events, and the Forced Priorities and Areafix information screens
  in the PACKET/MAIL CONTROL menu.

- The internal message editor now fully supports Internet E-Mail addressing
  provided that the VSOUP/SOUPGATE information screen in INTERNET
  CONNECTIVITY is properly configured. The SOUPGATE program is auto-
  matically called during a Queuescan to "pack" Internet EMAIL messages
  for further processing by VSOUP. VSOUP is also automatically called to
  send and receive Internet mail.

- In the tradition of the "keep it simple" philosophy of D'Bridge, you can
  just read and reply to Internet EMAIL as you do Fidonet NETmail.

  That means, you DO NOT "address" the SOUPGATE software; D'Bridge takes
  care of that automatically. When you compose an Internet EMAIL message,
  you just type in the EMAIL address and away you go. For example if
  you want to send a message to John Doe at his Hotmail account, just type
  in his address, johndoe@hotmail.com. Gone forever are the days of having
  to address the gate as "UUCP", put "To:" in the body of the message, and
  other extra work. And when you receive replies, D'Bridge automatically
  translates them from SOUPGATE into "non-geek jargon", to keep things as
  seamless and integrated as possible.

- BINKD support will be disabled if you specify 0 (zero) as the BINKD PORT.

- BINKD must now be ran as a "server" process (ie. running it in another
  window on your operating system). For stability reasons D'Bridge no
  longer starts BINKD to send/receive mail in "client" mode.

- DBUTIL will NOT create a log file of any activity if you create
